#Include Once "vec4.bi"

Type frustum_t
	Declare Sub CreateFrustum(fovy As single, ratio As single, znear As single, zfar As Single)
	Declare Sub UpdateFrustum(cam As Camera3D)
	Declare Sub FrustumFast_CreatePerspective(fovy As single, aspect As single, znear As single, zfar As Single)
	Declare Function boxInFrustum( bmin As vector3,bmax As vector3) As boolean
	Declare Function planeWithPoints(a As vector3, b As vector3, c As vector3) As vec4
	Declare Sub RenderFrustum()

	plane(0 To 5) As vec4
	corner(0 To 7) As vector3
	As Single Hnear
	As Single Wnear
	As Single Hfar
	As Single Wfar
	As Single zfar
	As Single znear
	As Single ratio
	As Single fovy
End Type
sub frustum_t.CreateFrustum( fovy As single,ratio As single, znear As single,zfar As Single )
	#define ANG2RAD 3.14159265358979323846/180.0
	Dim tang As Single=tan(ANG2RAD * fovy * 0.5)
	'get sizes of the far/near planes
	Hnear = tang * znear
	Wnear = Hnear * ratio
	Hfar = tang * zfar
	Wfar = Hfar * ratio
	this.znear=znear
	this.zfar=zfar
	this.ratio=ratio
	this.fovy=fovy
	#Undef ang2rad
End Sub
Sub frustum_t.UpdateFrustum(cam As Camera3D)
	Dim As Matrix cm=GetCameraMatrix(cam)
	Dim p As vector3=vector3(cm.m3,cm.m7,cm.m11)
	'Dim As vector3 dira=cam.target'vector3subtract(cam.position,cam.target)
	'Dim As vector3 dira=vector3subtract(cam.position,cam.target)
	'Vector3Normalize(dira)
	'Dim As vector3 r=vector3crossproduct(cam.up,dira)
	' compute the Z axis of camera
	' This axis points in the opposite direction from
	' the looking direction
	'Dim As vector3 Z = Vector3Subtract(p,dira)
	Dim As vector3 Z = Vector3(cm.m2,cm.m6,cm.m10)
	'Dim As vector3 Z = vector3(c.d,c.h,c.l,0)
	'z=Vector3Normalize(Z)
	'z=Vector3negate(z)
	' X axis of camera with given "up" vector and Z axis
	'Dim As vector3 X = vector3crossproduct(cam.up,Z)
	Dim As vector3 X = vector3(cm.m0,cm.m4,cm.m8)
	'Dim As vector3 X = Vector3Multiply(cam.up , Z)
	'Dim As vector3 X = vector3(c.a,c.e,c.i,0)
	'x=Vector3Normalize(X)
	'x=Vector3negate(x)

	' the real "up" vector is the cross product of Z and X
	'Dim As vector3 Y = vector3crossproduct(Z,X)'Z * X
	Dim As vector3 Y = vector3(cm.m1,cm.m5,cm.m9)
	'Dim As vector3 Y = Vector3Multiply(Z , X)
	'Dim As vector3 Y = vector3(c.b,c.f,c.j,0)
  	'y=Vector3Normalize(Y)
	'y=Vector3negate(y)

	' compute the centers of the near and far planes
	Dim As vector3 nc = Vector3Subtract(p , Vector3Scale(Z , znear))
	Dim As vector3 fc = Vector3Subtract(p , Vector3Scale(Z , zfar))

	' compute the 4 corners of the frustum on the near plane
	corner(0) = Vector3Add(nc , Vector3Subtract(Vector3Scale(Y , hnear) , Vector3Scale(X , wnear)))
	corner(1) = Vector3Add(nc , Vector3Add		 (Vector3Scale(Y , hnear) , Vector3Scale(X , wnear)))
	corner(2) = Vector3Subtract(nc , Vector3Subtract(Vector3Scale(Y , hnear) , Vector3Scale(X , wnear)))
	corner(3) = Vector3Subtract(nc , Vector3Add		(Vector3Scale(Y , hnear) , Vector3Scale(X , wnear)))

	' compute the 4 corners of the frustum on the far plane
	corner(4) = Vector3Add(fc ,Vector3Subtract(Vector3Scale( Y , hfar ),  Vector3Scale(X , wfar)))
	corner(5) = Vector3Add(fc ,Vector3Add     (Vector3Scale( Y , hfar) , Vector3Scale( X , wfar)))
	corner(6) =  Vector3Subtract(fc , Vector3Subtract(Vector3Scale(Y , hfar) ,  Vector3Scale(X , wfar)))
	corner(7) =  Vector3Subtract(fc , Vector3Add     (Vector3Scale(Y , hfar) ,  Vector3Scale(X , wfar)))
'Print corner(0).x,corner(0).y,corner(0).z',corner(0).w
'Print corner(1).x,corner(1).y,corner(1).z',corner(1).w
'Print corner(2).x,corner(2).y,corner(2).z',corner(2).w
'Print corner(3).x,corner(3).y,corner(3).z',corner(3).w
'Sleep
	' compute the six planes
	' the function set3Points assumes that the points
	' are given in counter clockwise order
	plane(0)=planeWithPoints(corner(1),corner(0),corner(4))
	plane(1)=planeWithPoints(corner(2),corner(3),corner(7))
	plane(2)=planeWithPoints(corner(0),corner(2),corner(6))
	plane(3)=planeWithPoints(corner(3),corner(1),corner(7))
	plane(4)=planeWithPoints(corner(0),corner(1),corner(3))
	plane(5)=planeWithPoints(corner(5),corner(4),corner(6))


'// compute the 4 corners of the frustum on the near plane
'	ntl = nc + Y * nh - X * nw;
'	ntr = nc + Y * nh + X * nw;
'	nbl = nc - Y * nh - X * nw;
'	nbr = nc - Y * nh + X * nw;
'
'	// compute the 4 corners of the frustum on the far plane
'	ftl = fc + Y * fh - X * fw;
'	ftr = fc + Y * fh + X * fw;
'	fbl = fc - Y * fh - X * fw;
'	fbr = fc - Y * fh + X * fw;
'
'	// compute the six planes
'	// the function set3Points assumes that the points
'	// are given in counter clockwise order
'	pl[TOP].set3Points(ntr,ntl,ftl);
'	pl[BOTTOM].set3Points(nbl,nbr,fbr);
'	pl[LEFT].set3Points(ntl,nbl,fbl);
'	pl[RIGHT].set3Points(nbr,ntr,fbr);
'	pl[NEARP].set3Points(ntl,ntr,nbr);
'	pl[FARP].set3Points(ftr,ftl,fbl);
End Sub

'sub frustum_t.FrustumFast_CreatePerspective(fovy As single, aspect As single, znear As single, zfar As single)
'    Dim as Const single an = fovy * (3.141592653589f/180.0f)
'    Dim as Const single si = Sin(an)
'    Dim as Const single co = cos(an)
'    plane(0).x =  0.0f: plane(0).y = -co:      plane(0).z =  si:        plane(0).w =  0.0f
'    plane(1).x =  0.0f: plane(1).y =  co:      plane(1).z =  si:        plane(1).w =  0.0f
'    plane(2).x =  co:   plane(2).y =  0.0f:    plane(2).z =  si*aspect: plane(2).w =  0.0f
'    plane(3).x = -co:   plane(3).y =  0.0f:    plane(3).z =  si*aspect: plane(3).w =  0.0f
'    plane(4).x =  0.0f: plane(4).y =  0.0f:    plane(4).z =  1.0f:      plane(4).w =  zfar
'    plane(5).x =  0.0f: plane(5).y =  0.0f:    plane(5).z = -1.0f:      plane(5).w = -znear
'End Sub

'One simple solution to avoid this issue (or to make it less likely to happen) is to do an extra set of tests,
'by reversing the roles of the object and the frustum. 
'For that, we need our frustum struct/class to contain the 8 corner points as well in addition to the 6 planes that define it.
'Then we can perform frustum-in-box tests in the exact same way as we did box against frustum: 
'comparing the 8 vertices (of the frustum) against the 6 planes (of the box),
'and looking for an occurrence of a vertex being fully outside of any of the planes:

'false if fully outside, true if inside or intersects

Function frustum_t.boxInFrustum( bmin As vector3,bmax As vector3) As boolean
    ' check box outside/inside of frustum
    Dim As Long outa
    For i As ULong=0 To 5
     	'Print  (vec4(bmin.x, bmin.y, bmin.z,1.0)) 
        'outa = 0
        'outa += iif((dotv( plane(i), (vec4(bmin.x, bmin.y, bmin.z,1.0)) ) < 0.0 ),1,0) 
        'outa += IIf((dotv( plane(i), (vec4(bMax.X, bMin.Y, bMin.Z,1.0)) ) < 0.0 ),1,0)
        'outa += IIf((dotv( plane(i), (vec4(bMin.X, bMax.Y, bMin.Z,1.0)) ) < 0.0 ),1,0)
        'outa += IIf((dotv( plane(i), (vec4(bMax.X, bMax.Y, bMin.Z,1.0)) ) < 0.0 ),1,0)
        'outa += IIf((dotv( plane(i), (vec4(bMin.X, bMin.Y, bMax.Z,1.0)) ) < 0.0 ),1,0)
        'outa += IIf((dotv( plane(i), (vec4(bMax.X, bMin.Y, bMax.Z,1.0)) ) < 0.0 ),1,0)
        'outa += IIf((dotv( plane(i), (vec4(bMin.X, bMax.Y, bMax.Z,1.0)) ) < 0.0 ),1,0)
        'outa += IIf((dotv( plane(i), (vec4(bMax.X, bMax.Y, bMax.Z,1.0)) ) < 0.0 ),1,0)
        'Print plane(i)
        if((dotv( plane(i), (vec4(bmin.x, bmin.y, bmin.z,1.0)) ) < 0.0 )) And _ 
          ((dotv( plane(i), (vec4(bMax.X, bMin.Y, bMin.Z,1.0)) ) < 0.0 )) And _
          ((dotv( plane(i), (vec4(bMin.X, bMax.Y, bMin.Z,1.0)) ) < 0.0 )) And _
          ((dotv( plane(i), (vec4(bMax.X, bMax.Y, bMin.Z,1.0)) ) < 0.0 )) And _
          ((dotv( plane(i), (vec4(bMin.X, bMin.Y, bMax.Z,1.0)) ) < 0.0 )) And _
          ((dotv( plane(i), (vec4(bMax.X, bMin.Y, bMax.Z,1.0)) ) < 0.0 )) And _
          ((dotv( plane(i), (vec4(bMin.X, bMax.Y, bMax.Z,1.0)) ) < 0.0 )) And _
          ((dotv( plane(i), (vec4(bMax.X, bMax.Y, bMax.Z,1.0)) ) < 0.0 )) Then Return FALSE
        'Print outa
          'Print outa
        'If( outa=8 ) Then Return FALSE
    Next
'sleep

    ''// check frustum outside/inside box
    Outa=0: For i As ULong=0 To 7: outa += IIf((corner(i).x > bMax.X),1,0):Next:If( outa=8 ) then Return FALSE
    Outa=0: For i As ULong=0 To 7: outa += IIf((corner(i).x < bMin.X),1,0):Next:if( outa=8 ) then Return FALSE
    Outa=0: For i As ULong=0 To 7: outa += IIf((corner(i).y > bMax.Y),1,0):Next:If( outa=8 ) then Return FALSE
    outa=0: for i As ULong=0 To 7: outa += IIf((corner(i).y < bMin.Y),1,0):Next:If( outa=8 ) then Return FALSE
    Outa=0: For i As ULong=0 To 7: outa += IIf((corner(i).z > bMax.Z),1,0):Next:If( outa=8 ) then Return FALSE
    outa=0: For i As uLong=0 To 7: outa += iif((corner(i).z < bMin.Z),1,0):Next:If( outa=8 ) then Return FALSE

    return TRUE
End Function
Function frustum_t.planeWithPoints(a As vector3, b As vector3, c As vector3) As vec4
  '  'Dim As single A1 = (a.y * (b.z - c.z)) + (b.y * (c.z - a.z)) + (c.y * (a.z - b.z))
  '  'Dim As single B1 = (a.z * (b.x - c.x)) + (b.z * (c.x - a.x)) + (c.z * (a.x - b.x))
  '  'Dim As single C1 = (a.x * (b.y - c.y)) + (b.x * (c.y - a.y)) + (c.x * (a.y - b.y))
  '  'Dim As single D1 = -(a.x * ((b.y * c.z) - (c.y * b.z)) + b.x * ((c.y * a.z) - (a.y * c.z)) + c.x * ((a.y * b.z) - (b.y * a.z)))
    '
    'Dim As single A1 = (a.y * (b.z - c.z)) + (b.y * (c.z - a.z)) + (c.y * (a.z - b.z))
    'Dim As single B1 = (a.z * (b.x - c.x)) + (b.z * (c.x - a.x)) + (c.z * (a.x - b.x))
    'Dim As single C1 = (a.x * (b.y - c.y)) + (b.x * (c.y - a.y)) + (c.x * (a.y - b.y))
    'Dim As single D1 = -(a.x * ((b.y * c.z) - (c.y * b.z)) + b.x * ((c.y * a.z) - (a.y * c.z)) + c.x * ((a.y * b.z) - (b.y * a.z)))
'' 	planenormal	
 	'Dim As single nf = 1.0f / sqr(A1 * A1 + B1 * B1 + C1 * C1)
  'Print vec4(nf * A1,nf * B1,nf * C1,nf * D1)
   'Return vec4(nf * A1,nf * B1,nf * C1,nf * D1)
   
      Dim As vector3 Normal1 = vector3Crossproduct(vector3subtract(b , a),vector3subtract( c , a))'vector3Normalize(vector3Crossproduct(vector3subtract(b , a),vector3subtract( c , a)))
    
    Dim As vector3 NormalizedNormal = vector3Normalize(Normal1)
    Dim As single a1 = NormalizedNormal.x
    Dim As Single b1 = NormalizedNormal.y
    Dim As Single c1 = NormalizedNormal.z
    Dim As Single d1 = -Vector3DotProduct(a, NormalizedNormal)
   'Print vec4(A1,B1,C1,D1)
   Return vec4(A1,B1,C1,D1)
End Function
Sub frustum_t.RenderFrustum()
    'glBegin(GL_LINES)
    for i As ULong= 0 To 7
        for j As ulong = 0 To 7
            if (i = j) Then Continue For
            dim As vector3 a=vector3negate(corner(i))
            dim As vector3 b=vector3negate(corner(j))
            DrawLine3D(a,b,MAROON)
'            glVertex3f(corner(i).x, corner(i).y, corner(i).z)
 '           glVertex3f(corner(j).x, corner(j).y, corner(j).z)
        Next
    Next
    'glEnd()
End Sub