#Include "fbgfx.bi"
#Include "math.bi"
#Include Once "Inc\sGUI\sGUI.bas"
#include once "Inc\sGUI\ScrollBar.bas"
#include once "Inc\sGUI\SimpleGadget.bas"

Using FB
Using sGUI
Const as integer scrW = 1366, scrH = 768

ScreenRes scrW,scrH,32,,GFX_ALPHA_PRIMITIVES
InitGFX(0)

Dim Shared As EventHandle Ptr event
event=New EventHandle
Dim Shared As Integer minimum_bs,maximum_bs,minimum_bo,maximum_bo,pagesize,minimum_arms,maximum_arms
Dim Shared As Single minimum_k,maximum_k,minimum_p,maximum_p

minimum_bs=1
maximum_bs=127
minimum_bo=0
maximum_bo=32
minimum_k=35
maximum_k=100
minimum_p=5
maximum_p=15
minimum_arms=1
maximum_arms=9
pagesize=1
Dim Shared As Gadget Ptr ScrollBulgeSize
Dim Shared As Gadget Ptr ScrollBulgeOffset
Dim Shared As Gadget Ptr ScrollSpiralK
Dim Shared As Gadget Ptr ScrollSpiralP
Dim Shared As Gadget Ptr ScrollSpiralArms
Dim Shared As Gadget Ptr ScrollBulgeHeight
Dim Shared As Gadget Ptr FlyButton
FlyButton=AddSimpleGadget(event,166,scrH-150+122,170,20,"Generate and Fly")

ScrollBulgeSize= AddScrollBar(event,150,scrH-150+0,200,minimum_bs,maximum_bs,1,pagesize,0)
SetScrolLBarVal(ScrollBulgeSize,320)
ScrollBulgeOffset= AddScrollBar(event,150,scrH-150+20,200,minimum_bo,maximum_bo,0,pagesize,0)
SetScrolLBarVal(ScrollBulgeoffset,0)
ScrollSpiralK= AddScrollBar(event,150,scrH-150+60,200,minimum_k,maximum_k,1,pagesize,0)
SetScrolLBarVal(ScrollSpiralK,35)
ScrollSpiralP= AddScrollBar(event,150,scrH-150+80,200,minimum_p,maximum_p,1,pagesize,0)
SetScrolLBarVal(ScrollSpiralP,5)
ScrollSpiralArms= AddScrollBar(event,150,scrH-150+100,200,minimum_arms,maximum_arms,1,pagesize,0)
SetScrolLBarVal(ScrollSpiralArms,1)
ScrollBulgeHeight= AddScrollBar(event,150,scrH-150+40,200,1.0,40.0,1,pagesize,0)
SetScrolLBarVal(ScrollBulgeHeight,20)
GadgetOn(ScrollBulgeSize)
GadgetOn(ScrollBulgeHeight)
GadgetOn(ScrollBulgeOffset)
GadgetOn(ScrollSpiralK)
GadgetOn(ScrollSpiralP)
GadgetOn(ScrollSpiralArms)
GadgetOn(FlyButton)

Type system_t
	Declare Constructor()
	Declare Constructor(x As Integer,y As Integer,z As integer)
	Declare Destructor()
	nr_stars As Integer
End Type
Constructor system_t()
nr_stars=Int(Rnd*3)
End Constructor
Constructor system_t(x As Integer,y As Integer,z As integer)
nr_stars=Int(Rnd*3)
End Constructor
Destructor system_t()

End Destructor



Type system_map'holds the systems,each is a 3*3*3 cube
	Declare Constructor()
	Declare Constructor(x As Integer,y As Integer,z As integer)
	Declare Destructor()
	systems As system_t Ptr Ptr Ptr
End Type
Constructor system_map()
systems=New system_t Ptr Ptr[3]
For i As Integer=0 To 2
	systems[i]=New system_t Ptr[3]
	For j As Integer=0 To 2
		systems[i][j]=New system_t[3]
	Next
Next
End Constructor
Constructor system_map(x As Integer,y As Integer,z As integer)
systems=New system_t Ptr Ptr[3]
For i As Integer=0 To 2
	systems[i]=New system_t Ptr[3]
	For j As Integer=0 To 2
		systems[i][j]=New system_t[3]
	Next
Next
End Constructor
Destructor system_map()
For i As Integer=0 To 2
	For j As Integer=0 To 2
		Delete [] Systems[i][j]
	Next
	Delete [] systems[i]
Next
Delete [] systems
End Destructor



Type galaxy_t
	Declare Constructor(xysize As Integer,zsize As integer)
	Declare Destructor()
	Declare Sub regenerate()
	sectors As system_map Ptr Ptr Ptr 'holds the entire galaxy, it is a x*y*z cubeoid
	xy_size As Integer
	z_size As Integer
	mapa As Short Ptr Ptr Ptr
End Type
Constructor galaxy_t(xysize As Integer,zsize As integer)
sectors=New system_map Ptr Ptr[xysize]
For i As Integer=0 To xysize-1
	sectors[i]=New system_map Ptr[xysize]
	For j As Integer=0 To xysize-1
		sectors[i][j]=New system_map[zsize]
	Next
Next
xy_size=xysize
z_size=zsize


mapa=New short Ptr Ptr[xy_size]
For x As UInteger=0 To xy_size-1
	mapa[x]=New Short Ptr[xy_size]
	For y As UInteger=0 To xy_size-1
		mapa[x][y]=New Short[z_size]
	Next
Next
End Constructor
Destructor galaxy_t()
For i As Integer=0 To xy_size-1
	For j As Integer=0 To xy_size-1
		Delete [] sectors[i][j]
	Next
	Delete [] sectors[i]
Next
Delete [] sectors
xy_size=0
z_size=0
End Destructor
Sub galaxy_t.regenerate()
	For x As UInteger=0 To xy_size-1
		For y As UInteger=0 To xy_size-1
			For z As UInteger=0 To z_size-1
				'Line(x*8+z*32*8,y*8)-(x*8+8,y*8+8),RGBA(g->mapa[x][y][z],g->mapa[x][y][z],g->mapa[x][y][z],128),BF
				mapa[x][y][z]=0
			Next
		Next
	Next
	'Dim mapa As UByte Ptr Ptr Ptr
	'mapa=New UByte Ptr Ptr[xy_size]
	'For x As UInteger=0 To xy_size-1
	'	mapa[x]=New UByte Ptr[xy_size]
	'	For y As UInteger=0 To xy_size-1
	'		mapa[x][y]=New UByte[z_size]
	'	Next
	'Next
	'seed=Timer*1000
	'epoch=Timer*1000
	Randomize timer
	'xy_size=xysize
	Dim nr_arms As Integer=GetScrollBarVal(ScrollSpiralArms)
	'yp=xy_size\3
	'xp=xy_size\3

	'clear_systems()
	Dim x As double
	Dim y As Double
	Dim z As Double
	Dim x1 As integer
	Dim y1 As Integer
	Dim z1 As Integer
	For j As UInteger=0 To 360-360/nr_arms Step 360/nr_arms
		'count+=1
		For i As Single=0 To 1440 Step 1
			Dim As Single k=GetScrollBarVal(ScrollSpiralK)/10.0
			Dim As Single p=GetScrollBarVal(ScrollSpiralP)/10.0
			Dim r1 As Single=(((i^2)/(k/p)^4))
			If r1>=0.70 Then Exit For
			y=0
			x=0
			z=0
			For s As Single=0 To sigmoid(map(r1,0,10,0,-16),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*16 Step 1'nr_arms
				x=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10'
				z=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10'
				y=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10
				z1=((z*(z_size/2)+(z_size/2)))' Mod (z_size)
				x1=(Sin((i+j)*degToRad)*r1*(xy_size/2)+(xy_size/2)+x*2)' Mod (xy_size)
				y1=(Cos((i+j)*degToRad)*r1*(xy_size/2)+(xy_size/2)+y*2)' Mod (xy_size)
				If z1>=0 And z1<z_size Then
					If y1>0 And y1<xy_size Then
						If x1>0 And x1<xy_size Then
							If mapa[x1][y1][z1]<256-1 Then
							mapa[x1][y1][z1]+=1
							EndIf
						EndIf
					EndIf
				EndIf
				'Print x1,y1,z1
				'galaxy_tmp->vertices->Add( New vec4( p1.x, p1.y, p1.z ) )
				For s1 As single=0 To (sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 ))*16 Step 1'nr_arms
					x=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10'
					z=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10'
					y=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10
					z1+=z'*2
					x1+=x'*2
					y1+=y'*2
					x1=(x1)' Mod (xy_size)
					y1=(y1)' Mod (xy_size)
					z1=(z1)' Mod (z_size)
					'Print x1,y1,z1
					If z1>=0 And z1<z_size Then
						If y1>0 And y1<xy_size Then
							If x1>0 And x1<xy_size Then
							If mapa[x1][y1][z1]<256-1 Then
							mapa[x1][y1][z1]+=1
							EndIf
							EndIf
						EndIf
					EndIf
					'					drawPoint3d(cam,vec4( p1.x, 0, p1.z ),sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*320.0,c)
					'					count+=1
					'pset(x1+z1*64,y1),RGBA(mapa[x1][y1][z1],mapa[x1][y1][z1],mapa[x1][y1][z1],127)
				Next
			Next
		Next
	Next

	'sleep
	'For i As UInteger=0 To xysize-1
	'	For j As UInteger=0 To xysize-1
	'		generate_systems(i,j,map[i][j] Shr 24)
	'	Next
	'Next
	'If map<>0 Then
	'	For i As UInteger=0 To xysize-1
	'		DeAllocate(map[i])
	'		map[i]=0
	'	Next
	'	DeAllocate(map)
	'	map=0
	'EndIf
	'For x As UInteger=0 To xy_size-1
	'	For y As UInteger=0 To xy_size-1
	'		For z As UInteger=0 To z_size-1
	'			'line(x*8,y*8)-(x*8+8,y*8+8),RGBA(mapa[x][y][z],mapa[x][y][z],mapa[x][y][z],128),BF
	'			pset(x*(1/z)*8,y*(1/z)*8),RGBA(mapa[x][y][z],mapa[x][y][z],mapa[x][y][z],32)
	'		Next
	'	Next
	'Next




	'For x As UInteger=0 To xy_size-1
	'	For y As UInteger=0 To xy_size-1
	'		Delete [] mapa[x][y]
	'	Next
	'	Delete [] mapa[x]
	'Next
	'Delete [] mapa
End Sub





Dim g As galaxy_t ptr=New galaxy_t(128,9)
g->regenerate()
While Not MultiKey(SC_ESCAPE)
	Line(0,0)-(scrW,scrH),0,BF
	Line(0,0)-(g->xy_size,g->xy_size),RGBA(0,255,0,255),B
	For x As UInteger=0 To g->xy_size-1
		For y As UInteger=0 To g->xy_size-1
			For z As UInteger=0 To g->z_size-1
				pset(x+z*g->xy_size,y),RGBA(g->mapa[x][y][z],g->mapa[x][y][z],g->mapa[x][y][z],127)
			Next
		Next
	Next
	event->xSleep(-1)
	if event->GADGETMESSAGE then
		select case event->GADGETMESSAGE
			case ScrollBulgeSize
				g->regenerate()
			case ScrollBulgeHeight
				g->regenerate()
			Case ScrollBulgeOffset
				g->regenerate()
			Case ScrollSpiralK
				g->regenerate()
			Case ScrollSpiralP
				g->regenerate()
			Case ScrollSpiralArms
				g->regenerate()
				'				play=Not(play)
				'				 print "Scrollbereich:" & minimum & "-" & maximum & " @ Pagesize " & pagesize & ": " & GetScrollBarVal(Scroll)
		end select
	end If
Wend
'For x As UInteger=0 To g->x_size-1
'	For y As UInteger=0 To g->y_size-1
'		For z As UInteger=0 To g->z_size-1
'			Draw String (x*8,y*8),"*",&h33333333
'		Next
'	Next
'Next

Sleep
end



