'' CreateQuad:TMesh(r:Int = 255, g:Int = 255, b:Int = 255, a:Float = 1.0, fx:Int = 0)
'' CreateSegCube:TMesh(segs:Int = 1, parent:TEntity = Null)
'' CreateSpherePart:TMesh(segments:Int,parent:TEntity=Null,start_pitch:Float=-90.0,end_pitch:Float=90.0,start_yaw:Float=-180.0,end_yaw:Float=180.0,radius:Float=1.0,multi1:Float=2.0,multi2:Float=0.5)
'' CreateRing:TMesh(parent:TEntity = Null, segments:Int = 360, r1:Float, r2:Float, fx:Int = 1 + 16, r:Int = 255, g:Int = 255, b:Int = 255, a:Float = 1.0)
'' UpdateRing(mesh:TMesh, segments:Int = 360, r1:Float, r2:Float, fx:Int = 1 + 16, r:Int = 255, g:Int = 255, b:Int = 255, a:Float = 1.0)
'
'' ----------------------------------------------------------------------------
'' Creates a Quad
'' ----------------------------------------------------------------------------
'Function CreateQuad:TMesh(r:Int = 255, g:Int = 255, b:Int = 255, a:Float = 1.0, fx:Int = 0)
'
'	 v1:Int, v2:Int, v3:Int, v4:Int
'
'	 mesh:TMesh = CreateMesh()
'	 surf:TSurface = CreateSurface(mesh)
'
'	v1 = AddVertex(surf, -0.5, 0.5, 0.0, 1.0, 0.0)
'	v2 = AddVertex(surf, 0.5, 0.5, 0.0, 0.0, 0.0)
'	v3 = AddVertex(surf, -0.5, -0.5, 0.0, 1.0, 1.0)
'	v4 = AddVertex(surf, 0.5, -0.5, 0.0, 0.0, 1.0)
'
'	VertexColor surf, v1, r, g, b, a
'	VertexColor surf, v3, r, g, b, a
'	VertexColor surf, v2, r, g, b, a
'	VertexColor surf, v4, r, g, b, a
'
'	AddTriangle(surf, 0, 1, 2)
'	AddTriangle(surf, 3, 2, 1)
'
'	EntityFX mesh, fx
'
'	Return mesh
'
'End Function
'
'
'
'' ----------------------------------------------------------------------------
'' Creates a Patch
'' ----------------------------------------------------------------------------
'Function CreatePatch:TMesh(Size:Int)
'
'	 x:Int, z:Int, v:Float, u:Float, v0:Int, v1:Int, v2:Int, v3:Int
'	 VertexBuffer:Int[129, 129]
'
'	' Create Mesh And surface
'	 mesh:Tmesh = CreateMesh()
'	 surf:Tsurface = CreateSurface(mesh)
'
'	For z = 0 To size
'
'		For x = 0 To size
'
'			' calculate uv coordinates that the texture fits To the tile
'			u = x * 1.0 / size
'			v = z * 1.0 / size * -1
'
'			' set vertexposition
'			VertexBuffer[x, z] = AddVertex (surf, -((Size) / 2.0) + x, 0.0, -((Size) / 2.0) + z, u, v)
'
'		Next
'
'	Next
'
'	' set triangles
'	For z = 0 To size - 1
'
'		For x = 0 To size - 1
'
'			v0 = VertexBuffer[x, z]
'			v1 = VertexBuffer[x + 1, z]
'			v2 = VertexBuffer[x + 1, z + 1]
'			v3 = VertexBuffer[x, z + 1]
'
'			AddTriangle (surf, v0, v2, v1)
'			AddTriangle (surf, v0, v3, v2)
'
'		Next
'
'	Next
'
'	FitMesh(mesh, -0.5, 0, -0.5, 1, 0, 1, 1)
'
'	UpdateNormals(mesh)
'
'	VertexBuffer = Null
'
'	Return mesh
'
'End Function

' ----------------------------------------------------------------------------
' Creates a Geo Spehere
' ----------------------------------------------------------------------------
Declare sub GEOsub( S As Any ptr, v1 As uinteger, v2 As UInteger, v3 As uinteger, Detail As uinteger)

Function GEOcreate( Detail As Integer=1, Parent As Any Ptr = 0 ) As Any ptr
	If Detail>5 Then Detail=5
	If Detail<0 Then Detail=0
	Dim As Any Ptr Mesh = CreateMesh( Parent )
	Dim As Any Ptr S = CreateSurface( Mesh )
	Dim As Double a=2.0/(1.0+Sqr(5.0))
	Dim As Double b=1.0/Sqr((3.0+Sqr(5.0)) / (1.0+Sqr(5.0)))
	Dim As Double lon,lat
	Dim As Double ro, phi,r,x,y,z
	Dim As UInteger v01=AddVertex(S,  0,  a,  b,lon,lat,0)
	Dim As UInteger v02=AddVertex(S,  0,  a, -b,lon,lat,0)
	Dim As UInteger v03=AddVertex(S,  0, -a,  b,lon,lat,0)
	Dim As UInteger v04=AddVertex(S,  0, -a, -b,lon,lat,0)
	Dim As UInteger v05=AddVertex(S,  a,  b,  0,lon,lat,0)
	Dim As UInteger v06=AddVertex(S,  a, -b,  0,lon,lat,0)
	Dim As UInteger v07=AddVertex(S, -a,  b,  0,lon,lat,0)
	Dim As UInteger v08=AddVertex(S, -a, -b,  0,lon,lat,0)
	Dim As UInteger v09=AddVertex(S,  b,  0,  a,lon,lat,0)
	Dim As UInteger v10=AddVertex(S,  b,  0, -a,lon,lat,0)
	Dim As UInteger v11=AddVertex(S, -b,  0,  a,lon,lat,0)
	Dim As UInteger v12=AddVertex(S, -b,  0, -a,lon,lat,0)

	VertexNormal(S,v01,0,a,b)
	VertexNormal(S,v02,0,a,-b)
	VertexNormal(S,v03,0,-a,b)
	VertexNormal(S,v04,0,-a,-b)
	VertexNormal(S,v05,a,b,0)
	VertexNormal(S,v06,a,-b,0)
	VertexNormal(S,v07,-a,b,0)
	VertexNormal(S,v08,-a,-b,0)
	VertexNormal(S,v09,b,0,a)
	VertexNormal(S,v10,b,0,-a)
	VertexNormal(S,v11,-b,0,a)
	VertexNormal(S,v12,-b,0,-a)

	For i As UInteger=0 To 11
		x=VertexX(S,i)
		y=VertexY(S,i)
		z=VertexZ(S,i)
		r=Sqr(x*x+y*y+z*z)
		lon = (ATan2(y,x)/3.0+M_PI)/(2*M_PI)
		lat = ((ACos(z/r)/6.0+M_PI/2)/M_PI+0.5)
		If lon>1 Then lon-=1.0
		If lat>1 Then lat-=1.0
		If lon<0 Then lon+=1.0
		If lat<0 Then lat+=1.0
		VertexTexCoords(S,i,lon,lat)
		VertexColor(S,i,x*255,y*255,z*255)
	Next

	GEOsub( S, v02,v05,v07,Detail )
	GEOsub( S, v01,v07,v05,Detail )
	GEOsub( S, v01,v03,v11,Detail )
	GEOsub( S, v01,v09,v03,Detail )
	GEOsub( S, v02,v04,v10,Detail )
	GEOsub( S, v02,v12,v04,Detail )
	GEOsub( S, v03,v06,v08,Detail )
	GEOsub( S, v04,v08,v06,Detail )
	GEOsub( S, v07,v11,v12,Detail )
	GEOsub( S, v08,v12,v11,Detail )
	GEOsub( S, v05,v10,v09,Detail )
	GEOsub( S, v06,v09,v10,Detail )
	GEOsub( S, v01,v11,v07,Detail )
	GEOsub( S, v01,v05,v09,Detail )
	GEOsub( S, v02,v07,v12,Detail )
	GEOsub( S, v02,v10,v05,Detail )
	GEOsub( S, v04,v12,v08,Detail )
	GEOsub( S, v04,v06,v10,Detail )
	GEOsub( S, v03,v08,v11,Detail )
	GEOsub( S, v03,v09,v06,Detail )

	If Detail=0 Then flipmesh mesh
	Return mesh
End Function

'================================================================================
'================================================================================
'================================================================================

Sub GEOsub( S As Any ptr, v1 As uinteger, v2 As UInteger, v3 As uinteger, Detail As UInteger )
	Dim As double nx,ny,nz,l,lon,lat,ro,phi,r

	If Detail > 0 then
		nx=(VertexX(S,v1)+VertexX(S,v2))/2
		ny=(VertexY(S,v1)+VertexY(S,v2))/2
		nz=(VertexZ(S,v1)+VertexZ(S,v2))/2
		l=Sqr(nx*nx+ny*ny+nz*nz)
		If l<=0.000001 then l=1
		lon = (ATan2(ny,nx)+M_PI)/(2*M_PI):lat = (ACos(nz)+M_PI/2)/M_PI+0.5
		If lon>1 Then lon-=1.0
		If lat>1 Then lat-=1.0
		If lon<0 Then lon+=1.0
		If lat<0 Then lat+=1.0
		Dim As UInteger n1=AddVertex(S,nx/l,ny/l,nz/l,lon,lat,0)
		VertexNormal(S,n1,nx/l,ny/l,nz/l)
		'VertexColor(S,n1,1,1,1)
		nx=(VertexX(S,v2)+VertexX(S,v3))/2
		ny=(VertexY(S,v2)+VertexY(S,v3))/2
		nz=(VertexZ(S,v2)+VertexZ(S,v3))/2
		l=Sqr(nx*nx+ny*ny+nz*nz)
		If l<=0.000001 then l=1
		lon = (ATan2(ny,nx)+M_PI)/(2*M_PI):lat = (ACos(nz)+M_PI/2)/M_PI+0.5
		If lon>1 Then lon-=1.0
		If lat>1 Then lat-=1.0
		If lon<0 Then lon+=1.0
		If lat<0 Then lat+=1.0
		Dim As UInteger n2=AddVertex(S,nx/l,ny/l,nz/l,lon,lat,0)
		VertexNormal(S,n2,nx/l,ny/l,nz/l)
		nx=(VertexX(S,v3)+VertexX(S,v1))/2
		ny=(VertexY(S,v3)+VertexY(S,v1))/2
		nz=(VertexZ(S,v3)+VertexZ(S,v1))/2
		l=Sqr(nx*nx+ny*ny+nz*nz)
		If l<=0.000001 then l=1
		lon = (ATan2(ny,nx)+M_PI)/(2*M_PI):lat = (ACos(nz)+M_PI/2)/M_PI+0.5
		If lon>1 Then lon-=1.0
		If lat>1 Then lat-=1.0
		If lon<0 Then lon+=1.0
		If lat<0 Then lat+=1.0
		Dim As UInteger n3=AddVertex(S,nx/l,ny/l,nz/l,lon,lat,0)
		VertexNormal(S,n3,nx/l,ny/l,nz/l)
		GEOsub( S, v1,n3,n1,Detail-1)
		GEOsub( S, v2,n1,n2,Detail-1)
		GEOsub( S, v3,n2,n3,Detail-1)
		GEOsub( S, n3,n2,n1,Detail-1)
	Else
		nx=VertexX(S,v1)
		ny=VertexY(S,v1)
		nz=VertexZ(S,v1)
		l=Sqr(nx*nx+ny*ny+nz*nz)
		If l<=0.000001 then l=1
		lon = (ATan2(ny,nx)+M_PI)/(2*M_PI):lat = (ACos(nz/l)+M_PI/2)/M_PI+0.5
		If lon>1 Then lon-=1.0
		If lat>1 Then lat-=1.0
		If lon<0 Then lon+=1.0
		If lat<0 Then lat+=1.0
		VertexTexCoords(S,v1,lon,lat)
		nx=VertexX(S,v2)
		ny=VertexY(S,v2)
		nz=VertexZ(S,v2)
		l=Sqr(nx*nx+ny*ny+nz*nz)
		If l<=0.000001 then l=1
		lon = (ATan2(ny,nx)+M_PI)/(2*M_PI):lat = (ACos(nz/l)+M_PI/2)/M_PI+0.5
		If lon>1 Then lon-=1.0
		If lat>1 Then lat-=1.0
		If lon<0 Then lon+=1.0
		If lat<0 Then lat+=1.0
		VertexTexCoords(S,v2,lon,lat)
		nx=VertexX(S,v3)
		ny=VertexY(S,v3)
		nz=VertexZ(S,v3)
		l=Sqr(nx*nx+ny*ny+nz*nz)
		If l<=0.000001 then l=1
		lon = (ATan2(ny,nx)+M_PI)/(2*M_PI):lat = (ACos(nz/l)+M_PI/2)/M_PI+0.5
		If lon>1 Then lon-=1.0
		If lat>1 Then lat-=1.0
		If lon<0 Then lon+=1.0
		If lat<0 Then lat+=1.0
		VertexTexCoords(S,v3,lon,lat)

		AddTriangle(S,v1,v2,v3)
	End If

End sub



' ----------------------------------------------------------------------------
' Creates a spherized Cube
' ----------------------------------------------------------------------------
Function CreateCubeSphere(segments As Integer, mode As Integer = 0,texture_mode as Integer = 1) As Any ptr
	If segments>255 Then segments=255
	If segments<1 Then segments=1
	If mode<0 Then mode=0
	If mode>1 Then mode=1
	If texture_mode<0 Then texture_mode=0
	If texture_mode>2 Then texture_mode=2

	Dim As Integer s
	Dim As Integer x,y
	Dim As single vx, vy, vz
	Dim As single magnitude
	Dim As single  vertx, verty, vertz
	Dim As integer vertex

	Dim As Any Ptr mesh = CreateMesh()
	Dim As Any Ptr surf
	Dim As Single u,v

	For s = 1 To 6
		surf = CreateSurface(mesh)
		For y = 0 To segments
			For x = 0 To segments
				Select Case s
					Case 1:
						vx = x - segments / 2
						vy = segments / 2
						vz = segments / 2 - y
					Case 2:
						vx = x - segments / 2
						vy = segments / 2 - y
						vz = -segments / 2
					Case 3:
						vx = x - segments / 2
						vy = -segments / 2
						vz = y - segments / 2
					Case 4:
						vx = -segments / 2
						vy = segments / 2 - y
						vz = segments / 2 - x
					Case 5:
						vx = segments / 2
						vy = segments / 2 - y
						vz = x - segments / 2
					Case 6:
						vx = segments / 2 - x
						vy = segments / 2 - y
						vz = segments / 2
				End Select

				If mode = 0 Then
					magnitude = Sqr(vx * vx + vy * vy + vz * vz)
					If magnitude<0.000001 Then magnitude=0.000001

					vertx = vx / magnitude
					verty = vy / magnitude
					vertz = vz / magnitude
				Else
					vx = vx / segments * 2
					vy = vy / segments * 2
					vz = vz / segments * 2

					vertx = vx * Sqr(1.0 - (vy * vy) / 2.0 - (vz * vz) / 2.0 + ((vy * vy) * (vz * vz) / 3.0))
					verty = vy * Sqr(1.0 - (vz * vz) / 2.0 - (vx * vx) / 2.0 + ((vz * vz) * (vx * vx) / 3.0))
					vertz = vz * Sqr(1.0 - (vx * vx) / 2.0 - (vy * vy) / 2.0 + ((vx * vx) * (vy * vy) / 3.0))
				EndIf
				vertex = AddVertex(surf, vertx, verty, vertz, x * 1.0 / segments, y * 1.0 / segments)
				VertexNormal(surf,vertex,vertX,vertY,vertZ)

				if texture_mode=0 then
					'todo fix the texture mapping
					u=(x * 1.0 / segments)/2.0
					v=(y * 1.0 / segments)/3.0

					If u>1.0 Then u-=1.0
					If v>1.0 Then v-=1.0
					If u<0.0 Then u+=1.0
					If v<0.0 Then v+=1.0

					If s=5 Then vertextexcoords(surf,vertex,	0.5+u,	(2.0/3.0)+v)'right
					If s=4 Then vertextexcoords(surf,vertex,	0.0+u,	(2.0/3.0)+v)'left
					If s=6 Then vertextexcoords(surf,vertex,	0.5+u,	(0.0/3.0)+v)'back
					If s=2 Then vertextexcoords(surf,vertex,	0.0+u,	(0.0/3.0)+v)'front
					If s=3 Then vertextexcoords(surf,vertex,	0.5+u,	(1.0/3.0)+v)'down
					If s=1 Then vertextexcoords(surf,vertex,	0.0+u,	(1.0/3.0)+v)'up

				elseif texture_mode=1 then
					u=(x * 1.0 / segments)/6.0
					v=(y * 1.0 / segments)
					If u>1 Then u-=1.0
					If v>1 Then v-=1.0
					If u<0 Then u+=1.0
					If v<0 Then v+=1.0
					If s=5 Then vertextexcoords(surf,vertex,	(5.0/6.0)+u,	v)'right
					If s=4 Then vertextexcoords(surf,vertex,	(4.0/6.0)+u,	v)'left
					''
					If s=6 Then vertextexcoords(surf,vertex,	(1.0/6.0)+u,	v)'back
					If s=2 Then vertextexcoords(surf,vertex,	(0.0/6.0)+u,	v)'front
					If s=3 Then vertextexcoords(surf,vertex,	(3.0/6.0)+u,	v)'down
					If s=1 Then vertextexcoords(surf,vertex,	(2.0/6.0)+u,	v)'up
					
				elseif texture_mode=2 then
					u=sqr((vertx*vertx)+(verty*verty)+(vertz*vertz))
					v=0.5
					If u>1 Then u=1.0
					If u<0 Then u=0.0
					vertextexcoords(surf,vertex,	u,	v)
				endif
				''
			Next
		Next

		For y = 0 To segments - 1
			For x = 0 To segments - 1
				AddTriangle(surf, y * (segments + 1) + x, y * (segments + 1) + x + 1, y * (segments + 1) + x + segments + 2)
				AddTriangle(surf, y * (segments + 1) + x, y * (segments + 1) + x + segments + 2, y * (segments + 1) + x + segments + 1)
			Next
		Next
	Next
	Return mesh
End Function

' ----------------------------------------------------------------------------
' Creates a spherized Cube
' ----------------------------------------------------------------------------
Function LoadCubeSphere(filename As String, scale As Single=1.0,mode As Integer = 0) As Any Ptr'only supports bmp


	Dim As Integer filenum, bmpwidth, bmpheight
	Dim As Any Ptr img

	'' open BMP file
	filenum = FreeFile()
	If Open( filename For Binary Access Read As #filenum ) <> 0 Then Return NULL

	'' retrieve BMP dimensions
	Get #filenum, 19, bmpwidth
	Get #filenum, 23, bmpheight

	Close #filenum

	'' create image with BMP dimensions
	img = ImageCreate( Abs(bmpwidth), Abs(bmpheight) )

	If img = NULL Then Return NULL

	'' load BMP file into image buffer
	If BLoad( filename, img ) <> 0 Then ImageDestroy( img ): Return NULL

	Dim segments As Integer=(Abs(bmpwidth))
	If segments>16 Then segments=16
	Dim As Integer s
	Dim As double x,y
	Dim As double vx, vy, vz
	Dim As Double magnitude
	Dim As Double  vertx, verty, vertz
	Dim As integer vertex

	Dim As Any Ptr mesh = CreateMesh()
	Dim As Any Ptr surf
	Dim As double u,v

	For s = 1 To 6

		surf = CreateSurface(mesh)

		For y = 0 To segments

			For x = 0 To segments

				Select Case s

					Case 1:
						vx = x - segments / 2
						vy = segments / 2
						vz = segments / 2 - y

					Case 2:
						vx = x - segments / 2
						vy = segments / 2 - y
						vz = -segments / 2

					Case 3:
						vx = x - segments / 2
						vy = -segments / 2
						vz = y - segments / 2

					Case 4:
						vx = -segments / 2
						vy = segments / 2 - y
						vz = segments / 2 - x

					Case 5:
						vx = segments / 2
						vy = segments / 2 - y
						vz = x - segments / 2

					Case 6:
						vx = segments / 2 - x
						vy = segments / 2 - y
						vz = segments / 2

				End Select

				If mode = 0 Then

					magnitude = Sqr(vx * vx + vy * vy + vz * vz)
					vertx = vx / magnitude
					verty = vy / magnitude
					vertz = vz / magnitude

				Else

					vx = vx / segments * 2
					vy = vy / segments * 2
					vz = vz / segments * 2

					vertx = vx * Sqr(1.0 - (vy * vy) / 2.0 - (vz * vz) / 2.0 + ((vy * vy) * (vz * vz) / 3.0))
					verty = vy * Sqr(1.0 - (vz * vz) / 2.0 - (vx * vx) / 2.0 + ((vz * vz) * (vx * vx) / 3.0))
					vertz = vz * Sqr(1.0 - (vx * vx) / 2.0 - (vy * vy) / 2.0 + ((vx * vx) * (vy * vy) / 3.0))

				EndIf

				u=(x * 1.0 / segments)/2.0
				v=(y * 1.0 / segments)/3.0
				If s=1 Then
					vertz+=vertz*((Point((0.5+u)*bmpwidth,	((2.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'-z
					verty+=verty*((Point((0.5+u)*bmpwidth,	((2.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'-z
					vertx+=vertx*((Point((0.5+u)*bmpwidth,	((2.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'-z
				EndIf
				If s=3 Then
					vertz+=vertz*((Point((0.0+u)*bmpwidth,	((2.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+z
					verty+=verty*((Point((0.0+u)*bmpwidth,	((2.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+z
					vertx+=vertx*((Point((0.0+u)*bmpwidth,	((2.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+z
				EndIf

				If s=2 Then
					vertz+=vertz*((Point((0.5+u)*bmpwidth,	((1.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'-y
					verty+=verty*((Point((0.5+u)*bmpwidth,	((1.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale  '-y
					vertx+=vertx*((Point((0.5+u)*bmpwidth,	((1.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'-y
				EndIf

				If s=6 Then
					vertz+=vertz*((Point((0.0+u)*bmpwidth,	((1.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+y
					verty+=verty*((Point((0.0+u)*bmpwidth,	((1.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+y
					vertx+=vertx*((Point((0.0+u)*bmpwidth,	((1.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+y
				EndIf

				If s=4 Then
					vertz+=vertz*((Point((0.0+u)*bmpwidth,	((0.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'-x
					verty+=verty*((Point((0.0+u)*bmpwidth,	((0.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'-x
					vertx+=vertx*((Point((0.0+u)*bmpwidth,	((0.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'-x
				EndIf

				If s=5 Then
					vertz+=vertz*((Point((0.5+u)*bmpwidth,	((0.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+x
					verty+=verty*((Point((0.5+u)*bmpwidth,	((0.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+x
					vertx+=vertx*((Point((0.5+u)*bmpwidth,	((0.0/3.0)+v)*bmpheight,img) And &hff)/256)*scale	'+x
				EndIf

				vertex = AddVertex(surf, vertx, verty, vertz, x * 1.0 / segments, y * 1.0 / segments)
				VertexNormal(surf,vertex,vertX,vertY,vertZ)
				'todo fix the texture mapping
				If s=1 Then vertextexcoords(surf,vertex,	0.5+u,	(2.0/3.0)+v)'-z
				If s=3 Then vertextexcoords(surf,vertex,	0.0+u,	(2.0/3.0)+v)'+z
				'
				If s=2 Then vertextexcoords(surf,vertex,	0.5+u,	(1.0/3.0)+v)'-y
				If s=6 Then vertextexcoords(surf,vertex,	0.0+u,	(1.0/3.0)+v)'+y
				'
				If s=4 Then vertextexcoords(surf,vertex,	0.0+u,	(0.0/3.0)+v)'-x
				If s=5 Then vertextexcoords(surf,vertex,	0.5+u,	(0.0/3.0)+v)'+x

			Next

		Next


		For y = 0 To segments - 1

			For x = 0 To segments - 1

				AddTriangle(surf, y * (segments + 1) + x, y * (segments + 1) + x + 1, y * (segments + 1) + x + segments + 2)

				AddTriangle(surf, y * (segments + 1) + x, y * (segments + 1) + x + segments + 2, y * (segments + 1) + x + segments + 1)

			Next

		Next

	Next
	surf =GetSurface(mesh,3)
	Dim surf1 As Any Ptr=GetSurface(mesh,2)

	'	For y=0 To segments	Step segments
	For x =0 To segments
		VertexCoords(surf1,x+(segments+1)*(segments+1)  ,vertexX(surf,x  ),vertexY(surf,x  ),vertexZ(surf,x  ))
		surf =GetSurface(mesh,6)
		VertexCoords(surf1,x+(segments+1)*(segments+1)  ,vertexX(surf,x  ),vertexY(surf,x  ),vertexZ(surf,x  ))
		'VertexCoords(surf1,x   ,vertexX(surf,x  ),vertexY(surf,x ),vertexZ(surf,x ))
		'surf =GetSurface(mesh,6)
		'VertexCoords(surf,y + (segments+1)*segments ,vertexX(surf1,y  ),vertexY(surf1,y ),vertexZ(surf1,y ))
		'surf =GetSurface(mesh,6)
		'VertexCoords(surf,y  ,vertexX(surf1,y * (segments+1) ),vertexY(surf1,y * (segments+1)),vertexZ(surf1,y * (segments+1)))
		'surf =GetSurface(mesh,6)
		'VertexCoords(surf,y * (segments+1) ,vertexX(surf1,y * (segments+1)+segments ),vertexY(surf1,y * (segments+1)+segments),vertexZ(surf1,y * (segments+1)+segments))
		'surf =GetSurface(mesh,5)
		'VertexCoords(surf,y * (segments+1) ,vertexX(surf1,y * (segments+1)+segments ),vertexY(surf1,y * (segments+1)+segments),vertexZ(surf1,y * (segments+1)+segments))

		'surf =GetSurface(mesh,4)
		'VertexCoords(surf,y * (segments) + x,vertexX(surf1,y * (segments) + x),vertexY(surf1,y * (segments) + x),vertexZ(surf1,y * (segments) + x))

		'surf =GetSurface(mesh,3)
		'VertexCoords(surf,i,vertexX(surf1,i),vertexY(surf1,i),vertexZ(surf1,i))
		'surf1 =GetSurface(mesh,6)
		'VertexCoords(surf,i,vertexX(surf1,i),vertexY(surf1,i),vertexZ(surf1,i))
		'surf1 =GetSurface(mesh,5)
		'VertexCoords(surf,i,vertexX(surf1,i),vertexY(surf1,i),vertexZ(surf1,i))

		'Next
	Next

	ImageDestroy img
	img = NULL
	Return mesh

End Function


'' ----------------------------------------------------------------------------
'' Create a segmented cube
'' ----------------------------------------------------------------------------
'Function CreateSegCube:TMesh(segs:Int = 1, parent:TEntity = Null)
'
'	 side:Int, surf:TSurface
'	 stx:Float, sty:Float, stp:Float, y:Float
'	 a:Int, x:Float, v:Float, b:Int, u:Float
'	 v0:Int, v1:Int, v2:Int, v3:Int
'	 mesh:TMesh = CreateMesh(parent)
'
'	 surface:TSurface[6]
'
'	For  i:Int = 0 To 5
'
'		surface[i] = CreateSurface(mesh)
'
'	Next
'
'	' sides
'	For side = 0 To 3
'
'		surf = surface[side]
'		stx = -.5
'		sty = stx
'		stp = Float(1) / Float(segs)
'		y = sty
'
'		For a = 0 To segs
'
'			x = stx
'			v = a / Float(segs)
'
'			For b = 0 To segs
'
'				u = b / Float(segs)
'				v0 = AddVertex(surf, x, y, 0.5, u, v)
'
'				x = x + stp
'
'			Next
'
'			y = y + stp
'
'		Next
'
'		For a = 0 To segs - 1
'
'			For b = 0 To segs - 1
'
'				v0 = a * (segs + 1) + b
'				v1 = v0 + 1
'				v2 = (a + 1) * (segs + 1) + b + 1
'				v3 = v2 - 1
'
'				AddTriangle(surf, v0, v1, v2)
'				AddTriangle(surf, v0, v2, v3)
'
'			Next
'
'		Next
'
'		RotateMesh mesh, 0, 90, 0
'
'	Next
'
'	'top and bottom
'	RotateMesh mesh, 0, 90, 90
'
'	For side = 0 To 1
'
'		surf = surface[4 + side]
'		stx:Float = -.5
'		sty:Float = stx
'		stp:Float = Float(1) / Float(segs)
'		y:Float = sty
'
'		For a = 0 To segs
'			x:Float = stx
'			v = a / Float(segs)
'			For b = 0 To segs
'				u = b / Float(segs)
'				v0 = AddVertex(surf, x, y, 0.5, u, v)
'				x = x + stp
'			Next
'			y = y + stp
'		Next
'
'		For a = 0 To segs - 1
'			For b = 0 To segs - 1
'				v0 = a * (segs + 1) + b
'				v1 = v0 + 1
'				v2 = (a + 1) * (segs + 1) + b + 1
'				v3 = v2 - 1
'				AddTriangle(surf, v0, v1, v2)
'				AddTriangle(surf, v0, v2, v3)
'			Next
'		Next
'
'		RotateMesh mesh, 180, 0, 0
'
'	Next
'
'	' scale uniform to -1 to +1 space in X/Y/Z dimensions
'	FitMesh mesh, -1, -1, -1, 2, 2, 2, 1
'
'	RotateMesh mesh, -90, 0, 0
'
'	Return mesh
'
'End Function
'
'
'' ----------------------------------------------------------------------------
'' Create a segmented Sphere
'' ----------------------------------------------------------------------------
Function CreateSpherePart(segments As Integer, parent As Any ptr = NULL, start_pitch As single = -90.0, end_pitch As Single = 90.0, start_yaw As Single = -180.0, end_yaw As Single = 180.0, radius As Single = 1.0, multi1 As Single = 2.0, multi2 As Single = 0.5) As Any ptr

	Dim seg_pitch As Integer = segments
	Dim vert_pitch As Integer = seg_pitch + 1
	Dim seg_yaw As Integer = segments * multi1

	Dim step_yaw As Single = (end_yaw - start_yaw) / (seg_yaw)
	Dim step_pitch As Single = (end_pitch - start_pitch) / (seg_pitch)
	Dim step_u As Single = multi2 / (seg_yaw)
	Dim step_v As Single = 1.0 / (seg_pitch)

	Dim mesh As Any Ptr = CreateMesh(parent)
	Dim surf As Any Ptr = CreateSurface(mesh)

	Dim yaw As Single = start_yaw
	Dim pitch As Single = start_pitch

	For  yaw_i As Integer = 0 To seg_yaw

		If yaw_i = seg_yaw Then yaw = end_yaw

		For  pitch_i As integer = 0 To seg_pitch

			If pitch_i = seg_pitch Then pitch = end_pitch

			Dim ny As Single = Sin(pitch) / Cos(pitch)
			Dim nx As Single = Sin(yaw)
			Dim nz As Single = Cos(yaw)

			' normalize vector
			Dim factor As Single = Sqr(nx * nx + ny * ny + nz * nz)
			nx = nx / Abs(factor)
			ny = ny / Abs(factor)
			nz = nz / Abs(factor)

			If Abs(pitch) = 90 Then
				nx = 0
				ny = Sgn(pitch)
				nz = 0
			EndIf

			dim v As integer = AddVertex(surf, nx * radius, ny * radius, nz * radius, 1 - step_u * yaw_i, 1 - step_v * pitch_i)
			VertexNormal surf, v, nx, ny, nz

			VertexTexCoords(surf, v, ((yaw + 180.0) / 360.0) + 0.5, (pitch + 90.0) / 180.0, 0, 1)

			' connect vertices
			If yaw_i > 0 And pitch_i > 0 then

				AddTriangle surf, yaw_i * vert_pitch + pitch_i, (yaw_i - 1) * vert_pitch + pitch_i - 1, (yaw_i) * vert_pitch + pitch_i - 1
				AddTriangle surf, yaw_i * vert_pitch + pitch_i, (yaw_i - 1) * vert_pitch + pitch_i, (yaw_i - 1) * vert_pitch + pitch_i - 1

			EndIf

			pitch = pitch + step_pitch

		Next

		pitch = start_pitch
		yaw = yaw + step_yaw

	Next

	Return mesh

End Function
'
'
'
'' ------------------------------------------------------------------------------------------------
'' Creates a Ring
'' ------------------------------------------------------------------------------------------------
'Function CreateRing:TMesh(parent:TEntity = Null, segments:Int = 360, r1:Float, r2:Float, fx:Int = 1 + 16, r:Int = 255, g:Int = 255, b:Int = 255, a:Float = 1.0)
'
'	 angle:Int, a1:Float, a2:Float, a3:Float, a4:Float
'	 v0:Int, v1:Int, v2:Int, v3:Int
'
'	 mesh:TMesh = CreateMesh(parent)
'	 surf:TSurface = CreateSurface(mesh)
'
'	If SEGMENTS > 360 Then SEGMENTS = 360
'
'	For angle = 1 To SEGMENTS Step 1
'
'		a1 = angle * 360.0 / SEGMENTS - 360.0 / SEGMENTS
'		a2 = angle * 360.0 / SEGMENTS + 360.0 / SEGMENTS
'		a3 = angle * 360.0 / SEGMENTS + 180.0 / SEGMENTS
'		a4 = angle * 360.0 / SEGMENTS - 180.0 / SEGMENTS
'
'		v0 = AddVertex(surf, r1 * Cos(a1), r1 * Sin(a1), 0, 0, 0)
'		v1 = AddVertex(surf, r1 * Cos(a2), r1 * Sin(a2), 0, 0, 0)
'		v2 = AddVertex(surf, r2 * Cos(a3), r2 * Sin(a3), 0, 1, 1)
'		v3 = AddVertex(surf, r2 * Cos(a4), r2 * Sin(a4), 0, 1, 1)
'
'		VertexColor surf, v0, r, g, b, a
'		VertexColor surf, v1, r, g, b, a
'		VertexColor surf, v2, r, g, b, a
'		VertexColor surf, v3, r, g, b, a
'
'		AddTriangle surf, v2, v1, v0
'		AddTriangle surf, v0, v3, v2
'
'	Next
'
'	For  v:Int = 0 To CountVertices(surf) - 1
'
'		VertexTexCoords surf, v, 0.5+(VertexX(surf, v)/2.0), 0.5+(-VertexY(surf, v)/2.0),0, 1
'
'	Next
'
'	EntityFX mesh, fx
'
'	Return mesh
'
'End Function
'
'
'
'' ------------------------------------------------------------------------------------------------
'' Updates a Ring
'' ------------------------------------------------------------------------------------------------
'Function UpdateRing(mesh:TMesh, segments:Int = 360, r1:Float, r2:Float, fx:Int = 1 + 16, r:Int = 255, g:Int = 255, b:Int = 255, a:Float = 1.0)
'
'	 angle:Int, a1:Float, a2:Float
'	 v:Int, v0:Int, v1:Int, v2:Int, v3:Int
'
'	 surf:TSurface = GetSurface(mesh, 1)
'
'	If SEGMENTS > 360 Then SEGMENTS = 360
'
'	For angle = 0 To SEGMENTS - 1 Step 1
'
'		a1 = angle * 360.0 / SEGMENTS - 360.0 / SEGMENTS
'		a2 = angle * 360.0 / SEGMENTS + 360.0 / SEGMENTS
'
'		v0 = (angle * 4) + 0
'		v1 = (angle * 4) + 1
'		v2 = (angle * 4) + 2
'		v3 = (angle * 4) + 3
'
'		VertexCoords surf, v0, r1 * Cos(a1), 0, r1 * Sin(a1)
'		VertexCoords surf, v1, r1 * Cos(a2), 0, r1 * Sin(a2)
'		VertexCoords surf, v2, r2 * Cos(a2), 0, r2 * Sin(a2)
'		VertexCoords surf, v3, r2 * Cos(a1), 0, r2 * Sin(a1)
'
'		VertexColor surf, v0, r, g, b, a
'		VertexColor surf, v1, r, g, b, a
'		VertexColor surf, v2, r, g, b, a
'		VertexColor surf, v3, r, g, b, a
'
'	Next
'
'	For v = 0 To CountVertices(surf) - 1
'
'		VertexTexCoords surf, v, VertexX(surf, v), VertexZ(surf, v), 0, 1
'
'	Next
'
'	EntityFX mesh, fx
'
'End Function