Type __VECTOR__
  x As single
  y As single
  z As single
End Type
Type __VECTOR_2D__
  x As single
  y As single
End Type
Type __VECTOR_2D_I__
  x As integer
  y As integer
End Type
declare function vector_normalize (byval v As __VECTOR__) as __VECTOR__
declare function vector_magnitude(byval v As __VECTOR__) As Single
declare function vector_cross (v1 As __VECTOR__, v2 As __VECTOR__) as __VECTOR__
declare sub matrix_rotate_axis( m() As Single, Byval angle As Single,Byval x As Single, Byval y As Single, Byval z As Single )
declare function matrix_transformVector( m() As Single, byval v As __VECTOR__ ) as __VECTOR__
declare function normal_calculate(a As __VECTOR__, b As __VECTOR__, c As __VECTOR__) As __VECTOR__
declare function vector(x as single=0, y as single=0, z as single=0) as __VECTOR__
declare function vector_distance (byval v1 as __VECTOR__, byval v2 as __VECTOR__) as double

dim shared NULL_VECTOR as __VECTOR__
NULL_VECTOR.x=0
NULL_VECTOR.y=0
NULL_VECTOR.z=0
dim shared NULL_VECTOR_2D as __VECTOR_2D__
NULL_VECTOR_2D.x=0
NULL_VECTOR_2D.y=0
dim shared NULL_VECTOR_2D_I as __VECTOR_2D_I__
NULL_VECTOR_2D_I.x=0
NULL_VECTOR_2D_I.y=0

#define VECTORX 1
#define VECTORY 2
#define VECTORZ 3

function s2v(byval v as string) as __VECTOR__
	dim as __VECTOR__ r
	r.x=cvs(mid(v, 1, 4))
	r.y=cvs(mid(v, 5, 4))
	r.z=cvs(mid(v, 9, 4))
	return r
end function
function v2s(byval v as __VECTOR__) as string
	return mks(v.x) & mks(v.y) & mks(v.z)
end function

function vector_invert (byval v as __VECTOR__) as __VECTOR__
	if v.x < 0 then v.x=1+v.x else v.x = 1-v.x
	if v.y < 0 then v.y=1+v.y else v.y = 1-v.y
	if v.z < 0 then v.z=1+v.z else v.z = 1-v.z
	return v
end function
function vector_bounce (byval v as __VECTOR__) as __VECTOR__
	v.x=-v.x
	v.y=-v.y
	v.z=-v.z
	return v
end function

function vector_return overload (byval v as __VECTOR__, byval what as integer) as single
	if what = VECTORX then return v.x
	if what = VECTORY then return v.x
	if what = VECTORZ then return v.x
end function
function vector_return (byval v as __VECTOR__, byval what as string) as single
	if lcase(what) = "x" then return v.x
	if lcase(what) = "y" then return v.x
	if lcase(what) = "z" then return v.x
end function

function vector_add overload (byval v1 as __VECTOR__, byval v2 as __VECTOR__) as __VECTOR__
	dim v as __VECTOR__
	v.x = v1.x + v2.x
	v.y = v1.y + v2.y
	v.z = v1.z + v2.z
	return v
end function
function vector_add (byval v1 as __VECTOR__, byval v2 as single) as __VECTOR__
	dim v as __VECTOR__
	v.x = v1.x + v2
	v.y = v1.y + v2
	v.z = v1.z + v2
	return v
end function

function vector_sub overload (byval v1 as __VECTOR__, byval v2 as __VECTOR__) as __VECTOR__
	dim v as __VECTOR__
	v.x = v1.x - v2.x
	v.y = v1.y - v2.y
	v.z = v1.z - v2.z
	return v
end function
function vector_sub (byval v1 as __VECTOR__, byval v2 as single) as __VECTOR__
	dim v as __VECTOR__
	v.x = v1.x - v2
	v.y = v1.y - v2
	v.z = v1.z - v2
	return v
end function

function vector_mul overload (byval v1 as __VECTOR__, byval v2 as __VECTOR__) as __VECTOR__
	dim v as __VECTOR__
	v.x = v1.x * v2.x
	v.y = v1.y * v2.y
	v.z = v1.z * v2.z
	return v
end function
function vector_mul(byval v1 as __VECTOR__, byval v2 as single) as __VECTOR__
	dim v as __VECTOR__
	v.x = v1.x * v2
	v.y = v1.y * v2
	v.z = v1.z * v2
	return v
end function

function vector_div overload (byval v1 as __VECTOR__, byval v2 as __VECTOR__) as __VECTOR__
	dim v as __VECTOR__
	v.x = v1.x / v2.x
	v.y = v1.y / v2.y
	v.z = v1.z / v2.z
	return v
end function
function vector_div(byval v1 as __VECTOR__, byval v2 as single) as __VECTOR__
	dim v as __VECTOR__
	v.x = v1.x / v2
	v.y = v1.y / v2
	v.z = v1.z / v2
	return v
end function

function vector(x as single=0, y as single=0, z as single=0) as __VECTOR__
	dim v as __VECTOR__
	v.x=x
	v.y=y
	v.z=z
	return v
end function

function vector_innerproduct(byval v1 as __VECTOR__, byval v2 as __VECTOR__) as single
	return (v1.x * v2.x + v1.y * v2.y + v1.z * v2.z)
end function

function vector_copy(byval v as __VECTOR__) as __VECTOR__
	return v
end function

function vector_2d_copy(byval v as __VECTOR_2D__) as __VECTOR_2D__
	return v
end function

sub vector_swap(byval v1 as __VECTOR__ ptr, byval v2 as __VECTOR__ ptr)
	dim v as __VECTOR__
	v = vector_copy(*v1)
	v1->x=v2->x
	v1->y=v2->y
	v1->z=v2->z
	v2->x=v.x
	v2->y=v.y
	v2->z=v.z
end sub

function vector_distance (byval v1 as __VECTOR__, byval v2 as __VECTOR__) as double
	return sqr( (v1.x-v2.x)^2 + (v1.y-v2.y)^2 + (v1.z-v2.z)^2 )
end function

function vector_normalize (byval v As __VECTOR__) as __VECTOR__
	Dim mag As Single
	mag = vector_magnitude(v)
	v.x = v.x / mag
	v.y = v.y / mag
	v.z = v.z / mag
	return v
End function

Function vector_magnitude(byval v As __VECTOR__) As Single
	Dim mag As Single
	mag = Sqr(v.x ^2 + v.y ^2 + v.z ^2)
	If mag = 0 Then mag = 1
	return mag
End Function

function vector_cross (v1 As __VECTOR__, v2 As __VECTOR__) as __VECTOR__
    dim vout as __VECTOR__
	vout.x = (v1.y * v2.z) - (v2.y * v1.z)
    vout.y = (v1.z * v2.x) - (v2.z * v1.x)
    vout.z = (v1.x * v2.y) - (v2.x * v1.y)
	return vout
end function

Sub matrix_rotate_axis( m() As Single, Byval angle As Single,Byval x As Single, Byval y As Single, Byval z As Single )
	Dim sa As Single
	Dim ca As Single
	Dim recip_leng As Single
	sa = Sin(angle)
	ca = Cos(angle)
	recip_leng = 1 / Sqr(x*x + y*y + z*z)
	x = x * recip_leng
	y = y * recip_leng
	z = z * recip_leng
	m(0)  = ca + (1-ca) * x * x
	m(1)  = (1-ca) * x*y + sa*z
	m(2)  = (1-ca) * x*z - sa*y
	m(3)  = 0
	m(4)  = (1-ca) * y*x - sa*z
	m(5)  = ca + (1-ca) * y * y
	m(6)  = (1-ca) * y*z + sa*x
	m(7)  = 0
	m(8)  = (1-ca) * z*x + sa*y
	m(9)  = (1-ca) * y*z - sa*x
	m(10) = ca + (1-ca) * z * z
	m(11) = 0
	m(12) = 0
	m(13) = 0
	m(14) = 0
	m(15) = 1
End Sub

function matrix_transformVector( m() As Single, byval v As __VECTOR__ ) as __VECTOR__
	Dim x As Single
	Dim y As Single
	Dim z As Single
	x = v.x
	y = v.y
	z = v.z
	v.x = x * m(0) + y * m(4) + z * m(8)
	v.y = x * m(1) + y * m(5) + z * m(9)
	v.z = x * m(2) + y * m(6) + z * m(10)
	return v
End function

Function normal_calculate(a As __VECTOR__, b As __VECTOR__, c As __VECTOR__) As __VECTOR__
	dim as __VECTOR__ v(2), retVect
	v(0).x = b.x - a.x
	v(0).y = b.y - a.y
	v(0).z = b.z - a.z
	v(1).x = a.x - c.x
	v(1).y = a.y - c.y
	v(1).z = a.z - c.z
	retVect=vector_normalize(vector_cross(v(0), v(1)))
	return retVect
End Function
