#Include Once "raylib.bi"
Function MyGuiSliderPro(bounds As Rectangle, text0 As Const zstring Ptr, value as Single, minValue as Single, maxValue as Single, sliderWidth As Long ) As Single

	Dim As GuiControlState state = guiState

	Dim As long sliderValue = (((value - minValue)/(maxValue - minValue))*(bounds.width - 2*GuiGetStyle(SLIDER, BORDER_WIDTH)))

	Dim As Rectangle slider0 =  Rectangle(bounds.x, bounds.y + GuiGetStyle(SLIDER, BORDER_WIDTH) + GuiGetStyle(SLIDER, SLIDER_PADDING), _
	0, bounds.height - 2*GuiGetStyle(SLIDER, BORDER_WIDTH) - 2*GuiGetStyle(SLIDER, SLIDER_PADDING) )

	if (sliderWidth > 0) Then       ' Slider

		slider0.x += (sliderValue - sliderWidth/2)
		slider0.width = sliderWidth

	elseif (sliderWidth = 0) Then ' SliderBar

		slider0.x += GuiGetStyle(SLIDER, BORDER_WIDTH)
		slider0.width = sliderValue
	EndIf

	' Update control
	'----------------------------------
	if ((state <> GUI_STATE_DISABLED) andalso not guiLocked) Then

		Dim As Vector2 mousePointeger = GetMousePosition()

		if (CheckCollisionPointRec(mousePointeger, bounds)) Then

			if (IsMouseButtonDown(MOUSE_LEFT_BUTTON)) Then

				state = GUI_STATE_PRESSED

				' Get equivalent value and slider position from mousePointeger.x
				value = ((maxValue - minValue)*(mousePointeger.x - (bounds.x + sliderWidth/2)))/(bounds.width - sliderWidth) + minValue

				if (sliderWidth > 0) Then
					slider0.x = mousePointeger.x - slider0.width/2  ' Slider

				ElseIf (sliderWidth = 0) Then
					slider0.width = sliderValue          ' SliderBar
				EndIf
			else
				state = GUI_STATE_FOCUSED
			EndIf

			if (value > maxValue) Then
				value = maxValue

			elseif (value < minValue) Then
				value = minValue
			EndIf
		EndIf
	EndIf

	' Bar limits check
	if (sliderWidth > 0) Then       ' Slider

		if (slider0.x <= (bounds.x + GuiGetStyle(SLIDER, BORDER_WIDTH))) Then
			slider0.x = bounds.x + GuiGetStyle(SLIDER, BORDER_WIDTH)

		elseif ((slider0.x + slider0.width) >= (bounds.x + bounds.width)) Then
			slider0.x = bounds.x + bounds.width - slider0.width - GuiGetStyle(SLIDER, BORDER_WIDTH)
		EndIf

	elseif (sliderWidth = 0) Then ' SliderBar

		if (slider0.width > bounds.width) Then slider0.width = bounds.width - 2*GuiGetStyle(SLIDER, BORDER_WIDTH)
	EndIf
	'----------------------------------

	' Draw control
	'----------------------------------
	GuiDrawRectangle(bounds, GuiGetStyle(SLIDER, BORDER_WIDTH), Fade(GetColor(GuiGetStyle(SLIDER, BORDER + (state*3))), guiAlpha), Fade(GetColor(GuiGetStyle(SLIDER, iif(state <> GUI_STATE_DISABLED,  BASE_COLOR_NORMAL , BASE_COLOR_DISABLED))), guiAlpha))

	' Draw slider integerernal bar (depends on state)
	if ((state = GUI_STATE_NORMAL) OrElse (state = GUI_STATE_PRESSED)) Then
		GuiDrawRectangle(slider0, 0, BLANK, Fade(GetColor(GuiGetStyle(SLIDER, BASE_COLOR_PRESSED)), guiAlpha))

	elseif (state = GUI_STATE_FOCUSED) Then
		GuiDrawRectangle(slider0, 0, BLANK, Fade(GetColor(GuiGetStyle(SLIDER, BASE_COLOR_DISABLED)), guiAlpha))
	EndIf

	' Draw left/right text if provided
	if (text0 <> NULL) Then

		Dim As Rectangle textBounds
		textBounds.width = GetTextWidth(text0)'+bounds.width  ' TODO: Consider text icon
		textBounds.height = GuiGetStyle(DEFAULT, TEXT_SIZE)
		textBounds.x = bounds.x + bounds.width/2 - textBounds.width/2' + GuiGetStyle(SLIDER, TEXT_PADDING)
		'textBounds.x = bounds.x + bounds.width/2 - textBounds.width/2' + GuiGetStyle(SLIDER, TEXT_PADDING)
		textBounds.y = bounds.y + bounds.height/2 - GuiGetStyle(DEFAULT, TEXT_SIZE)/2

		'GuiDrawText(text0, textBounds, GUI_TEXT_ALIGN_CENTER, BLACK)
		GuiDrawText(text0, textBounds, GUI_TEXT_ALIGN_LEFT, Fade(GetColor(GuiGetStyle(SLIDER, TEXT + (state*3))), guiAlpha))
	EndIf

	'----------------------------------

	return value
End function
function MyGuiSliderBar(bounds As Rectangle, text As Const zstring Ptr, value as Single, minValue as Single, maxValue as Single) As Single

	return MyGuiSliderPro(bounds, text, value, minValue, maxValue, 0)
End Function

Function MyGuiValueBox(bounds As Rectangle, text0 As Const zstring Ptr, value as Long Ptr, minValue as single, maxValue as single, editMode as boolean) As boolean

	#if Not Defined(VALUEBOX_MAX_CHARS)
	#define VALUEBOX_MAX_CHARS  32
	#endif

	static As Long framesCounter = 0           ' Required for blinking cursor

	Dim As GuiControlState state = guiState
	Dim As boolean pressed = false

	Dim textValue As ZString*(VALUEBOX_MAX_CHARS + 1)
	sprintf(@textValue, "%u", *value)

	Dim As Rectangle textBounds
	if (text0 <> NULL) Then
		textBounds.width = GetTextWidth(text0)
		textBounds.height = GuiGetStyle(DEFAULT, TEXT_SIZE)
		textBounds.x = bounds.x + GuiGetStyle(VALUEBOX, TEXT_PADDING)
		'textBounds.x = bounds.x + bounds.width + GuiGetStyle(VALUEBOX, TEXT_PADDING)
		'textBounds.x = bounds.x + bounds.width/2 - textBounds.width/2' + GuiGetStyle(SLIDER, TEXT_PADDING)
		textBounds.y = bounds.y + bounds.height/2 - GuiGetStyle(DEFAULT, TEXT_SIZE)/2
		'if (GuiGetStyle(VALUEBOX, TEXT_ALIGNMENT) = GUI_TEXT_ALIGN_LEFT) Then textBounds.x = bounds.x - textBounds.width - GuiGetStyle(VALUEBOX, TEXT_PADDING)
	EndIf

	' Update control
	'----------------------------------
	if ((state <> GUI_STATE_DISABLED) andalso not guiLocked) Then
		Dim As Vector2 mousePointeger = GetMousePosition()

		Dim As boolean valueHasChanged = false

		if (editMode) Then
			state = GUI_STATE_PRESSED

			framesCounter+=1

			Dim As Long keyCount = strLen(textValue)
			' Only allow keys in range [48..57]
			if (keyCount < VALUEBOX_MAX_CHARS) Then
				Dim As Long maxWidth = bounds.width
				If (GetTextWidth(textValue) < maxWidth) Then
					Dim As long key = GetCharPressed()

					if ((key >= 48) And (key <= 57)) Then
						textValue[keyCount] = key
						keyCount+=1
						valueHasChanged = true
					EndIf
				EndIf
			endif

			' Delete text
			if (keyCount > 0) Then
				if (IsKeyPressed(KEY_BACKSPACE)) Then
					keyCount-=1
					if (keyCount < 0) Then keyCount = 0
					textValue[keyCount] = 0
					framesCounter = 0
					valueHasChanged = TRUE
				Elseif (IsKeyDown(KEY_BACKSPACE)) Then
					if ((framesCounter > TEXTEDIT_CURSOR_BLINK_FRAMES) AndAlso (framesCounter mod 2) = 0) Then keyCount-=1
					if (keyCount < 0) Then keyCount = 0
					textValue[keyCount] = 0
					valueHasChanged = true
				EndIf
			EndIf

			if (valueHasChanged) Then
				*value = TextToInteger(@textValue[0])
				sprintf(@textValue, "%d", *value)
				'Print *value,textValue
			EndIf

			if (IsKeyPressed(KEY_ENTER) OrElse ( Not CheckCollisionPointRec(mousePointeger, bounds) AndAlso IsMouseButtonPressed(MOUSE_LEFT_BUTTON))) Then pressed = TRUE
		else

			if (*value > maxValue) Then
				*value = maxValue
			elseif (*value < minValue) Then
				*value = minValue
			EndIf
			if (CheckCollisionPointRec(mousePointeger, bounds)) Then

				state = GUI_STATE_FOCUSED
				if (IsMouseButtonPressed(MOUSE_LEFT_BUTTON)) Then pressed = true
			EndIf
		EndIf

		if (pressed) Then framesCounter = 0
	endif
	'----------------------------------

	' Draw control
	'----------------------------------
	Dim As Color baseColor = BLANK
	if (state = GUI_STATE_PRESSED) Then
		baseColor = GetColor(GuiGetStyle(VALUEBOX, BASE_COLOR_PRESSED))
	ElseIf (state = GUI_STATE_DISABLED) Then
		baseColor = GetColor(GuiGetStyle(VALUEBOX, BASE_COLOR_DISABLED))
	EndIf
	' WARNING: BLANK color does not work properly with Fade()
	GuiDrawRectangle(bounds, GuiGetStyle(VALUEBOX, BORDER_WIDTH), Fade(GetColor(GuiGetStyle(VALUEBOX, BORDER + (state*3))), guiAlpha), baseColor)
	GuiDrawText(textValue, GetTextBounds(VALUEBOX, bounds), GUI_TEXT_ALIGN_RIGHT, Fade(GetColor(GuiGetStyle(VALUEBOX, TEXT + (state*3))), guiAlpha))

	' Draw blinking cursor
	if ((state = GUI_STATE_PRESSED) andalso (editMode AndAlso ((framesCounter/20) mod 2 = 0))) Then

		' NOTE: ValueBox integerernal text is always centered
		Dim As Rectangle cursor =  Rectangle(bounds.x + GetTextWidth(textValue)/2 + bounds.width/2 + 2, bounds.y + 2*GuiGetStyle(VALUEBOX, BORDER_WIDTH), 1, bounds.height - 4*GuiGetStyle(VALUEBOX, BORDER_WIDTH) )
		GuiDrawRectangle(cursor, 0, BLANK, Fade(GetColor(GuiGetStyle(VALUEBOX, BORDER_COLOR_PRESSED)), guiAlpha))
	EndIf

	' Draw text label if provided
	if (text0 <> NULL) Then
		GuiDrawText(text0, textBounds, iif(GuiGetStyle(VALUEBOX, TEXT_ALIGNMENT) = GUI_TEXT_ALIGN_RIGHT, GUI_TEXT_ALIGN_LEFT , GUI_TEXT_ALIGN_RIGHT), Fade(GetColor(GuiGetStyle(LABEL, TEXT + (state*3))), guiAlpha))
	EndIf
	'----------------------------------

	return pressed
End Function

' Color Panel control
Function MyGuiColorPanelEx(bounds As Rectangle, color0 as RayColor, hue As Single) As RayColor
	'
	'For x As UInteger=0 To 360/6
	'	For y As UInteger=0 To 128
	'		c1.c=&hffff0000
	'		c2.c=&hffffff00
	'		r=lerp(c1.r,c2.r,x/60)
	'		g=lerp(c1.g,c2.g,x/60)
	'		b=lerp(c1.b,c2.b,x/60)
	'
	'		cr.r=lerp(r,cw.r,y/128)
	'		cr.g=lerp(g,cw.g,y/128)
	'		cr.b=lerp(b,cw.b,y/128)
	'		PSet img,(x,y+128),cr.c
	'		cr.r=lerp(cb.r,r,y/128)
	'		cr.g=lerp(cb.g,g,y/128)
	'		cr.b=lerp(cb.b,b,y/128)
	'		PSet img,(x,y),cr.c
	'
	'		c1.c=&hffffff00
	'		c2.c=&hff00ff00
	'		r=lerp(c1.r,c2.r,x/60)
	'		g=lerp(c1.g,c2.g,x/60)
	'		b=lerp(c1.b,c2.b,x/60)
	'
	'		cr.r=lerp(r,cw.r,y/128)
	'		cr.g=lerp(g,cw.g,y/128)
	'		cr.b=lerp(b,cw.b,y/128)
	'		PSet img,(x+60,y+128),cr.c
	'		cr.r=lerp(cb.r,r,y/128)
	'		cr.g=lerp(cb.g,g,y/128)
	'		cr.b=lerp(cb.b,b,y/128)
	'		PSet img,(x+60,y),cr.c
	'
	'		c1.c=&hff00ff00
	'		c2.c=&hff00ffff
	'		r=lerp(c1.r,c2.r,x/60)
	'		g=lerp(c1.g,c2.g,x/60)
	'		b=lerp(c1.b,c2.b,x/60)
	'
	'		cr.r=lerp(r,cw.r,y/128)
	'		cr.g=lerp(g,cw.g,y/128)
	'		cr.b=lerp(b,cw.b,y/128)
	'		PSet img,(x+120,y+128),cr.c
	'		cr.r=lerp(cb.r,r,y/128)
	'		cr.g=lerp(cb.g,g,y/128)
	'		cr.b=lerp(cb.b,b,y/128)
	'		PSet img,(x+120,y),cr.c
	'
	'		c1.c=&hff00ffff
	'		c2.c=&hff0000ff
	'		r=lerp(c1.r,c2.r,x/60)
	'		g=lerp(c1.g,c2.g,x/60)
	'		b=lerp(c1.b,c2.b,x/60)
	'
	'		cr.r=lerp(r,cw.r,y/128)
	'		cr.g=lerp(g,cw.g,y/128)
	'		cr.b=lerp(b,cw.b,y/128)
	'		PSet img,(x+180,y+128),cr.c
	'		cr.r=lerp(cb.r,r,y/128)
	'		cr.g=lerp(cb.g,g,y/128)
	'		cr.b=lerp(cb.b,b,y/128)
	'		PSet img,(x+180,y),cr.c
	'
	'		c1.c=&hff0000ff
	'		c2.c=&hffff00ff
	'		r=lerp(c1.r,c2.r,x/60)
	'		g=lerp(c1.g,c2.g,x/60)
	'		b=lerp(c1.b,c2.b,x/60)
	'
	'		cr.r=lerp(r,cw.r,y/128)
	'		cr.g=lerp(g,cw.g,y/128)
	'		cr.b=lerp(b,cw.b,y/128)
	'		PSet img,(x+240,y+128),cr.c
	'		cr.r=lerp(cb.r,r,y/128)
	'		cr.g=lerp(cb.g,g,y/128)
	'		cr.b=lerp(cb.b,b,y/128)
	'		PSet img,(x+240,y),cr.c
	'
	'		c1.c=&hffff00ff
	'		c2.c=&hffff0000
	'		r=lerp(c1.r,c2.r,x/60)
	'		g=lerp(c1.g,c2.g,x/60)
	'		b=lerp(c1.b,c2.b,x/60)
	'
	'		cr.r=lerp(r,cw.r,y/128)
	'		cr.g=lerp(g,cw.g,y/128)
	'		cr.b=lerp(b,cw.b,y/128)
	'		PSet img,(x+300,y+128),cr.c
	'		cr.r=lerp(cb.r,r,y/128)
	'		cr.g=lerp(cb.g,g,y/128)
	'		cr.b=lerp(cb.b,b,y/128)
	'		PSet img,(x+300,y),cr.c
	'	Next
	'Next

	Dim As GuiControlState state = guiState
	Dim As Vector2 pickerSelector

	Dim As Vector3 vcolor =  Vector3(color0.r/255.0f, color0.g/255.0f, color0.b/255.0f )
	Dim hsv as Vector3 = ConvertRGBtoHSV(vcolor)

	pickerSelector.x = bounds.x + hsv.y*bounds.width            ' HSV: Saturation
	pickerSelector.y = bounds.y + (1.0f - hsv.z)*bounds.height  ' HSV: Value

	Dim As Vector3 maxHue =  Vector3(iif(hue >= 0.0f , hue , hsv.x), 1.0f, 1.0f)
	Dim As Vector3 rgbHue = ConvertHSVtoRGB(maxHue)
	Dim As Color maxHueCol =  Color((255.0f*rgbHue.x),_
	(255.0f*rgbHue.y),_
	(255.0f*rgbHue.z), 255 )

	Dim As Const Color colWhite = Color( 255, 255, 255, 255 )
	Dim As Const Color colBlack = Color( 0, 0, 0, 255 )

	' Update control
	'----------------------------------
	if ((state <> GUI_STATE_DISABLED) andalso not guiLocked) Then

		Dim As Vector2 mousePointeger = GetMousePosition()

		if (CheckCollisionPointRec(mousePointeger, bounds)) Then

			if (IsMouseButtonDown(MOUSE_LEFT_BUTTON)) Then

				state = GUI_STATE_PRESSED
				pickerSelector = mousePointeger

				' Calculate color from picker
				Dim As Vector2 colorPick = Vector2( pickerSelector.x - bounds.x, pickerSelector.y - bounds.y )

				colorPick.x /= bounds.width     ' Get normalized value on x
				colorPick.y /= bounds.height    ' Get normalized value on y

				hsv.y = colorPick.x
				hsv.z = 1.0f - colorPick.y

				Dim RGB1 as Vector3 = ConvertHSVtoRGB(hsv)

				' NOTE: Vector3ToColor() only available on raylib 1.8.1
				color0 = Color( (255.0f*rgb1.x),_
				(255.0f*rgb1.y),_
				(255.0f*rgb1.z),_
				(255.0f*color0.a/255.0f) )


			else
				state = GUI_STATE_FOCUSED
			EndIf
		endif
	endif
	'----------------------------------

	' Draw control
	'----------------------------------
	if (state <> GUI_STATE_DISABLED)Then

		DrawRectangleGradientEx(bounds, Fade(colWhite, guiAlpha), Fade(colWhite, guiAlpha), Fade(maxHueCol, guiAlpha), Fade(maxHueCol, guiAlpha))
		DrawRectangleGradientEx(bounds, Fade(colBlack, 0), Fade(colBlack, guiAlpha), Fade(colBlack, guiAlpha), Fade(colBlack, 0))

		' Draw color picker: selector
		Dim As Rectangle selector =  Rectangle (pickerSelector.x - GuiGetStyle(COLORPICKER, COLOR_SELECTOR_SIZE)/2, pickerSelector.y - GuiGetStyle(COLORPICKER, COLOR_SELECTOR_SIZE)/2, GuiGetStyle(COLORPICKER, COLOR_SELECTOR_SIZE), GuiGetStyle(COLORPICKER, COLOR_SELECTOR_SIZE) )
		GuiDrawRectangle(selector, 0, BLANK, Fade(colWhite, guiAlpha))

	else

		DrawRectangleGradientEx(bounds, Fade(Fade(GetColor(GuiGetStyle(COLORPICKER, BASE_COLOR_DISABLED)), 0.1f), guiAlpha), Fade(Fade(colBlack, 0.6f), guiAlpha), Fade(Fade(colBlack, 0.6f), guiAlpha), Fade(Fade(GetColor(GuiGetStyle(COLORPICKER, BORDER_COLOR_DISABLED)), 0.6f), guiAlpha))
	endif

	GuiDrawRectangle(bounds, 1, Fade(GetColor(GuiGetStyle(COLORPICKER, BORDER + state*3)), guiAlpha), BLANK)
	'----------------------------------

	return color
End function

' Progress Bar control extended, shows current progress value
Function MyGuiProgressBar(bounds As Rectangle, textLeft As Const zstring Ptr, value as Single, minValue as Single, maxValue as single) As Single

	Dim As GuiControlState state = guiState

	Dim As Rectangle progress = Rectangle( bounds.x + GuiGetStyle(PROGRESSBAR, BORDER_WIDTH), _
	bounds.y + GuiGetStyle(PROGRESSBAR, BORDER_WIDTH) + GuiGetStyle(PROGRESSBAR, PROGRESS_PADDING), 0, _
	bounds.height - 2*GuiGetStyle(PROGRESSBAR, BORDER_WIDTH) - 2*GuiGetStyle(PROGRESSBAR, PROGRESS_PADDING) )

	' Update control
	'----------------------------------
	if (state <> GUI_STATE_DISABLED) Then progress.width = (value/(maxValue - minValue)*(bounds.width - 2*GuiGetStyle(PROGRESSBAR, BORDER_WIDTH)))
	'----------------------------------

	' Draw control
	'----------------------------------
	GuiDrawRectangle(bounds, GuiGetStyle(PROGRESSBAR, BORDER_WIDTH), Fade(GetColor(GuiGetStyle(PROGRESSBAR, BORDER + (state*3))), guiAlpha), BLANK)

	' Draw slider integerernal progress bar (depends on state)
	if ((state = GUI_STATE_NORMAL) OrElse (state = GUI_STATE_PRESSED)) Then
		GuiDrawRectangle(progress, 0, BLANK, Fade(GetColor(GuiGetStyle(PROGRESSBAR, BASE_COLOR_PRESSED)), guiAlpha))

	elseif (state = GUI_STATE_FOCUSED) Then
		GuiDrawRectangle(progress, 0, BLANK, Fade(GetColor(GuiGetStyle(PROGRESSBAR, TEXT_COLOR_FOCUSED)), guiAlpha))
	EndIf
	' Draw left/right text if provided
	if (textLeft <> NULL) Then

		Dim As Rectangle textBounds
		textBounds.width = GetTextWidth(textLeft)  ' TODO: Consider text icon
		textBounds.height = GuiGetStyle(DEFAULT, TEXT_SIZE)
		textBounds.x = bounds.x + bounds.width/4 + textBounds.width/4 - GuiGetStyle(PROGRESSBAR, TEXT_PADDING)
		textBounds.y = bounds.y + bounds.height/2 - GuiGetStyle(DEFAULT, TEXT_SIZE)/2

		GuiDrawText(textLeft, textBounds, GUI_TEXT_ALIGN_CENTER, Fade(GetColor(GuiGetStyle(PROGRESSBAR, TEXT + (state*3))), guiAlpha))
		'GuiDrawText(textLeft, textBounds, GUI_TEXT_ALIGN_RIGHT, Fade(GetColor(GuiGetStyle(PROGRESSBAR, TEXT + (state*3))), guiAlpha))
	EndIf

	'----------------------------------

	return value
End function





