function ToRaylibImage( _
  byval fbImg as Fb.Image ptr ) _
  as Image
 
  '' Create a fully transparent image
  var _
    rlImg => GenImageColor( fbImg->width, fbImg->height, BLANK )
 
  '' Fetch a pointer to the start of the Fb.Image pixel area, skipping header
  dim as ulong ptr _
    fbPx => cptr( ulong ptr, fbImg ) + sizeOf( Fb.Image ) \ sizeOf( ulong )
 
  '' Fetch a pointer to the Raylib Image pixel area
  dim as ulong ptr _
    rlPx => cptr( ulong ptr, rlImg.data )
 
  /'
    FreeBasic image buffers are padded to a paragraph (16 bytes) boundary. This
    means we need to take this into account when addressing each pixel.
  '/
  dim as integer _
    pitchInPixels => fbImg->pitch \ sizeOf( ulong )
 
  '' Then we just transfer the pixels
  for _
    y as integer => 0 to rlImg.height - 1
   
    for _
      x as integer => 0 to rlImg.width - 1
     
      dim as ulong _
        c => fbPx[ y * pitchInPixels + x ]
     
      '' Do note that I'm swapping the red and blue components here!
      rlPx[ y * rlImg.width + x ] => rgba( _
        c and 255, _
        c shr 8 and 255, _
        c shr 16 and 255, _
        c shr 24 )
    next
  next
 
  return( rlImg )
end Function