#Include once "crt.bi"

#Define ByteToMB(x) (x/1024)/1024

Type Mem
	PhysTotal As UInteger
	PhysAvail As UInteger
	Phys_Used As UInteger
	PhyShared As UInteger
	PhyBuffer As UInteger
	SwapTotal As UInteger
	SwapAvail As UInteger
	Swap_Used As UInteger
End Type

Type Res
	ubBPP As UByte
	sBPP As String
	sRes As String
End Type

Type Alg
	CPU As Double
	Sys As String
	Runtime As String
End Type

Type CPU
	sBrand As String
	sVendor As String
	sSpeed As String
	sNumCores As String
	sArch As String
	sFamily As String
	sModel As String
	sStepping As String
	sh3DNow As String
	sh3DNowEx As String
	shMMX As String
	shMMXEx As String
	shSSE As String
	shSSE2 As String
	shSSE3 As String
	shSSSE3 As String
	shSSE41 As String
	shSSE42 As String
	shSSE4a As String
	shSSE5 As String
	shVMX As String
End Type
Dim Shared MemInf As Mem
Dim Shared ResInf As Res
Dim Shared AlgInf As Alg
Dim Shared CPUInf As CPU
CPUInf.sh3DNow = "No"
CPUInf.sh3DNowEx = "No"
CPUInf.shMMX = "No"
CPUInf.shMMXEx = "No"
CPUInf.shSSE = "No"
CPUInf.shSSE2 = "No"
CPUInf.shSSE3 = "No"
CPUInf.shSSSE3 = "No"
CPUInf.shSSE41 = "No"
CPUInf.shSSE42 = "No"
CPUInf.shSSE4a = "No"
CPUInf.shSSE5 = "No"
CPUInf.shVMX = "No"

Declare Function _GetCoreCountAMD () As Byte
Declare Function _GetCoreCountIntel () As Byte
Declare Sub CollectInfo ()
Declare Sub CollectInfoExtra ()
Declare Function GetArch () As String
Declare Function GetCPUClock () As Integer
Declare Function getFamily () As Byte
Declare Function getModel () As Byte
Declare Function getStepping () As Byte
Declare Function has_CPUID () As Integer
Declare Function has_MMX () As Byte
Declare Function has_SSE () As Byte
Declare Function has_SSE2 () As Byte
Declare Function is_AMD () As Byte
Declare Function is_x64 () As Byte
Declare Function readBrandString () As String
Declare Function readVendorName () As String
Declare Function GetWindowsVersion () As String
Declare Function GetWindowsMajorVersion () As Integer
	
#Define WIN_INCLUDEALL
#Include once "windows.bi"

Function GetWindowsVersion () As String
	Dim r As String
	Dim viOS As OSVERSIONINFO
	viOS.dwOSVersionInfoSize = SizeOf(OSVERSIONINFO)
	GetVersionEx(@viOS)
	
	Select Case viOS.dwPlatformId
		Case VER_PLATFORM_WIN32_NT
			If (viOS.dwMajorVersion >= 6) And (viOS.dwMinorVersion >= 0) Then r = "Windows Vista"
			If (viOS.dwMajorVersion = 5) And (viOS.dwMinorVersion = 2) Then r = "Windows Server 2003"
			If (viOS.dwMajorVersion = 5) And (viOS.dwMinorVersion = 1) Then r = "Windows XP"
			If (viOS.dwMajorVersion = 5) And (viOS.dwMinorVersion = 0) Then r = "Windows 2000"
			If viOS.dwMajorVersion <= 4 Then r = "Windows NT"
		Case VER_PLATFORM_WIN32_WINDOWS
			If (viOS.dwMajorVersion = 4) And (viOS.dwMinorVersion = 0) Then r = "Windows 95"
			If (viOS.dwMajorVersion = 4) And (viOS.dwMinorVersion = 10) Then
				If viOS.szCSDVersion = "A" Then r = " Windows 98 SE" Else r = "Windows 98"
			EndIf
			If (viOS.dwMajorVersion = 4) And (viOS.dwMinorVersion = 90) Then r = "Windows ME"
		Case VER_PLATFORM_WIN32s
			r = "Win32s"
	End Select
		
	Return r
End Function

Function GetWindowsMajorVersion () As Integer
	Dim viOS As OSVERSIONINFO
	viOS.dwOSVersionInfoSize = SizeOf(OSVERSIONINFO)
	GetVersionEx(@viOS)
	
	Return viOS.dwMajorVersion
End Function

Function GetArch () As String
	Select Case (fb_CpuDetect Shr 28)
		Case 3: Return "i386"
		Case 4: Return "i486"
		Case 5: Return "i586"
		Case 6: Return "i686"
	End Select
End Function

Function has_CPUID () As Integer
	Asm 
		pushfd
		pop eax
		mov ebx, eax
		xor eax, &h200000
		push eax
		popfd
		pushfd
		pop eax
		cmp eax, ebx
		jz no_cpuid
		mov eax,1 
		no_cpuid: 
		mov [Function], eax 
	End Asm
	
End Function

Function GetCPUClock () As Integer
	Dim As Uinteger t
	Dim As Double t1
	SetPriorityClass (GetCurrentProcess(), REALTIME_PRIORITY_CLASS)
	Asm
		xor eax, eax
		cpuid
		rdtsc
		mov [t], eax
	End Asm
	
	t1 = Timer + 0.2
	Do: Loop Until t1 < Timer
	Asm
		xor eax, eax
		cpuid
		rdtsc
		Sub eax, [t]
		mov ecx, 2000000
		cdq
		idiv ecx
		inc eax
		imul eax, 10
		mov [Function], eax
	End Asm
	SetPriorityClass (GetCurrentProcess(), NORMAL_PRIORITY_CLASS)
End Function

Function has_MMX () As Byte
	Dim As Byte hat_mmx = 0
	Asm 
		mov eax, 1
		cpuid
		test edx, &h00800000
		jz doesnot
		mov Byte Ptr [hat_mmx], 1
		
		doesnot:
	End Asm
	Return hat_mmx
End Function

Function has_SSE () As Byte
	Dim As Byte hat_sse = 0
	Asm
		mov eax, 1
		cpuid
		test edx, &h02000000
		jz doesnot2
		mov Byte Ptr [hat_sse], 1 
		
		doesnot2:
	End Asm
	Return hat_sse
End Function

Function has_SSE2 () As Byte
	Dim As Byte hat_sse2 = 0
	Asm
		mov eax, 1
		cpuid
		test edx, &h04000000
		jz doesnot3
		mov Byte Ptr [hat_sse2], 1 
		
		doesnot3:
	End Asm
	Return hat_sse2
End Function

Function is_AMD () As Byte
	Dim As Byte _is_amd, is_intel
	Asm
	  mov eax, 0
	  cpuid
	  cmp ecx, &h444d4163
	  jnz no_amd
	  mov Byte Ptr [_is_amd], 1
	  no_amd:
	  cmp ecx, &h6c65746e
	  jnz no_intel
	  mov Byte Ptr [is_intel], 1
	  no_intel:
	End Asm
	If _is_AMD = 0 Then Return 0 Else Return 1
End Function

Function is_x64 () As Byte
	Dim As UInteger erg
	Dim As Byte AMD64
	If is_AMD = 1 Then
		Asm
			mov eax,&h80000000
			cpuid
			and eax, &h0F
			mov [erg], eax
		End Asm
		If erg > 0 Then
			Asm
				mov eax,&h80000001
				cpuid
				test edx, &h20000000
				jz weiter5
				mov Byte Ptr [AMD64], 1
				weiter5:
			End Asm
		End If
	Else
		Asm
			mov eax,&h80000000
			cpuid
			and eax, &h0F
			mov [erg], eax
		End Asm
		If erg > 0 Then
			Asm
			  mov eax,&h80000001
			  cpuid
			  test edx, &h20000000
			  jz no_EM64T
			  mov Byte Ptr [AMD64], 1
			  no_EM64T:
			End Asm
		End If
	End If
	Return AMD64
End Function

Function _GetCoreCountAMD () As Byte
	Dim As UInteger erg, tmp
	Dim As Byte mnc, cores
	Asm
		mov eax, &h80000000
		cpuid
		And eax, &h0fffffff
		mov [erg], eax
	End Asm
	Asm
		mov eax,&h80000008
		cpuid
		mov [mnc], cl
		Shr ecx,12
		And ecx,15
		mov [tmp],ecx
	End Asm
	If tmp=0 Then
	cores=mnc+1
	Else
		cores=(1 shl tmp)
	EndIf
	Return cores
End Function

Function _GetCoreCountIntel () As Byte
	Dim As Integer erg
	Dim As UInteger tmp, tmp1, tmp2
	Dim As Byte HTT
	Asm
		mov eax, 1
		cpuid
		mov [tmp], edx
	End Asm
	If tmp And &h10000000 Then HTT = 1
	tmp = 0
	Asm
		mov eax, 0
		cpuid
		mov [erg], eax
	End Asm
	Asm 
		mov eax, 1
		cpuid
		mov [tmp], ecx
		Shr ebx, 16
		And ebx, &h0ff
		mov [tmp2], ebx
	End Asm
	If tmp2 > 1 Then
		If HTT = 1 Then
			If erg >= 4 Then
				Asm
					mov eax, 4
					mov ecx, 0
					cpuid
					Shr eax, 26
					And eax, &h3F
					Inc eax
					mov [tmp], eax
				End Asm
				If tmp2\tmp < 2 Then HTT = 0
			EndIf
			Return Cast(Byte, tmp2)
		EndIf
	EndIf
	Return 1
End Function

Function readVendorName () As String
	Dim _e As UInteger
	Dim vendor As String * 12
	Asm 
		mov eax, 0 
		cpuid 
		mov [_e], eax
		mov [vendor], ebx
		mov [vendor+4], edx 
		mov [vendor+8], ecx 
	End Asm
	
	Return vendor
End Function

Function readBrandString () As String
   Dim Brand As String * 48
   Asm
      mov eax, &H80000002
      cpuid
      cmp eax, 0
      jz no_brand
      mov [Brand], eax
      mov [Brand+4], ebx
      mov [Brand+8], ecx
      mov [Brand+12], edx
      
      mov eax, &H80000003
      cpuid
      mov [Brand+16], eax
      mov [Brand+20], ebx
      mov [Brand+24], ecx
      mov [Brand+28], edx
      
      mov eax, &H80000004
      cpuid
      mov [Brand+32], eax
      mov [Brand+36], ebx
      mov [Brand+40], ecx
      mov [Brand+44], edx
      
      no_brand:
   End Asm
      Return Brand
End Function

Function getStepping () As Byte
	Dim As Byte Stepping
	Asm
		mov eax, 1 
		cpuid 
		mov ebx, eax 
		and eax, &h0F 
		mov [Stepping], al
	End Asm
	Return Stepping
End Function

Function getModel () As Byte
	Dim As Byte Model
	Asm
		mov eax, 1
		cpuid
		mov eax,ebx 
		shr eax, 4 
		and eax, &h0F 
		mov [Model], al
	End Asm
	Return Model
End Function

Function getFamily () As Byte
	Dim As Byte Family
	Asm
		mov eax, 1
		cpuid
		mov eax,ebx 
		shr eax, 8 
		and eax, &h0F 
		mov [Family], al
	End Asm
	Return Family
End Function


Function Replace (Byval StrEx as String, Byval StrMask as String, Byval StrRplce as String) as String
	If Len(StrEx)=0 or Len(StrMask)>Len(StrEx) Then Return StrEx
	Dim Buffer as String=StrEx
	Dim MaskSearch as UInteger
	Dim MFound as byte
	Dim lp as UInteger=1
	Do
		MaskSearch=InStr(lp,Buffer,StrMask)
		MFound=0
		If MaskSearch Then
			MFound=1:lp=MaskSearch+Len(StrRplce)
			Buffer=Left(Buffer,MaskSearch-1)+ _
			StrRplce+ _
			Right(Buffer,Len(Buffer)-(MaskSearch+(Len(StrMask)-1)))
		End If
	Loop while MFound=1
	Return Buffer
End Function

#Define YesToSPR(t)	*IIf(t = "Yes", @"supported", @"not supported")

Sub CollectInfoExtra()
	With CPUInf
		If has_CPUID () = 1 Then
			Select Case readVendorName()
				Case "GenuineIntel": .sVendor = "Intel"
				Case "UMC UMC UMC ": .sVendor = "UMC"
				Case "AuthenticAMD": .sVendor = "AMD"
				Case "CyrixInstead": .sVendor = "Cyrix"
				Case "NexGenDriven": .sVendor = "NexGen"
				Case "CentaurHauls": .sVendor = "Centaur"
				Case "RiseRiseRise": .sVendor = "Rise Technology"
				Case "SiS SiS SiS ": .sVendor = "SiS"
				Case "GenuineTMx86": .sVendor = "Transmeta"
				Case "Geode by NSC": .sVendor = "National Semiconductor"
			End Select
			
			If is_x64 () Then
				.sArch = "x64"
			Else
				.sArch = GetArch()
			EndIf
			If is_AMD () Then
				Dim As Byte _3dnow, _3dnowex, _mmxex, _sse4a, _sse5
				Asm
					mov eax,&h80000001
					cpuid
					
					test edx, &h400000
					jz no_mmxex
					mov Byte Ptr [_mmxex], 1
					
					no_mmxex:
					test edx, &h80000000
					jz no_3dnow
					mov Byte Ptr [_3dnow], 1
					
					no_3dnow:
					test edx, &h40000000
					jz no_3dnowex
					mov Byte Ptr [_3dnowex], 1
					
					no_3dnowex:
					Test ecx, &h40
					jz no_sse4a
					mov Byte Ptr [_sse4a], 1
					
					no_sse4a:
					Test ecx, &h800
					jz no_sse5
					mov Byte Ptr [_sse5], 1
					
					no_sse5:
				End Asm
				
				.sh3DNow = *IIf(_3dnow, @"Yes", @"No")
				.sh3DNowEx = *IIf(_3dnowex, @"Yes", @"No")
				.shMMXEx = *IIf(_mmxex, @"Yes", @"No")
				
				.shSSE4a = *IIf(_sse4a, @"Yes", @"No")
				.shSSE5 = *IIf(_sse5, @"Yes", @"No")
				
				.sNumCores = Str(_GetCoreCountAMD())
			Else ' Intel
				Dim As Byte _sse3, _ssse3, _sse41, _sse42, _vmx
				Asm
					mov eax, 1
					cpuid
					
					Test ecx, 1
					jz no_sse3
					mov Byte Ptr [_sse3], 1
					
					no_sse3:
					Test ecx, &h200
					jz no_ssse3
					mov Byte Ptr [_ssse3], 1
					
					no_ssse3:
					Test ecx, &h20
					jz no_vmx
					mov Byte Ptr [_vmx], 1
					
					no_vmx:
					Test ecx, &h80000
					jz no_sse41
					mov Byte Ptr [_sse41], 1
					
					no_sse41:
					Test ecx, &h100000
					jz no_sse42
					mov Byte Ptr [_sse42], 1
					
					no_sse42:
				End Asm
				
				.shSSE3 = *IIf(_sse3, @"Yes", @"No")
				.shSSSE3 = *IIf(_ssse3, @"Yes", @"No")
				.shVMX = *IIf(_vmx, @"Yes", @"No")
				.shSSE41 = *IIf(_sse41, @"Yes", @"No")
				.shSSE42 = *IIf(_sse42, @"Yes", @"No")
				
				.sNumCores = Str(_GetCoreCountIntel())
			EndIf
			
			.sBrand = readBrandString()
			
			.sSpeed = "~" & Str(GetCPUClock()) & " Mhz"
			
			.sFamily = Str(getFamily())
			.sModel = Str(getModel())
			.sStepping = Str(getStepping())
			
			.shMMX = *IIf(has_MMX(), @"Yes", @"No")
			.shSSE = *IIf(has_SSE(), @"Yes", @"No")
			.shSSE2 = *IIf(has_SSE2(), @"Yes", @"No")
		EndIf
	End With

	Dim hDC As HDC=GetDC(0)
	Const BITSPIXEL = 12
	Const PLANES = 14
	
	With ResInf
		.ubBPP=GetDeviceCaps(hDC, BITSPIXEL) * GetDeviceCaps(hDC, PLANES)
		Select Case .ubBPP
			Case 1: .sBPP="monochrome"
			Case 4: .sBPP="4 colors"
			Case 8: .sBPP="256 colors"
			Case Else: .sBPP=Str(.ubBPP) & " BPP"
		End Select
		.sRes=GetDeviceCaps(hDC, HORZRES) & "x" & GetDeviceCaps(hDC, VERTRES)
	End With
	
	ReleaseDC(0, hDC)
End Sub

Sub CollectInfo()
	If GetWindowsMajorVersion () >= 5 Then ' On 2000/XP/Vista use new function
		Dim p_MemInf As MEMORYSTATUSEX
		p_MemInf.dwLength=Len(p_MemInf)
		GlobalMemoryStatusEx(@p_MemInf) 
		
		With MemInf
			.PhysTotal=ByteToMB(p_MemInf.ullTotalPhys)
			.PhysAvail=ByteToMB(p_MemInf.ullAvailPhys)
			.Phys_Used=.PhysTotal - .PhysAvail
			.SwapTotal=ByteToMB(p_MemInf.ullTotalPageFile)
			.SwapAvail=ByteToMB(p_MemInf.ullAvailPageFile)
			.Swap_Used=.SwapTotal - .SwapAvail
		End With 
	Else ' on 95/98/Millenium use old function (the new doesn't exist on this systems yet)
		Dim p_MemInf As MEMORYSTATUS
		p_MemInf.dwLength=Len(p_MemInf)
		GlobalMemoryStatus(@p_MemInf) 
		
		With MemInf
			.PhysTotal=ByteToMB(p_MemInf.dwTotalPhys)
			.PhysAvail=ByteToMB(p_MemInf.dwAvailPhys)
			.Phys_Used=.PhysTotal - .PhysAvail
			.SwapTotal=ByteToMB(p_MemInf.dwTotalPageFile)
			.SwapAvail=ByteToMB(p_MemInf.dwAvailPageFile)
			.Swap_Used=.SwapTotal - .SwapAvail
		End With 
	EndIf
	
	With AlgInf
		.Sys=GetWindowsVersion()
		.Runtime = Fix(((GetTickCount/1000)/60)/60) & " hours"
	End With
End Sub
