#Include Once "noise.bi"
#Include Once "NoiseFactory.bi"
'define a standart interface for the Noise Filters
Type INoiseFilter extends object
	Declare virtual Function eval(x As Double,y As Double) As double
	Declare virtual Function eval(x As Double,y As Double,z As double) As double
	Declare virtual Function eval(x As Double,y As Double,z As Double,w As Double) As double
	value As Double
	Settings As NoiseSettings Ptr
	noise As INoise Ptr
End Type
Function INoiseFilter.eval(x As Double,y As Double) As double
	Return value
End Function
Function INoiseFilter.eval(x As Double,y As Double,z As Double) As double
	Return value
End Function
Function INoiseFilter.eval(x As Double,y As Double,z As Double,w As Double) As double
	Return value
End Function



'The Classic Perlin
Type NormalNoiseFilter extends INoiseFilter
	Declare Constructor(NS As NoiseSettings Ptr)
	Declare Destructor()
	Declare Function eval(x As Double,y As Double) As Double
	Declare Function eval(x As Double,y As Double,z As double) As Double
	'Settings As NoiseSettings
	'noise As INoise Ptr

End Type
Constructor NormalNoiseFilter(NS As NoiseSettings ptr)
Settings = NS
noise = NoiseFactory.CreateNoise(NS)

End Constructor
Destructor NormalNoiseFilter()
Delete noise

End Destructor

Function NormalNoiseFilter.eval(x As Double,y As Double,z As Double) As double
	Dim amplitude As Double = 1'Settings->strength
	Dim weight As Double = 1
	Dim v As Double
	dim frequency As Double=Settings->baseRoughness
	dim strength As Double=Settings->strength
	Dim min As Double = DBL_MAX
	Dim max As Double = DBL_MIN
	value=0
	For i As UInteger=0 To Settings->octaves-1
		v=((noise->noise(x*frequency+Settings->CenterX,y*frequency+Settings->CenterY,z*frequency+Settings->CenterZ)))
		v=(v+1)*0.5
		'v*=v
		v*=weight
		weight=v*Settings->weightMult
		value+=v*amplitude'*strength 
		frequency*=Settings->roughness
		amplitude*=Settings->persistence
		If value<min Then min=value
		If value>max Then max=value
	Next
	'value/=(max-min)
	'value/=(Settings->octaves)
	'If Settings->mask_enable=TRUE Then
	'	value*=Settings->minValue
	'EndIf
	'value = IIf((value>Settings->minValue),value,Settings->minValue)
	'value*=Settings->strength
'	value+=Settings->planetsize
'value=IIf(Settings->negateValue,-value,value)
	Return value'*Settings->negateValue'*Settings->strength
End Function
Function NormalNoiseFilter.eval(x As Double,y As Double) As double
	Dim amplitude As Double = 1'Settings->strength
	Dim weight As Double = 1
	Dim v As Double
	dim frequency As Double=Settings->baseRoughness
	dim strength As Double=Settings->strength
	Dim min As Double = DBL_MAX
	Dim max As Double = DBL_MIN
	value=0
	For i As UInteger=0 To Settings->octaves-1
		v=((noise->noise(x*frequency+Settings->CenterX,y*frequency+Settings->CenterY,0)))'+1.0
		'v=(v+1)*0.5
		'v*=v
		v*=weight
		weight=v
		value+=v*amplitude'*strength
		frequency*=Settings->roughness
		amplitude*=Settings->persistence
		If value<min Then min=value
		If value>max Then max=value
	Next
	value = IIf(value>Settings->minValue,value,Settings->minValue)
	Return value/(Settings->octaves+1)
End Function


'A Rigid Filter
Type RigidNoiseFilter extends INoiseFilter
	Declare Constructor(NS As NoiseSettings Ptr)
	Declare Destructor()
	Declare function eval(x As Double,y As double) As double
	Declare function eval(x As Double,y As Double,z As double) As double

	Settings As NoiseSettings ptr
	noise As INoise ptr

End Type
Constructor RigidNoiseFilter(NS As NoiseSettings Ptr)
Settings = NS
noise = NoiseFactory.CreateNoise(NS)
End Constructor
Destructor RigidNoiseFilter()
Delete noise
End Destructor
Function RigidNoiseFilter.eval(x As Double,y As Double) As Double
	Dim amplitude As Double = 1'Settings->strength
	Dim weight As Double = 1
	Dim v As Double
	dim frequency As Double=Settings->baseRoughness
	dim strength As Double=Settings->strength
	Dim min As Double = DBL_MAX
	Dim max As Double = DBL_MIN
	value=0
	For i As UInteger=0 To Settings->octaves-1
		v=1.0-(Abs(noise->noise(x*frequency+Settings->CenterX,y*frequency+Settings->CenterY,0)))'+1.0
		'v=(v+1)*0.5
		v*=v
		v*=weight
		weight=v
		value+=v*amplitude'*strength
		frequency*=Settings->roughness
		amplitude*=Settings->persistence
		If value<min Then min=value
		If value>max Then max=value
	Next
	value = IIf(0>value-Settings->minValue,0,value-Settings->minValue)
	Return value/(Settings->octaves+1)
End Function
Function RigidNoiseFilter.eval(x As Double,y As Double,z As Double) As double
	Dim amplitude As Double = 1
	Dim weight As Double = 1.0
	Dim v As Double
	dim frequency As Double=Settings->baseRoughness
	Dim min As Double = DBL_MAX
	Dim max As Double = DBL_MIN
	value=0
	For i As UInteger=0 To Settings->octaves-1
		v=Abs((noise->noise(x*frequency+Settings->CenterX,y*frequency+Settings->CenterY,z*frequency+Settings->CenterZ)))
		'v=(v+1)*0.5
		v*=v
		v*=weight
		weight=v*Settings->weightMult
		value+=v*amplitude'*Settings->strength
		frequency*=Settings->roughness
		amplitude*=Settings->persistence
		If value<min Then min=value
		If value>max Then max=value
	Next
	'value/=Settings->octaves
	value = IIf((value>Settings->minValue),value,Settings->minValue)
	'value=map(value,min,max,0,1)
	'value*=Settings->strength
'	value+=Settings->planetsize
	'value/=(Settings->octaves)
	'value^=(Settings->octaves)
'value=IIf(Settings->negateValue,-value,value)

	Return value
End Function
















