Type control_t
	key As Integer
	action_txt As ZString*32
End Type

Type binding_t
	nr_sections As Integer
	ReDim keys(512) As control_t
End Type
Dim Shared keys As binding_t
Function BindKey(section As Integer=0,key As Integer,action As Integer,text As ZString Ptr,bindings As binding_t=keys) As boolean
	If (section*512+action) > (bindings.nr_sections*512+512) Then Return FALSE
	bindings.keys(section*512+action).key=key
	bindings.keys(section*512+action).action_txt=*text
	Return true
End Function
Function KeyGetKey(section As Integer,action As Integer,bindings As binding_t=keys) As Integer
	If (section*512+action) > (bindings.nr_sections*512+512) Then Return -1
	Return bindings.keys(section*512+action).key
End Function
Function KeyGetActionText(section As Integer,action As Integer,bindings As binding_t=keys) As ZString Ptr
	If (section*512+action) > (bindings.nr_sections*512+512) Then Return NULL
	Return @bindings.keys(section*512+action).action_txt
End Function
Function KeyGetAction(section As Integer,key As Integer,bindings As binding_t=keys) As Integer
	For i As UInteger=lBound(bindings.keys) To UBound(bindings.keys)
		If key=bindings.keys(i).key Then Return i
	Next
	Return -1
End Function
Function LoadKeyBindings(fname As ZString Ptr,bindings As binding_t=keys) As boolean
	Dim As FILE Ptr rgsFile = fopen(fName, "rt")
	Dim As Integer n,s,b,a
	Dim As Integer nset=0
	Dim As ZString*32 t
	Dim done As boolean=FALSE
	Dim As integer linenr=0

	if (rgsFile <> NULL) Then
		Dim As ZString*1024 buffer
		While Not done
			linenr+=1
			fgets(buffer, 256, rgsFile)
			buffer=LCase(buffer)
			If feof(rgsFile)<>0 Then done=TRUE

			if (buffer[0] = Asc("#") Or buffer[0] = Asc(!"\n")) Then Continue While
			Select Case(buffer[0])
				case ("n")
					If nset=0 Then
						If sscanf(buffer,"n %d",@n)=1 Then
							bindings.nr_sections=n+1
							ReDim bindings.keys((n+1)*512)
						Else
							printf(!"WARNING at line %d: number of sections not set!\nusing default value!\n\n",linenr)
						EndIf
					EndIf
				case ("s")
					If sscanf(buffer,"s %d",@s)<>1 Then
						printf(!"WARNING at line %d: no section is set!\nusing default section!\n\n",linenr)
					EndIf
					If s>n Then
						printf(!"ERROR at line %d: selected section is out of bound!\nABORT!\n\n",linenr)
						done=TRUE
					EndIf
				case ("b")
					If sscanf(buffer,"b %d,%d,%[^#\n\0]",@b,@a,t)=3 Then
						'Print "b",b,a,t
						BindKey(s,b,a,t,bindings)
					Else
						printf(!"WARNING at line %d: number of parameters not match!\nContinue with next line!\n\n",linenr)
					EndIf
				case ("r")
					If buffer[1]=Asc("_") Then
						If sscanf(buffer,"%s",@t)=1 Then
							If memcmp(@t,@!"r_screenres",strlen(t))=0 Then
								Print "set screenres"
							ElseIf memcmp(@t,@!"r_msaa",strlen(t))=0 Then
								Print "MSAA"
							EndIf

						Else
							printf(!"WARNING at line %d: number of parameters not match!\nContinue with next line!\n\n",linenr)
						EndIf
					EndIf
			End select
		Wend
	Else
		printf("File Not Found!\n")
		Return FALSE
	EndIf
	fclose(rgsFile)
	Return Not(done)
End Function

LoadKeyBindings("./data/config/keybindings.bnd",keys)
Print KeyGetKey(0,1)
Print *KeyGetActionText(0,1)
Print KeyGetAction(0,52)
Print *KeyGetActionText(1,KeyGetAction(0,52))
