#Include Once "arraylist.bi"
#Include Once "fps.bas"
#Include Once "star_tab.bi"
#Define AU 149600
#Define SOLZ 696


'four/1
'4.1.1
Function get_peak_frequency(temp As double) As Double
	Return 3000000/temp
End Function
Function get_rgb_peak_color(l As Double,a As UByte) As Double'RGB <0,255> <- lambda l <380,780> [nm]
	Dim As Double r,g,b
	if (l<380.0) Then
		r=     0.00
	elseif (l<400.0) Then
		r=0.05-0.05*sin(M_PI*(l-366.0)/ 33.0)
	ElseIf (l<435.0) Then
		r=     0.31*sin(M_PI*(l-395.0)/ 81.0)
	ElseIf (l<460.0) Then
		r=     0.31*sin(M_PI*(l-412.0)/ 48.0)
	ElseIf (l<540.0) Then
		r=     0.00
	ElseIf (l<590.0) Then
		r=     0.99*sin(M_PI*(l-540.0)/104.0)
	ElseIf (l<670.0) Then
		r=     1.00*sin(M_PI*(l-507.0)/182.0)
	ElseIf (l<730.0) Then
		r=0.32-0.32*sin(M_PI*(l-670.0)/128.0)
	else
		r=     0.00
	EndIf
	if (l<454.0) Then
		g=     0.00
	ElseIf (l<617.0) Then
		g=     0.78*sin(M_PI*(l-454.0)/163.0)
	else
		g=     0.00
	EndIf
	if (l<380.0)Then
		b=     0.00
	ElseIf (l<400.0) Then
		b=0.14-0.14*sin(M_PI*(l-364.0)/ 35.0)
	ElseIf (l<445.0) Then
		b=     0.96*sin(M_PI*(l-395.0)/104.0)
	ElseIf (l<510.0) Then
		b=     0.96*sin(M_PI*(l-377.0)/133.0)
	else
		b=     0.00
	endif
	Return RGBA(r*255,g*255,b*255,a)
End Function
'four/2
'4.2.1
Function get_hydrosphere_determination(basetemp As Double,isinouter As Integer) As Integer
	Dim res As Integer=0
	If basetemp>500 Then
		res=0
	ElseIf basetemp>370 And basetemp<=500 Then
		res=1
	ElseIf basetemp>245 And basetemp<=370 Then
		res=2
	ElseIf basetemp<=245 Then
		res=3
	ElseIf isinouter Then
		res=4
	EndIf
	Return res
End Function
'4.2.2
Function get_hydrosphere_extensivness(radius As Double,inlife As Integer,ininner As integer) As Double
	Dim r1 As UInteger=rndRange(1,10)
	Dim r2 As UInteger
	Dim res As Double=0
	If ininner=1 And inlife<>0 Then
		r1+=1
	EndIf
	If radius<2000 Then
		r2=0
	ElseIf radius>=2000 And radius<4000 Then
		r2=1
	ElseIf radius>=4000 And radius<7000 Then
		r2=2
	ElseIf radius>=7000 Then
		r2=3
	EndIf

	Select Case r1
		Case r1=1
			res=0
		case r1=2
			If r2>=2 And r2<=3 Then res=rndRange(1,10)+rndRange(1,10)
		Case r1=3
			If r2=1 Then
				res=rndRange(1,10)
			ElseIf r2=2 Then
				res=20+rndRange(1,10)
			ElseIf r2=3 Then
				res=20+rndRange(1,10)+rndRange(1,10)
			EndIf
		Case r1=4
			If r2=1 Then
				res=rndRange(1,10)
			ElseIf r2=2 Then
				res=30+rndRange(1,10)
			ElseIf r2=3 Then
				res=40+rndRange(1,10)+rndRange(1,10)
			EndIf
		Case r1=5
			If r2=1 Then
				res=10+rndRange(1,10)
			ElseIf r2=2 Then
				res=40+rndRange(1,10)
			ElseIf r2=3 Then
				res=60+rndRange(1,10)
			EndIf
		Case r1=6
			If r2=0 Then
				res=rndRange(1,10)
			ElseIf r2=1 Then
				res=20+rndRange(1,10)
			ElseIf r2=2 Then
				res=50+rndRange(1,10)
			ElseIf r2=3 Then
				res=70+rndRange(1,10)
			EndIf
		Case r1=7
			If r2=0 Then
				res=rndRange(1,10)
			ElseIf r2=1 Then
				res=30+rndRange(1,10)
			ElseIf r2=2 Then
				res=60+rndRange(1,10)
			ElseIf r2=3 Then
				res=80+rndRange(1,10)
			EndIf
		Case r1=8
			If r2=0 Then
				res=10+rndRange(1,10)
			ElseIf r2=1 Then
				res=40+rndRange(1,10)
			ElseIf r2=2 Then
				res=70+rndRange(1,10)
			ElseIf r2=3 Then
				res=90+rndRange(1,10)
			EndIf
		Case r1=9
			If r2=0 Then
				res=rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)
			ElseIf r2=1 Then
				res=50+rndRange(1,10)
			ElseIf r2=2 Then
				res=80+rndRange(1,10)+rndRange(1,10)
			ElseIf r2=3 Then
				res=100
			EndIf
		Case r1=10
			If r2=0 Then
				res=10+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)
			ElseIf r2=1 Then
				res=10+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)+rndRange(1,10)
			ElseIf r2=2 Then
				res=100
			ElseIf r2=3 Then
				res=100
			EndIf

	end select
	Return res
End Function
'4.2.3
Function get_wather_vapor_factor(basetemp As Double,hydrosphere_percent As double) As Double
	Dim res As Double=(basetemp-240)/100*hydrosphere_percent*rndRange(1,10)
	If res<=0 Then res=0
	Return res
End Function
'4.3.1
Function get_special_base_atmosphere() As String
	Dim res As String
	Dim r As UInteger=Int(Rnd*12)
	res+=gases_short_names(r)+","
	For i As UInteger=1 To 3
		res+=gases_short_names(r+i)+","
	Next
	Return res
End Function
Function get_atmospheric_basic_composition(base_temp As double) As String
	Dim res As String
	Dim r1 As UInteger=rndRange(1,10)
	If base_temp>400 Then
		If r1>=1 And r1<=4 Then
			res="N2,CO2,"
		ElseIf r1>=5 And r1<=6 Then
			res="CO2,"
		ElseIf r1>=7 And r1<=8 Then
			res="NO2,SO2,"
		ElseIf r1=9 Then
			res="SO2,"
		ElseIf r1=10 Then
			res=get_special_base_atmosphere()
		EndIf
	ElseIf base_temp>=240 And base_temp<=400 Then
		If r1>=1 And r1<=4 Then
			res="N2,CO2,"
		ElseIf r1>=5 And r1<=6 Then
			res="CO2,"
		ElseIf r1>=7 And r1<=8 Then
			res="N2,CH4,"
		ElseIf r1=9 Then
			res="CO2,CH4,NH3,"
		ElseIf r1=10 Then
			res=get_special_base_atmosphere()
		EndIf
	ElseIf base_temp>=150 And base_temp<240 Then
		If r1>=1 And r1<=4 Then
			res="N2,CO2,"
		ElseIf r1>=5 And r1<=6 Then
			res="CO2,"
		ElseIf r1>=7 And r1<=8 Then
			res="N2,CH4,"
		ElseIf r1=9 Then
			res="H2,He,"
		ElseIf r1=10 Then
			res=get_special_base_atmosphere()
		EndIf
	ElseIf base_temp>=50 And base_temp<150 Then
		If r1>=1 And r1<=4 Then
			res="N2,CH4,"
		ElseIf r1>=5 And r1<=6 Then
			res="H2,He,N2,"
		ElseIf r1>=7 And r1<=8 Then
			res="N2,CO,"
		ElseIf r1=9 Then
			res="He,H2,"
		ElseIf r1=10 Then
			res=get_special_base_atmosphere()
		EndIf
	ElseIf base_temp<50 Then
		If r1>=1 And r1<=4 Then
			res="H2,"
		ElseIf r1>=5 And r1<=6 Then
			res="He,"
		ElseIf r1>=7 And r1<=8 Then
			res="He,H2,"
		ElseIf r1=9 Then
			res="Ne,"
		ElseIf r1=10 Then
			res=get_special_base_atmosphere()
		EndIf
	EndIf
	Return res
End Function
'4.3.2
'todo
Function retain_gases(main_gases As String,base_surface_temp As Double, escape_vel As Double) As String
	Dim e As Double=0.02783*base_surface_temp/(escape_vel*escape_vel)
	Dim res As String
	Dim As UInteger pos1,pos2,gas_nr
	pos1=1
	For i As UInteger=1 To Len(main_gases)
		If Mid(main_gases,i,1)="," Then
			'Print Mid(main_gases,pos1,(i)-pos1)
			For j As UInteger=0 To 14
				If Mid(main_gases,pos1,(i)-pos1)=(gases_short_names(j)) Then
					gas_nr=j
					If gases_mol_weight(gas_nr)>e Then
						res+=gases_short_names(gas_nr)+","
					EndIf
					Exit for
				EndIf
			Next
			pos1=i+1
		EndIf
	Next
	Return res
End Function






Type stellar_object_t extends object
	orbit As Double
	orbit_inclination As double
	orbit_periode As Double
	radius As Double
	mass As Double
	exentry As Double
	rotation_periode As Double
	posi As Vector3
	parrent As stellar_object_t Ptr
	childs As arrayList
	typ As UInteger'sun/planet/moon...
	seed As UInteger
	'Declare Sub render(c As cameras,m As object3d Ptr)
	Declare Sub update_pos(pivot As Vector3,epoch As Double,r As Double)

End Type

Type planet_tf As planet_t
Type moon_t extends stellar_object_t
	moon_type As UInteger
	density As Double
	gravity As Double
	axial_tilt As Double
	escape_velocity As Double
	roche_limit As Double
	tidal_lock As Double
	tidal_locked As boolean
	core_type As Integer
	tectonic_activity As Double
	tectonic As Integer
	magnetic_factor As Double
	magnetic_field As Double
	paek_frequency As double
	parrent As planet_tf Ptr
	Declare Destructor()
	Declare Sub generate_moon(inner As Double,hab_min As Double,hab_max As Double,abudance As Integer,age As Double,lum As Double,ma As Double,d As Double,o As Double,r As Double,tidal_lock As boolean)
'	Declare Sub render(c As cameras,m As object3d Ptr)
	Declare Sub update_pos(pivot As Vector3,epoch As Double,r As Double)
End Type
Destructor moon_t()
'
End Destructor
Type star_tf As star_t
Type planet_t extends stellar_object_t
	planet_type As UInteger
	orbit_type As UInteger
	orbit_both As boolean
	axial_tilt As Double
	gravity As Double
	escape_velocity As Double
	density As Double
	tidal_lock As Double
	tidal_locked As boolean
	core_type As Integer
	tectonic_activity As Double
	tectonic As Integer
	magnetic_factor As Double
	magnetic_field As Double
	base_temperature As Double
	paek_frequency As double
	habitable As boolean
	solar_day As Double
	nr_moons As uInteger
	moon As moon_t Ptr
	parrent As star_tf ptr
	Declare Destructor()
	Declare Sub generate_planet(inner As Double,hab_min As Double,hab_max As Double,abudance As Integer,age As Double,lum As Double,ma As Double)
	Declare Sub delete_moons()
	Declare Sub create_moons(n As uInteger)
	Declare Sub remove_moons(r As Double)
'	Declare Sub render(c As cameras,m As object3d Ptr)
	Declare Sub update_pos(pivot As Vector3,epoch As Double)
	Declare Sub update_planet_orbits(binar As boolean,o As double)
End Type
Destructor planet_t()
'If nr_moons>0 Then
'Delete [] moon
'EndIf
End Destructor
Type star_t extends stellar_object_t
	star_type As ZString*256
	star_class As UInteger
	star_specification As UInteger
	temperature As Double
	luminousity As Double
	radius As Double
	age As Double
	life_span As Double
	abudance As Integer
	inner_zone As Double
	habitable_zone_min As Double
	habitable_zone_max As Double
	modifier As Integer
	nr_planets As UInteger
	planet As planet_t Ptr
	bary_center As double
	paek_frequency As double

	Declare Destructor()
	Declare Sub generate_star()
	Declare Sub delete_planets()
	Declare Sub create_planets(n As UInteger)
	Declare Sub remove_planets(hot As Double,binar As boolean,o As double)
	Declare Sub update_planet_orbits(binar As boolean,o As Double,m As Double)
'	Declare Sub render(c As cameras,m As object3d Ptr)
	Declare Sub update_pos(pivot As Vector3,epoch As Double)
End Type
Destructor star_t()
'If nr_planets>0 Then
'Delete [] planet
'EndIf
End Destructor
Type system_t extends stellar_object_t
	nr_stars As UInteger
	sys_name As ZString*256
	star As star_t Ptr
	stars As arrayList Ptr
	planets As arrayList Ptr
	moons As arrayList ptr
	posi As Vector3
	bary_center As Vector3
	Declare Destructor()
	Declare Sub generate_system(n As UInteger,p As Vector3)
	Declare Sub delete_stars()
	Declare Sub create_stars(n As UInteger)
	'Declare Sub render(c As cameras,m As object3d Ptr)
End Type
Destructor system_t()
'If nr_planets>0 Then
'Delete [] planet
'EndIf
End Destructor
Type sector_t
	'Declare Constructor()
	Declare Constructor(p As Vector3 Ptr)
	Declare Destructor()
	Declare Sub generate_systems(nr As UInteger)
	'Declare Sub render_sector(cam As cameras,m As object3d Ptr)
	Declare Sub update(dt As single)
	systems As arrayList Ptr'holds 9 objects from type system_t
	ships As arrayList Ptr'holds the ships in the sector
	stations As arrayList Ptr 'holds the stations in the sector
	connects_to As arrayList Ptr
	connects_from As arrayList Ptr
	position As Vector3 Ptr
	size As Double
	kelvin As Double
	epoch As Double
	seed As Double
	bary_center As Vector3
	known As boolean
End Type
'Constructor sector_t
'
'End Constructor
Constructor sector_t(p As Vector3 ptr)
systems = New arrayList()
connects_to = New arrayList()
connects_from = New arrayList()
position = New Vector3(0,0,0)'p
known=FALSE
seed=Rnd*&Hffffffff
epoch=Rnd*&Hffffffff+seed
End Constructor

Destructor sector_t()
Delete position
If systems->count>0 Then
	For i As UInteger=0 To systems->count-1
		'systems->delete_stars()
		systems->removeLast()
	Next
	Delete systems
EndIf
If connects_to->count>0 Then
	For i As UInteger=0 To connects_to->count-1
		connects_to->removeLast()
	Next
	Delete connects_to
EndIf
If connects_from->count>0 Then
	For i As UInteger=0 To connects_from->count-1
		connects_from->removeLast()
	Next
	Delete connects_from
EndIf
End Destructor
Sub sector_t.generate_systems(nr As UInteger)
	Dim s As system_t Ptr
	Dim nr_stars As UInteger=nr
'	For i As UInteger=0 To nr-1
		Dim r As UInteger=rndRange(1,10)
		If r>=7 Then nr_stars=2
		s=New system_t
				s->posi = *position'+Vector3((0.5-rnd)*0.10,(0.5-rnd)*0.10,(0.5-rnd)*0.10)
				s->bary_center = Vector3(0,0,0)'*position'+Vector3((0.5-rnd)*0.10,(0.5-rnd)*0.10,(0.5-rnd)*0.10)
				s->seed=Int(Rnd*&h7fffffff)
		s->generate_system(nr_stars,s->posi)
		kelvin+=s->star->temperature
		systems->Add(s)
'	Next
	kelvin/=nr_stars
	size=10
	If s->star[0].nr_planets>0 Then
		size=s->star[0].planet[s->star[0].nr_planets-1].orbit
		If s->nr_stars>1 then
			If s->star[1].nr_planets>0 Then
				If s->star[1].planet[s->star[1].nr_planets-1].orbit>size Then
					size=s->star[1].planet[s->star[1].nr_planets-1].orbit
				EndIf
			EndIf
		endif
	EndIf

	bary_center=Vector3(0,0,0)'s->star[0].bary_center)
End Sub
'Sub sector_t.render_sector(c As cameras,m As object3d Ptr)
'	Dim s As system_t Ptr
'	Dim col As UInteger
'	'epoch+=dt
'	'For i As UInteger=0 To systems->count-1
'	s=systems->Get(0)
'	'c.lookat(s->posi,Vector3(0,1,0))
'	'If systems->count>0 Then
'	'For i As UInteger=0 To systems->count-1
'	's=systems->Get(i)
'	If s->nr_stars>1 Then
'		'c=Temperature2RGB(s->star[(Timer*5)Mod s->nr_stars].temperature)
'		'drawPoint3d(cam,m->objectSpaceToWorldSpace( s->posi ),1,c)
'		For j As UInteger=0 To s->nr_stars-1
'			s->star[j].render(c,m)
'			s->star[j].update_pos(s->bary_center,epoch)
'			If s->star[j].nr_planets>0 Then
'				For k As UInteger=0 To s->star[j].nr_planets-1
'					s->star[j].planet[k].render(c,m)
'					If s->star[j].planet[k].orbit_both=TRUE Then
'						s->star[j].planet[k].update_pos(s->bary_center,epoch)
'					Else
'						s->star[j].planet[k].update_pos(s->star[j].posi,epoch)
'					EndIf
'					If s->star[j].planet[k].nr_moons>0 Then
'						For l As UInteger=0 To s->star[j].planet[k].nr_moons-1
'							s->star[j].planet[k].moon[l].render(c,m)
'							s->star[j].planet[k].moon[l].update_pos(s->star[j].planet[k].posi,epoch,s->star[j].planet[k].radius)
'						Next
'					EndIf
'				Next
'			endif
'		Next
'	Else
'		s->star[0].render(c,m)
'		's->star[0].update_pos(bary_center,epoch)
'		If s->star[0].nr_planets>0 Then
'			For k As UInteger=0 To s->star[0].nr_planets-1
'				s->star[0].planet[k].render(c,m)
'				s->star[0].planet[k].update_pos(s->bary_center,epoch)
'				If s->star[0].planet[k].nr_moons>0 Then
'					For l As UInteger=0 To s->star[0].planet[k].nr_moons-1
'						s->star[0].planet[k].moon[l].render(c,m)
'						s->star[0].planet[k].moon[l].update_pos(s->star[0].planet[k].posi,epoch,s->star[0].planet[k].radius)
'					Next
'				EndIf
'			Next
'		endif
'	EndIf
'	drawPixel3d(c,m->objectSpaceToWorldSpace( s->bary_center ),2,&hffff0000)
'
'	'Next
'	'endif
'End Sub
'Sub star_t.render(c As cameras,m As object3d ptr)
'	Dim col As UInteger=Temperature2RGB(temperature,127)
'	Dim col1 As UInteger=&hff333333
'	Dim p As Vector3=m->objectSpaceToWorldSpace( posi )
'	Dim p1 As Vector3=m->objectSpaceToWorldSpace( Vector3(-radius/2,-radius,0) )
'	drawPoint3d(c,p,(radius*SOLZ ),col)
'	drawText3dshadowed(c,p+p1,star_type,col,col1,8)
'	'drawCircle3d(c,bary_center,orbit,0,360,&hff333333)
'	'drawText3d(c,p+p1,star_type,col)
'End Sub
'Sub planet_t.render(c As cameras,m As object3d ptr)
'	Dim col As UInteger=planet_type_colors(planet_type )'Temperature2RGB(base_temperature*4)
'	Dim col1 As UInteger=&hff333333
'	Dim p As Vector3=m->objectSpaceToWorldSpace( posi )
'	Dim p1 As Vector3=m->objectSpaceToWorldSpace( Vector3(-radius/2,-radius,0) )
'	drawPoint3d(c,p,radius,col)
'	If habitable Then
'		drawPoint3d(c,p,radius/2,&hff00ff00)
'	EndIf
'	drawText3dshadowed(c,p+p1,planet_class_str(planet_type),col,col1,8)
'	'drawCircle3d(c,bary_center,orbit,0,360,&hff333333)
'	'drawText3d(c,p,planet_class_str(planet_type),col)
'End Sub
'Sub moon_t.render(c As cameras,m As object3d Ptr)
'	Dim col As UInteger=&hff333333'Temperature2RGB(2000)
'	Dim col1 As UInteger=&hff333333
'	Dim p As Vector3=m->objectSpaceToWorldSpace( posi )
'	Dim p1 As Vector3=m->objectSpaceToWorldSpace( Vector3(-radius/2,-radius,0) )
'	drawPoint3d(c,p,radius,moon_type_colors(moon_type ))
'	drawText3dshadowed(c,p+p1,moon_class_str(moon_type),col,col1,8)
'	'drawText3d(c,p,moon_class_str(moon_type),col)
'End Sub
Sub sector_t.update(dt As Single)
		epoch+=dt
End Sub
Sub star_t.update_pos(pivot As Vector3,epoch As Double)
	'posi=pivot+Vector3(Sin(radians(epoch/(orbit_periode)))*orbit*AU,0,cos(radians(epoch/(orbit_periode)))*orbit*AU)
End Sub
Sub planet_t.update_pos(pivot As Vector3,epoch As Double)
	'posi=pivot+Vector3(Sin(radians(epoch/(orbit_periode)))*orbit*AU,Sin(radians(epoch/(orbit_periode)))*(sin(radians(orbit_inclination))*orbit*AU),cos(radians(epoch/(orbit_periode)))*orbit*AU)
End Sub
Sub moon_t.update_pos(pivot As Vector3,epoch As Double,r As Double)
	'posi=pivot+Vector3(Sin(radians(epoch/(orbit_periode)))*(orbit*r),sin(radians(epoch/(orbit_periode)))*(sin(radians(orbit_inclination))*(orbit*r)),cos(radians(epoch/(orbit_periode)))*(orbit*r))
End Sub
Sub system_t.generate_system(n As UInteger,p As Vector3)
	'	If n>0 Then
	posi=p
	bary_center=Vector3(0,0,0)
	create_stars(n)
	Dim temperature As Double=0
	Dim r1 As UInteger=rndRange(1,100)
	Dim r2 As UInteger=rndRange(1,10)
	Dim r3 As UInteger=rndRange(0,9)
	Dim r4 As UInteger=rndRange(1,10)
	Dim r5 As UInteger=rndRange(0,star_class_e.nr_entrys-1)
	Dim c As Integer
	If r1=1 Then
		c=star_class_e.AV
		If r2>=7 Then c=star_class_e.AIV
	EndIf
	If r1>=2 And r1<=4 Then
		c=star_class_e.FV
		If r2>=9 Then c=star_class_e.FIV
	EndIf
	If r1>=5 And r1<=12 Then
		c=star_class_e.GV
		If r2=10 Then c=star_class_e.GIV
	EndIf
	If r1>=13 And r1<=26 Then
		c=star_class_e.KV
	EndIf
	'white dwarf
	If r1>=27 And r1<=36 Then
		c=star_class_e.WDVII
	EndIf
	If r1>=37 And r1<=85 Then
		c=star_class_e.AV
	EndIf
	'brown dwarf
	If r1>=86 And r1<=98 Then
		c=star_class_e.BD
	EndIf
	If r1=99 Then
		If r2=1 Then c=star_class_e.FIII
		If r2=2 Then c=star_class_e.GIII
		If r2>=3 And r2<=5 Then c=star_class_e.KIII
		If r2>=6 And r2<=7 Then c=star_class_e.MIII
		If r2>=8 Then c=star_class_e.KIV
	EndIf
	'special
	If r1=100 Then c=rndRange(star_class_e.S,star_class_e.nr_entrys-1)
	If c=star_class_e.S Then c=star_class_e.BV
	If nr_stars>0 Then
		star[0].star_class=c

		star[0].star_specification=r3
		star[0].temperature=star_temperatures(c,r3)
		star[0].luminousity=star_luminousity(c,r3)
		star[0].mass=star_mass(c,r3)
		star[0].radius=star_radius(c,r3)
		star[0].bary_center=0
		temperature+=star_temperatures(c,r3)
		star[0].star_type=star_class_str(star[0].star_class)&Str(star[0].star_specification)&star_size_code_str(star[0].star_class)
	EndIf
	If nr_stars>1 Then
		If r4<3 Then
			If r5<c Then
				star[1].star_class=c
				star[1].star_specification=r3
				star[1].temperature=star_temperatures(c,r3)
				star[1].luminousity=star_luminousity(c,r3)
				star[1].mass=star_mass(c,r3)
				star[1].radius=star_radius(c,r3)
				temperature+=star_temperatures(c,r3)
			Else
				r3=rndRange(0,9)
				star[1].star_class=r5
				star[1].star_specification=r3
				star[1].temperature=star_temperatures(r5,r3)
				star[1].luminousity=star_luminousity(r5,r3)
				star[1].mass=star_mass(r5,r3)
				star[1].radius=star_radius(r5,r3)
				temperature+=star_temperatures(r5,r3)
			EndIf
		Else
			'brown dwarf
			If r5>star_class_e.KIV Then
				r3=rndRange(0,9)
				star[1].star_class=star_class_e.BD
				star[1].star_specification=r3
				star[1].temperature=star_temperatures(star_class_e.BD,r3)
				star[1].luminousity=star_luminousity(star_class_e.BD,r3)
				star[1].mass=star_mass(star_class_e.BD,r3)
				star[1].radius=star_radius(star_class_e.BD,r3)
				temperature+=star_temperatures(star_class_e.BD,r3)
			Else
				r3=rndRange(0,9)
				star[1].star_class=r5
				star[1].star_specification=r3
				star[1].temperature=star_temperatures(r5,r3)
				star[1].luminousity=star_luminousity(r5,r3)
				star[1].mass=star_mass(r5,r3)
				star[1].radius=star_radius(r5,r3)
				temperature+=star_temperatures(r5,r3)
			EndIf
		EndIf
		'calculate star orbits
		If nr_stars>1 Then
			If star[0].mass<star[1].mass Then
				Swap star[0],star[1]
			EndIf
			r1=rndRange(1,10)
			Dim o As Double
			If r1>=1 And r1<=3 Then o=rndRange(1,2)*2
			If r1>=4 And r1<=6 Then o=rndRange(1,5)*3
			If r1>=7 And r1<=8 Then o=rndRange(1,10)*5
			If r1=9 Then o=rndRange(1,10)*20
			If r1=10 Then o=rndRange(1,10)*200
			star[0].bary_center=(1.0*(star[1].mass/(star[0].mass+star[1].mass)))
			star[0].orbit=o*(star[0].bary_center)'+o
			star[1].bary_center=(1.0-star[0].bary_center)'-(o-star[0].bary_center)'(o*(star[0].mass/(star[0].mass+star[1].mass)))
			star[1].orbit=-(o*(star[1].bary_center))'-o
			star[0].orbit_periode=Sqr((star[0].orbit*star[0].orbit*star[0].orbit)/(star[0].mass+star[1].mass))
			star[1].orbit_periode=Sqr((star[0].orbit*star[0].orbit*star[0].orbit)/(star[0].mass+star[1].mass))
			r1=rndRange(1,10)
			r2=rndRange(1,10)
			If r1>=1 And r1<=2 Then o=r2*0.01
			If r1>=3 And r1<=4 Then o=0.1+r2*0.01
			If r1>=5 And r1<=6 Then o=0.2+r2*0.01
			If r1>=7 And r1<=8 Then o=0.3+r2*0.01
			If r1=9  Then o=0.4+r2*0.01
			If r1=10  Then o=0.5+r2*0.04
			star[0].exentry=o
			star[0].inner_zone=4*Sqr(star[0].luminousity)
			star[1].exentry=o
			star[1].inner_zone=4*Sqr(star[0].luminousity)
		EndIf
		'star[1].delete_planets()
		'star[1].nr_planets=0
		star[1].star_type=star_class_str(star[1].star_class)&Str(star[1].star_specification)&star_size_code_str(star[1].star_class)
	EndIf

	For i As UInteger=0 To nr_stars-1
		If star[i].star_class=star_class_e.KIV Then star[i].star_specification=0
		'randomizing subgiants
		If star[i].star_class>=star_class_e.AIV And star[i].star_class<=star_class_e.KIV Then
			r1 =rndRange(1,10)
			star[i].mass*=rnd_subgiants_multiplier(0,r1)
			star[i].luminousity*=rnd_subgiants_multiplier(1,r1)
			star[i].radius= Sqr(star[i].luminousity)* ((5800/star[i].temperature)*(5800/star[i].temperature))
		EndIf
		'randomizing giants
		If star[i].star_class>=star_class_e.AIII And star[i].star_class<=star_class_e.MIII Then
			r1 =rndRange(1,10)
			star[i].mass*=rnd_giants_multiplier(0,r1)
			star[i].luminousity*=rnd_giants_multiplier(1,r1)
			star[i].radius= Sqr(star[i].luminousity)* ((5800/star[i].temperature)*(5800/star[i].temperature))
		EndIf
		'calculate the luminousity of withe and brown dwarfs
		If star[i].star_class>=star_class_e.WDVII And star[i].star_class<=star_class_e.BD Then
			star[i].luminousity=Abs((star[i].radius*star[i].radius)*(star[i].temperature*star[i].temperature*star[i].temperature*star[i].temperature)/(5800*5800*5800*5800))
		EndIf
		star[i].star_type=star_class_str(star[i].star_class)&Str(star[i].star_specification)&star_size_code_str(star[i].star_class)
	Next
	'calculate the system age
	For i As UInteger=0 To nr_stars-1
		star[i].life_span=10*(star[i].mass/star[i].luminousity)
		p=Vector3(star[i].bary_center,0,0)
		star[i].posi=Vector3Add(p,Vector3(Sin(timer)*star[i].orbit,0,cos(timer)*star[i].orbit))

		r1=rndRange(1,10)
		If star[i].star_class=star_class_e.AV Or star[i].star_class=star_class_e.AIV Or star[i].star_class=star_class_e.AIII Then
			If star[i].star_specification>=0 And star[i].star_specification<=4 Then
				star[i].age=system_age(2,r1)
				star[i].luminousity*=system_age_luminousity_modifier(2,r1)
			EndIf
			If star[i].star_specification>=5 And star[i].star_specification<=9 Then
				star[i].age=system_age(3,r1)
				star[i].luminousity*=system_age_luminousity_modifier(3,r1)
			EndIf
		EndIf
		If star[i].star_class=star_class_e.FV Or star[i].star_class=star_class_e.FIV Or star[i].star_class=star_class_e.FIII Then
			If star[i].star_specification>=0 And star[i].star_specification<=4 Then
				star[i].age=system_age(4,r1)
				star[i].luminousity*=system_age_luminousity_modifier(2,r1)
			EndIf
			If star[i].star_specification>=5 And star[i].star_specification<=9 Then
				star[i].age=system_age(5,r1)
				star[i].luminousity*=system_age_luminousity_modifier(3,r1)
			EndIf
		EndIf
		If star[i].star_class=star_class_e.GV Or star[i].star_class=star_class_e.GIV Or star[i].star_class=star_class_e.GIII Then
			If star[i].star_specification>=0 And star[i].star_specification<=4 Then
				star[i].age=system_age(6,r1)
				star[i].luminousity*=system_age_luminousity_modifier(2,r1)
			EndIf
			If star[i].star_specification>=5 And star[i].star_specification<=9 Then
				star[i].age=system_age(7,r1)
				star[i].luminousity*=system_age_luminousity_modifier(3,r1)
			EndIf
		EndIf
		If star[i].star_class=star_class_e.KV Or star[i].star_class=star_class_e.KIV Or star[i].star_class=star_class_e.KIII Then
			If star[i].star_specification>=0 And star[i].star_specification<=4 Then
				star[i].age=system_age(8,r1)
				star[i].luminousity*=system_age_luminousity_modifier(2,r1)
			EndIf
			If star[i].star_specification>=5 And star[i].star_specification<=9 Then
				star[i].age=system_age(9,r1)
				star[i].luminousity*=system_age_luminousity_modifier(3,r1)
			EndIf
		EndIf
		If star[i].star_class=star_class_e.MV Or star[i].star_class=star_class_e.MIII Then
			If star[i].star_specification>=0 And star[i].star_specification<=9 Then
				star[i].age=system_age(10,r1)
				star[i].luminousity*=system_age_luminousity_modifier(2,r1)
			EndIf
		EndIf
		If star[i].star_class=star_class_e.WDVII Then
			If star[i].star_specification>=0 And star[i].star_specification<=9 Then
				star[i].age=system_age(11,r1)
				star[i].luminousity*=system_age_luminousity_modifier(2,r1)
			EndIf
		EndIf
		If star[i].star_class=star_class_e.BD Then
			If star[i].star_specification>=0 And star[i].star_specification<=9 Then
				star[i].age=system_age(12,r1)
				star[i].luminousity*=system_age_luminousity_modifier(2,r1)
			EndIf
		EndIf
	Next

	If nr_stars>1 Then
		star[1].age=star[0].age
	EndIf
	'get the abudance
	For i As UInteger=0 To n-1
		r1=rndRange(1,10)+rndRange(1,10)+Int(star[i].age+0.5)
		If r1>=3 And r1<=9 Then star[i].abudance=2
		If r1>=10 And r1<=12 Then star[i].abudance=1
		If r1>=13 And r1<=18 Then star[i].abudance=0
		If r1>=19 And r1<=21 Then star[i].abudance=-1
		If r1>=22 Then star[i].abudance=-3
		star[i].habitable_zone_min=0.75*Sqr(star[i].luminousity)
		star[i].habitable_zone_max=1.4*Sqr(star[i].luminousity)
		'planetcreation
		r1=rndRange(1,10)
		If star[i].star_class=star_class_e.KV Then
			If star[i].star_specification>=5 And star[i].star_specification<=9 Then
				r1+=1
			EndIf
		EndIf
		If star[i].star_class=star_class_e.MV Then
			If star[i].star_specification>=0 And star[i].star_specification<=4 Then
				r1+=2
			EndIf
		EndIf
		If star[i].star_class=star_class_e.MV Then
			If star[i].star_specification>=5 And star[i].star_specification<=9 Then
				r1+=3
			EndIf
		EndIf
		If star[i].star_class=star_class_e.BD Then
			r1+=5
		EndIf
		r1+=star[i].abudance
		r2=0
		If r1=1 Then r2=rndRange(1,10)+10
		If r1>=2 And r1<=5 Then r2=rndRange(1,10)+5
		If r1>=6 And r1<=7 Then r2=rndRange(1,10)
		If r1>=8 And r1<=9 Then r2=rndRange(1,5)

		''		If r2>0 Then
		''create planet orbits
		'If nr_stars>0 Then
		'	star[i].create_planets(r2)
		'	If star[i].nr_planets>0 Then
		'		star[i].planet[0].orbit=0.05*(star[i].mass*star[i].mass)*rndRange(1,10)
		'		star[i].planet[0].orbit_inclination=0.33+rndRange(0,10)
		'		star[i].planet[0].generate_planet(star[i].inner_zone,star[i].habitable_zone_min,star[i].habitable_zone_max,star[i].abudance,star[i].age,star[i].luminousity,star[i].mass)
		'		star[i].planet[0].orbit_periode=Sqr((star[i].planet[0].orbit*star[i].planet[0].orbit*star[i].planet[0].orbit)/(star[i].mass+star[i].planet[0].mass))
		'		star[i].planet[0].posi=Vector3Add(star[i].planet[0].posi,Vector3(Sin(timer)*star[i].planet[0].orbit,0,Cos(timer)*star[i].planet[0].orbit))
		'		If star[i].nr_planets>1 Then
		'			For k As UInteger=1 To star[i].nr_planets-1
		'				star[i].planet[k].orbit=star[i].planet[k-1].orbit+1.1+(rndRange(1,10)*0.1)+0.1
		'				star[i].planet[k].orbit_inclination=0.33+rndRange(0,10)
		'				star[i].planet[k].generate_planet(star[i].inner_zone,star[i].habitable_zone_min,star[i].habitable_zone_max,star[i].abudance,star[i].age,star[i].luminousity,star[i].mass)
		'				star[i].planet[k].orbit_periode=Sqr((star[i].planet[k].orbit*star[i].planet[k].orbit*star[i].planet[k].orbit)/(star[i].mass+star[i].planet[k].mass))
		'				star[i].planet[k].posi=Vector3Add(star[i].posi,Vector3(Sin(timer)*star[i].planet[k].orbit/100,0,Cos(timer)*star[i].planet[k].orbit/100))
		'			Next
		'		EndIf
		'	EndIf
		'	'remove all planets in untentable orbits
		'	Dim hot As Double
		'	Dim bina As boolean=nr_stars>1
		'	If star[i].star_class>=star_class_e.WDVII And star[i].star_class<=star_class_e.BD Then
		'		r1=rndRange(1,10)
		'		If star[i].mass >=0.6 And star[i].mass<=0.9 Then r1+=2
		'		If star[i].mass>0.9 Then r1+=4
		'		If r1>=1 And r1<=4 Then hot=2
		'		If r1>=5 And r1<=8 Then hot=4
		'		If r1>=9 And r1<=11 Then hot=6
		'		If r1>=12 Then hot=10
		'		If bina Then hot*=2
		'		Dim o As Double
		'		Dim m As double
		'		If bina=TRUE Then
		'			o=(Abs(star[0].orbit)+Abs(star[1].orbit))
		'			m=star[0].mass+star[1].mass
		'		EndIf
		'		star[i].remove_planets(hot,bina,o)
		'		star[i].update_planet_orbits(bina,o,m)
		'	Else
		'		hot=0.025 * Sqr(star[0].luminousity)
		'		If bina Then hot=0.025 * Sqr(star[0].luminousity+star[1].luminousity)
		'		Dim o As Double
		'		Dim m As double
		'		If bina=TRUE Then
		'			o=(Abs(star[0].orbit)+Abs(star[1].orbit))
		'			m=star[0].mass+star[1].mass
		'		EndIf
		'		star[i].remove_planets(hot,bina,o)
		'		star[i].update_planet_orbits(bina,o,m)
		'	EndIf

		'EndIf
	Next

	sys_name=get_sysname(seed)
	'scale it down
	'Dim bina As boolean=nr_stars>1
	'If nr_stars>0 Then
	'	For i As UInteger=0 To n-1
	'		star[i].radius=Log(1+star[i].radius*696000 )
	'		Dim f As Integer=IIf(star[i].orbit<0,-1,1)
	'		star[i].orbit=Log(1+Abs(star[i].orbit)  )
	'		If f=-1 Then star[i].orbit=-star[i].orbit
	'		If star[i].nr_planets>0 Then
	'			For k As UInteger=0 To star[i].nr_planets-1
	'				star[i].planet[k].radius=Log(1+star[i].planet[k].radius)
	'				star[i].planet[k].orbit=Log(1+Abs(star[i].orbit  ))
	'				If star[i].planet[k].nr_moons>0 Then
	'					For l As UInteger=0 To star[i].planet[k].nr_moons-1
	'						star[i].planet[k].moon[l].radius=Log(1+star[i].planet[k].moon[l].radius)
	'						star[i].planet[k].moon[l].orbit=Log(1+Abs(star[i].planet[k].moon[l].orbit))'*star[i].planet[k].radius
	'					Next
	'				endif
	'				'Print "here",o
	'			Next
	'		endif
	'	Next
	'endif
End Sub
Sub system_t.delete_stars()
	If star<>0 Then
		For i As UInteger=0 To nr_stars-1
			'star[i].delete_planets()
		Next
		RL_FREE(star)
		star=0
	EndIf
	nr_stars=0
End Sub
Sub system_t.create_stars(n As UInteger)
	If n>0 Then
		If star=0 Then
			star=RL_Calloc(n,SizeOf(star_t))
		EndIf
	EndIf
	nr_stars=n
End Sub
Sub star_t.delete_planets()
	If planet<>0 Then
		For i As UInteger=0 To nr_planets-1
			'planet[i].delete_moons()
		Next
		RL_FREE(planet)
		planet=0
	EndIf
	nr_planets=0
End Sub
Sub star_t.create_planets(n As UInteger)
	If n>0 Then
		If planet=0 Then
			planet=RL_Calloc(n,SizeOf(planet_t))
		EndIf
	EndIf
	nr_planets=n
End Sub
Sub planet_t.delete_moons()
	If moon<>0 Then
		DeAllocate(moon)
		moon=0
	EndIf
	nr_moons=0
End Sub
Sub planet_t.create_moons(n As uInteger)
	If n>0 Then
		If moon=0 Then
			moon=Callocate(n,SizeOf(moon_t))
		EndIf
	EndIf
	nr_moons=n
End Sub

Sub star_t.remove_planets(hot As Double,binar As boolean,o As Double)
	Dim n As UInteger=nr_planets
	Dim p As planet_t Ptr=planet
	If binar=TRUE Then
		If n>0 Then
			While ( (p[0].orbit>=(o*(1+exentry)/3) And (p[0].orbit<=o*(1-exentry)*3))) Or (p[0].orbit<=radius) Or (p[0].orbit<hot)
				'While ( (p[0].orbit<=(o*(1-exentry)/3) And (p[0].orbit>=o*(1+exentry)*3))) Or (p[0].orbit<=radius) Or (p[0].orbit<hot)
				'While ((p[0].orbit>o/6) ) Or (p[0].orbit<=radius) Or (p[0].orbit<hot)
				If n=1 Then
					If p[0].nr_moons>0 Then
						DeAllocate(p[0].moon)
						p[0].moon=0
					EndIf
					DeAllocate(p)
					p=0
					n=0
					Exit While
				Else
					If n>1 Then
						If p[0].nr_moons>0 Then
							DeAllocate(p[0].moon)
							p[0].moon=0
						EndIf
						For j As UInteger=1 To n-1
							p[j-1]= p[j]
						Next
						n-=1
						p=ReAllocate(planet,(n)*SizeOf(planet_t))
					EndIf
				EndIf
				planet=p
			Wend
		EndIf
	Else
		If n>0 Then
			While (p[0].orbit<hot) Or (p[0].orbit<=radius)
				If n=1 Then
					If p[0].nr_moons>0 Then
						DeAllocate(p[0].moon)
						p[0].moon=0
					EndIf
					DeAllocate(p)
					p=0
					n=0
					Exit While
				Else
					If n>1 Then
						'Print "here",n,n-1
						If p[0].nr_moons>0 Then
							DeAllocate(p[0].moon)
							p[0].moon=0
						EndIf
						For j As UInteger=1 To n-1
							p[j-1]= p[j]
						Next
						n-=1
						p=ReAllocate(planet,(n)*SizeOf(planet_t))
					EndIf
				EndIf
				planet=p
			Wend
		EndIf
	EndIf
	planet=p
	nr_planets=n
End Sub
Sub planet_t.remove_moons(r As Double)
	Dim n As UInteger=nr_moons
	Dim p As moon_t Ptr=moon

	If n>0 Then
		While (p[0].orbit<=radius)
			If n=1 Then
				DeAllocate(p)
				p=0
				n=0
				Exit While
			Else
				If n>1 Then
					'Print "here",n,n-1
					For j As UInteger=1 To n-1
						p[j-1]= p[j]
					Next
					n-=1
					p=ReAllocate(moon,(n)*SizeOf(moon_t))
				EndIf
			EndIf
			moon=p
		Wend
	EndIf
	moon=p
	nr_moons=n
End Sub
Sub star_t.update_planet_orbits(binar As boolean,o As Double,m As Double)
	If binar=TRUE Then
		If nr_planets>0 Then
			For i As UInteger=0 To nr_planets-1
				If (planet[i].orbit>((orbit*(1-exentry))/3)) Then
					planet[i].orbit_both=TRUE
					planet[i].orbit+=o
					planet[i].orbit_periode=Sqr((planet[i].orbit*planet[i].orbit*planet[i].orbit)/(m+planet[i].mass))
				Else
					planet[i].orbit_both=FALSE
				EndIf
			Next
		EndIf
	EndIf
End Sub
Sub planet_t.update_planet_orbits(binar As boolean,o As Double)
	If binar=TRUE Then
		If (orbit>((orbit*(1+exentry))/3)) Then
			orbit_both=TRUE
			orbit+=o
		Else
			orbit_both=FALSE
		EndIf
	EndIf
End Sub
Sub planet_t.generate_planet(inner As Double,hab_min As Double,hab_max As Double,abudance As Integer,age As Double,lum As Double,ma As Double)
	Dim r1 As Integer=rndRange(1,100)
	Dim r2 As Integer=rndRange(1,10)
	'get planet type
	If orbit<=inner Then
		If r1>=1 And r1<=21 Then planet_type=planet_class.asteorid
		If r1>=22 And r1<=72 Then planet_type=planet_class.terestrial
		If r1>=73 And r1<=82 Then planet_type=planet_class.chunk
		If r1>=83 And r1<=94 Then planet_type=planet_class.giant
		If r1>=95 And r1<=99 Then planet_type=planet_class.jovian
		If r1>=100 Then
			r1=rndRange(planet_class.terestrial,planet_class.giant)
			planet_type=r1
		EndIf
	Else
		If r1>=1 And r1<=17 Then planet_type=planet_class.asteorid
		If r1>=18 And r1<=27 Then planet_type=planet_class.terestrial
		If r1>=28 And r1<=40 Then planet_type=planet_class.chunk
		If r1>=41 And r1<=89 Then planet_type=planet_class.giant
		If r1>=90 And r1<=99 Then planet_type=planet_class.jovian
		If r1>=100 Then
			r1=rndRange(planet_class.terestrial,planet_class.giant)
			planet_type=r1
		EndIf
	EndIf
	If planet_type>=planet_class.terestrial And planet_type<=planet_class.giant Then
		radius=planet_size(planet_type-1,r2)+rndRange(1,10)*planet_size_modifier(planet_type-1,r2)
	EndIf
	If planet_type>=planet_class.jovian Then
		r2=rndRange(1,10)
		If r2>=1 And r2<=4 Then mass=500+rndRange(1,10)*50
		If r2>=5 And r2<=7 Then mass=1000+rndRange(1,10)*100
		If r2>=8 And r2<=9 Then mass=2000+rndRange(1,10)*100
		If r2>=10 Then mass=3000+rndRange(1,10)*100
		radius=60000+(rndRange(1,10)-0.5*age)*2000
	EndIf
	If orbit<=inner Then
		If planet_type>=planet_class.asteorid Then density=0.3+rndRange(1,10)*(0.127/(0.4+(orbit/Sqr(lum)))^0.67)
		If planet_type>=planet_class.chunk Then density=0.3+rndRange(1,10)*(0.127/(0.4+(orbit/Sqr(lum)))^0.67)
		If planet_type>=planet_class.terestrial Then density=0.3+rndRange(1,10)*(0.127/(0.4+(orbit/Sqr(lum)))^0.67)
		If planet_type>=planet_class.giant Then density=0.1+rndRange(1,10)*0.025
		mass=((radius/6380)*(radius/6380)*(radius/6380))*density
	Else
		If planet_type>=planet_class.asteorid Then density=0.1+rndRange(1,10)*0.05
		If planet_type>=planet_class.chunk Then density=0.1+rndRange(1,10)*0.05
		If planet_type>=planet_class.terestrial Then density=0.1+rndRange(1,10)*0.05
		If planet_type>=planet_class.giant Then density=0.08+rndRange(1,10)*0.025
		mass=((radius/6380)*(radius/6380)*(radius/6380))*density
	EndIf
	gravity=mass/((radius/6380)*(radius/6380))
	escape_velocity=Sqr(19600 * gravity * radius)/11200
	tidal_lock=(ma*26640000)/((orbit*400)*(orbit*400)*(orbit*400))
	tidal_locked=IIf((0.83+rndRange(1,10)*0.03)*tidal_lock*age/6.6>1.0,TRUE,FALSE)
	r1=rndRange(1,10)
	If r1>=1 And r1<=5 Then exentry=0.005*rndRange(1,10)
	If r1>=6 And r1<=7 Then exentry=0.05+0.01*rndRange(1,10)
	If r1>=8 And r1<=9 Then exentry=0.15+0.01*rndRange(1,10)
	If r1>=10 Then exentry=0.25+0.04*rndRange(1,10)
	If tidal_locked=FALSE Then
		r1=rndRange(1,10)
		If r1>=1 And r1<=2 Then axial_tilt=rndRange(1,10)
		If r1>=3 And r1<=4 Then axial_tilt=10+rndRange(1,10)
		If r1>=5 And r1<=6 Then axial_tilt=20+rndRange(1,10)
		If r1>=7 And r1<=8 Then axial_tilt=30+rndRange(1,10)
		If r1>=9 And r1<=10 Then axial_tilt=40+rndRange(1,100)*1.4
	EndIf
	If tidal_locked=FALSE Then
		r1=rndRange(1,10)
		Dim modif As Double=tidal_lock*age
		If planet_type=planet_class.terestrial Then
			If mass>4 Then modif-=2
			If r1>=1 And r1<=5 Then rotation_periode=10+rndRange(1,10)*2
			If r1>=6 And r1<=8 Then rotation_periode=30+rndRange(1,100)
			If r1>=9 And r1<=10 Then rotation_periode=rndRange(1,100)*2*24
		EndIf
		If planet_type=planet_class.chunk Then
			If r1>=1 And r1<=5 Then rotation_periode=rndRange(1,10)*2
			If r1>=6 And r1<=8 Then rotation_periode=10+rndRange(1,10)*24
			If r1>=9 And r1<=10 Then rotation_periode=20+rndRange(1,100)*24
		EndIf
		If planet_type=planet_class.giant Or planet_type=planet_class.jovian Then
			If mass<50 Then modif+=2
			If r1>=1 And r1<=5 Then rotation_periode=6+rndRange(1,5)
			If r1>=6 And r1<=7 Then rotation_periode=11+rndRange(1,5)
			If r1>=8 And r1<=9 Then rotation_periode=16+rndRange(1,10)
			If r1>=10 Then rotation_periode=26+rndRange(1,10)
		EndIf
		rotation_periode*=(1.0+(0.1*modif))
	EndIf
	solar_day= 1.0/((1.0/rotation_periode)-(1.0/orbit_periode))
	'create the core and mantle
	If planet_type>=planet_class.terestrial And planet_type<=planet_class.chunk Then
		If orbit<=inner Then
			If density>=0.4 And density<0.7 Then core_type=core_class.SI_smetal
			If density>=0.7 And density<1.0 Then core_type=core_class.FENI_mmetal
			If density>=1.0 And density<=1.3 Then core_type=core_class.FENI_lmetal
		Else
			If density>=0.15 And density<0.3 Then core_type=core_class.ice
			If density>=0.30 And density<0.45 Then core_type=core_class.SI_ice
			If density>=0.45 And density<=0.6 Then core_type=core_class.SI_smetal
		EndIf
		'create tectonic
		tectonic_activity=(5+rndRange(1,10))*Sqr(mass)/age
		If core_type>=core_class.ice And core_type<=core_class.SI_ice Then
			tectonic_activity*=density
		EndIf
		If rotation_periode<18 Then
			tectonic_activity*=1.25
		EndIf
		If rotation_periode>100 Then
			tectonic_activity*=1.25
		EndIf
		If tidal_locked=TRUE Then
			tectonic_activity*=0.5
		EndIf
		r1=rndRange(1,10)
		If tectonic_activity<0.5 Then tectonic=tectonic_class.dead
		If tectonic_activity>=0.5 And tectonic_activity<1.0 Then
			If r1>=1 And r1<=7 Then tectonic=tectonic_class.dead
			If r1>=8 And r1<=9 Then tectonic=tectonic_class.hotspot
			If r1>=10 Then tectonic=tectonic_class.plastic
		EndIf
		If tectonic_activity>=1.0 And tectonic_activity<2.0 Then
			If r1=1 Then tectonic=tectonic_class.dead
			If r1>=2 And r1<=5 Then tectonic=tectonic_class.hotspot
			If r1>=6 And r1<=9 Then tectonic=tectonic_class.plastic
			If r1>=10 Then tectonic=tectonic_class.plate
		EndIf
		If tectonic_activity>=2.0 And tectonic_activity<3.0 Then
			If r1>=1 And r1<=2 Then tectonic=tectonic_class.hotspot
			If r1>=3 And r1<=6 Then tectonic=tectonic_class.plastic
			If r1>=7 Then tectonic=tectonic_class.plate
		EndIf
		If tectonic_activity>=3.0 And tectonic_activity<5.0 Then
			If r1=1 Then tectonic=tectonic_class.hotspot
			If r1>=2 And r1<=3 Then tectonic=tectonic_class.plastic
			If r1>=4 And r1<=8 Then tectonic=tectonic_class.plate
			If r1>=9 Then tectonic=tectonic_class.platelet
		EndIf
		If tectonic_activity>=5.0 Then
			If r1=1 Then tectonic=tectonic_class.plastic
			If r1=2 Then tectonic=tectonic_class.plate
			If r1>=3 And r1<=7 Then tectonic=tectonic_class.platelet
			If r1>=8 Then tectonic=tectonic_class.extreme
		EndIf
		'create magnetic field
		If tidal_locked=TRUE Then
			magnetic_factor=10*1.0/Sqr(orbit_periode/24)*(density*density)*Sqr(mass)/age
		Else
			magnetic_factor=10*1.0/Sqr(rotation_periode/24)*(density*density)*Sqr(mass)/age
		EndIf
		If core_type>=core_class.ice And core_type<=core_class.SI_ice Then
			magnetic_factor*=0.5
		EndIf
		r1=rndRange(1,10)
		r2=rndRange(1,10)
		If magnetic_factor<0.05 Then magnetic_field=0
		If magnetic_factor>=0.05 And magnetic_factor<0.5 Then
			If r1>=1 And r1<=5 Then magnetic_field=0
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.001
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.002
			If r1>=10 Then magnetic_field=r2*0.01
		EndIf
		If magnetic_factor>=0.5 And magnetic_factor<1.0 Then
			If r1>=1 And r1<=3 Then magnetic_field=0
			If r1>=4 And r1<=5 Then magnetic_field=r2*0.001
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.002
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.01
			If r1>=10 Then magnetic_field=r2*0.05
		EndIf
		If magnetic_factor>=1.0 And magnetic_factor<2.0 Then
			If r1>=1 And r1<=3 Then magnetic_field=r2*0.001
			If r1>=4 And r1<=5 Then magnetic_field=r2*0.002
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.01
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.05
			If r1>=10 Then magnetic_field=r2*0.1
		EndIf
		If magnetic_factor>=2.0 And magnetic_factor<4.0 Then
			If r1>=1 And r1<=3 Then magnetic_field=r2*0.05
			If r1>=4 And r1<=5 Then magnetic_field=r2*0.1
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.2
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.3
			If r1>=10 Then magnetic_field=r2*0.5
		EndIf
		If magnetic_factor>=4.0 Then
			If r1>=1 And r1<=3 Then magnetic_field=r2*0.1
			If r1>=4 And r1<=5 Then magnetic_field=r2*0.2
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.3
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.5
			If r1>=10 Then magnetic_field=r2*1.0
		EndIf
	EndIf
	'create magnetic field for giants and jovians
	r1=rndRange(1,10)
	r2=rndRange(1,10)
	If planet_type>=planet_class.giant And planet_type<=planet_class.jovian Then
		If mass<50 Then
			If r1=1 Then magnetic_field=r2*0.1
			If r1>=2 And r1<=4 Then magnetic_field=r2*0.25
			If r1>=5 And r1<=7 Then magnetic_field=r2*0.5
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.75
			If r1>=10 Then magnetic_field=r2*1.0
		EndIf
		If mass>=50 And mass<200 Then
			If r1=1 Then magnetic_field=r2*0.25
			If r1>=2 And r1<=4 Then magnetic_field=r2*0.5
			If r1>=5 And r1<=7 Then magnetic_field=r2*0.75
			If r1>=8 And r1<=9 Then magnetic_field=r2*1.0
			If r1>=10 Then magnetic_field=r2*1.5
		EndIf
		If mass>=200 And mass<500 Then
			If r1=1 Then magnetic_field=r2*0.5
			If r1>=2 And r1<=4 Then magnetic_field=r2*1.0
			If r1>=5 And r1<=7 Then magnetic_field=r2*1.5
			If r1>=8 And r1<=9 Then magnetic_field=r2*2.0
			If r1>=10 Then magnetic_field=r2*3.0
		EndIf
		If mass>=500 Then
			If r1=1 Then magnetic_field=r2*1.5
			If r1>=2 And r1<=4 Then magnetic_field=r2*2.5
			If r1>=5 And r1<=7 Then magnetic_field=r2*5.0
			If r1>=8 And r1<=9 Then magnetic_field=r2*10.0
			If r1>=10 Then magnetic_field=r2*25.0
		EndIf
	EndIf
	'generate asteorid
	If planet_type>=planet_class.asteorid Then
		r1=rndRange(1,10)
		If orbit>inner Then r1+=6
		If orbit<hab_min Then r1-=2
		If density>=0.6 And density<0.8 Then r1-=1
		If density>=0.8 And density<1.0 Then r1-=2
		If density>=1.0 And density<1.2 Then r1-=3
		If density>=1.2 Then r1-=5
		If r1<-1 Then core_type=asteorid_class.M
		If r1>=-1 And r1<=5 Then core_type=asteorid_class.S
		If r1>=6 And r1<=10 Then core_type=asteorid_class.C
		If r1>=11 Then core_type=asteorid_class.Ice
		r1=rndRange(1,10)
		r2=rndRange(1,10)
		If orbit<=inner Then
			r1-=1
		Else
			r1+=2
		EndIf
		If orbit_both=TRUE Then r1+=2
		If age>7 Then r1-=1
		r1+=abudance
		If r1<5 Then mass=0.0001*r2
		If r1>=5 And r1<=6 Then mass=0.001*r2
		If r1>=7 And r1<=8 Then mass=0.01*r2
		If r1>=9 And r1<=10 Then mass=0.1*r2
		If r1>=11 Then mass=1*r2
	EndIf
	'lays it in habitable zone
	If orbit>=hab_min And orbit<=hab_max Then habitable=TRUE
	'calculate base surface temperature
	base_temperature = 255/Sqr(orbit/Sqr(lum))


	'create moons
	Dim n As Integer=0
	If tidal_locked=FALSE Then
		r1=rndRange(1,10)
		If orbit>inner Then r1+=5
		If planet_type=planet_class.chunk Then
			If r1>=-4 And r1<=9 Then n=0
			If r1>=10 And r1<=13 Then n=1
			If r1>=14 Then n=1
		EndIf
		If planet_type=planet_class.terestrial Then
			If r1>=-4 And r1<=5 Then n=0
			If r1>=6 And r1<=7 Then n=1
			If r1>=8 And r1<=9 Then n=rndRange(1,2)
			If r1>=10 And r1<=13 Then n=rndRange(1,5)
			If r1>=14 Then n=rndRange(1,10)
		EndIf
		If planet_type=planet_class.giant Or planet_type=planet_class.jovian Then
			If r1>=-4 And r1<=0 Then n=0
			If r1>=1 And r1<=5 Then n=rndRange(1,5)
			If r1>=6 And r1<=7 Then n=rndRange(1,10)
			If r1>=8 And r1<=9 Then n=rndRange(1,10)+5
			If r1>=10 And r1<=13 Then n=rndRange(1,10)+10
			If r1>=14 Then n=rndRange(1,10)+20
		EndIf
		create_moons(n)
	EndIf
	If nr_moons>0 Then
		For i As UInteger=0 To nr_moons-1
			moon[i].generate_moon(inner,hab_min,hab_max,abudance,age,lum,mass,density,orbit,radius,tidal_locked)
			'	moon[i].orbit*=(radius)
		Next
	EndIf

	'remove_moons(radius)
End Sub

Sub moon_t.generate_moon(inner As Double,hab_min As Double,hab_max As Double,abudance As Integer,age As Double,lum As Double,ma As Double,d As Double,o As Double,r As double,tidal_lock As boolean)
	Dim r1 As Integer=rndRange(1,10)
	If r1>=1 And r1<=4 Then orbit=1+rndRange(1,10)*0.5
	If r1>=5 And r1<=7 Then orbit=6+rndRange(1,10)
	If r1>=8 And r1<=9 Then orbit=16+rndRange(1,10)*3
	If r1>=10 Then orbit=45+rndRange(1,100)*3

	If o<inner Then
		density=0.3+rndRange(1,10)*0.1
	Else
		density=0.1+rndRange(1,10)*0.05
	EndIf
	roche_limit=2.456*(d/density)^0.33
	r1=rndRange(1,100)
	If abudance<0 Then r1+=abudance*2
	If abudance>0 Then r1+=abudance
	If r1>=-4 And r1<=64 Then
		moon_type=moon_class.tiny_chunk
		radius=rndRange(1,10)*10
	EndIf
	If r1>=65 And r1<=84 Then
		moon_type=moon_class.chunk
		radius=rndRange(1,10)*100
	EndIf
	If r1>=85 And r1<=94 Then
		moon_type=moon_class.large_chunk
		radius=1000+rndRange(1,10)*100
	EndIf
	If r1>=95 And r1<=99 Then
		moon_type=moon_class.small_terrestrial
		radius=2000+rndRange(1,10)*200
	EndIf
	If r1>=100 Then
		moon_type=moon_class.terrestrial
		radius=4000+rndRange(1,10)*400
	EndIf
	If orbit<=roche_limit And moon_type>=moon_class.tiny_chunk And moon_type<=moon_class.large_chunk Then
		moon_type=moon_class.ring
	EndIf
	mass=((radius/6380)*(radius/6380)*(radius/6380))/density
	gravity= mass/((radius/6380)*(radius/6380))
	Dim orbit1 As Double=orbit*r
	orbit_periode=Sqr((((orbit1/400000)*(orbit1/400000)*(orbit1/400000))*(793.64/mass)))
	'orbit_periode=Sqr((((orbit)*(orbit)*(orbit))/(793.64/mass)))
	posi=Vector3Add(posi,Vector3(Sin(timer)*(o+orbit),0,cos(timer)*(o+orbit)))
	orbit_inclination=0.33+rndRange(0,10)

End Sub
'Sub print_moon_data(galaxy As galaxy_t,snr As Integer,pnr As Integer,mnr As integer)
'	Dim moon As moon_t=galaxy.systems[galaxy.xp][galaxy.yp].star[snr-1].planet[pnr-1].moon[mnr-1]
'	DrawText(75,1,Str(moon.moon_type),&hffffffff)
'	DrawText(75,2,Str(moon.orbit),&hffffffff)
'	DrawText(75,3,Str(moon.orbit_periode),&hffffffff)
'	DrawText(75,4,Str(moon.radius),&hffffffff)
'	DrawText(75,5,Str(moon.density),&hffffffff)
'	DrawText(75,6,Str(moon.mass),&hffffffff)
'	DrawText(75,7,Str(moon.gravity),&hffffffff)
'	DrawText(75,8,Str(moon.exentry),&hffffffff)
'	DrawText(75,9,Str(moon.axial_tilt),&hffffffff)
'	DrawText(75,10,Str(moon.rotation_periode),&hffffffff)
'	DrawText(75,11,Str(moon.escape_velocity),&hffffffff)
'	DrawText(75,12,Str(moon.roche_limit),&hffffffff)
'	DrawText(75,13,Str(moon.tidal_lock),&hffffffff)
'	DrawText(75,14,Str(moon.tidal_locked),&hffffffff)
'	DrawText(75,15,Str(moon.core_type),&hffffffff)
'	DrawText(75,16,Str(moon.tectonic_activity),&hffffffff)
'	DrawText(75,17,Str(moon.tectonic),&hffffffff)
'	DrawText(75,18,Str(moon.magnetic_factor),&hffffffff)
'	DrawText(75,19,Str(moon.magnetic_field),&hffffffff)
'End Sub
'Sub print_planet_data(galaxy As galaxy_t,snr As Integer,pnr As Integer)
'	Dim planet As planet_t=galaxy.systems[galaxy.xp][galaxy.yp].star[snr-1].planet[pnr-1]
'	DrawText(75,1,Str(planet.planet_type),&hffffffff)
'	DrawText(75,2,Str(planet.orbit),&hffffffff)
'	DrawText(75,3,Str(planet.orbit_periode),&hffffffff)
'	DrawText(75,4,Str(planet.radius),&hffffffff)
'	DrawText(75,5,Str(planet.density),&hffffffff)
'	DrawText(75,6,Str(planet.mass),&hffffffff)
'	DrawText(75,7,Str(planet.gravity),&hffffffff)
'	DrawText(75,8,Str(planet.exentry),&hffffffff)
'	DrawText(75,9,Str(planet.axial_tilt),&hffffffff)
'	DrawText(75,10,Str(planet.rotation_periode),&hffffffff)
'	DrawText(75,11,Str(planet.escape_velocity),&hffffffff)
'	DrawText(75,12,Str(planet.tidal_lock),&hffffffff)
'	DrawText(75,13,Str(planet.tidal_locked),&hffffffff)
'	DrawText(75,14,Str(planet.core_type),&hffffffff)
'	DrawText(75,15,Str(planet.tectonic_activity),&hffffffff)
'	DrawText(75,16,Str(planet.tectonic),&hffffffff)
'	DrawText(75,17,Str(planet.magnetic_factor),&hffffffff)
'	DrawText(75,18,Str(planet.magnetic_field),&hffffffff)
'	DrawText(75,19,Str(planet.base_temperature),&hffffffff)
'	DrawText(75,20,Str(planet.habitable),&hffffffff)
'	DrawText(75,21,Str(planet.solar_day),&hffffffff)
'	DrawText(75,22,Str(planet.nr_moons),&hffffffff)
'End Sub
'Sub print_star_data(galaxy As galaxy_t,snr As Integer)
'	Dim star As star_t=galaxy.systems[galaxy.xp][galaxy.yp].star[snr-1]
'	Dim tstr As String="STARCLASS: " & Left(star_class_str(star.star_class),1) & Str(star.star_specification) & Right(star_class_str(star.star_class),4)
'	TO_ClearText(textedit)
'	TO_AppendLine(textedit,"NAME: ")
'	TO_AppendLine(textedit,tstr)
'	TO_AppendLine(textedit,"")
'	TO_AppendLine(textedit,"Size: " & Left(Str(star.radius),6) & " Sol Radii")
'	TO_AppendLine(textedit,"Mass: " & Left(Str(star.mass),6) & " Sols")
'	TO_AppendLine(textedit,"Temperature: " & Str(star.temperature) & " K")
'	TO_AppendLine(textedit,"Luminousity: " & Left(Str(star.Luminousity),6) & " Lumen")
'	TO_AppendLine(textedit,"Age: " & Str(star.age) & " GY")
'	TO_AppendLine(textedit,"LifeSpan: " & Left(Str(star.life_span),6) & " GYs left.")
'	TO_AppendLine(textedit,"Habitable Zone: " & Left(Str(star.habitable_zone_min),6) & " AU - " & Left(Str(star.habitable_zone_max),6) & " AU")
'	If star.orbit<>0 Then
'	TO_AppendLine(textedit,"")
'	TO_AppendLine(textedit,"It orbits his partner at " & Str(Abs(star.orbit)) & " AU.")
'	TO_AppendLine(textedit,"The orbit periode is " & Left(Str(star.orbit_periode),6) & " Years.")
'	EndIf
'	If star.nr_planets>0 Then
'	TO_AppendLine(textedit,"")
'		TO_AppendLine(textedit,"Also he has " & Str(star.nr_planets) & " Planets.")
'		If star.nr_planets>0 then
'		Dim x As Integer=0
'		For i As UInteger=0 To star.nr_planets-1
'			If star.planet[i].orbit_both Then x+=1
'		Next
'		If x>0 Then TO_AppendLine(textedit,Str(x) & " of them orbit both Stars.")
'		EndIf
'	EndIf
'	For r As Integer=0 To 5
'	For i As Integer=0 To 360
'	DrawText(80+Sin(i*degToRad)*r,7+Cos(i*degToRad)*r,Chr(dither_chars(r)),Temperature2RGB(star.temperature+((-0.5*Rnd)*(star.temperature)))And &h00ffffff Or RGBA(0,0,0,(r+1)*32))
'	Next
'	Next
''	DrawText(75,12,Str(star.inner_zone),&hffffffff)
'	UpdateGadget(textedit)
'End Sub


Function get_home_world(s As arrayList Ptr) As arrayList
	Dim sec As sector_t Ptr 
	Dim sys As system_t Ptr 
	Dim sta As star_t 
	Dim pl As planet_t
	Dim res As arrayList
	For i As UInteger=0 To s->count-1
		sec=s->Get(i)
		For j As UInteger=0 To sec->systems->count-1
			sys=sec->systems->Get(j)
			If sys->nr_stars>0 Then
				For k As UInteger=0 To sys->nr_stars-1
					sta=sys->star[k]
					'If sta.star_class=star_class_e.GV Andalso (sta.star_specification>=2 andalso sta.star_specification<=4) then
						If sta.nr_planets>0 Then
							For l As UInteger=0 To sta.nr_planets-1
								pl=sta.planet[l]
								If (pl.habitable=TRUE) Then
									If (pl.planet_type>=planet_class.terestrial AndAlso pl.planet_type<=planet_class.chunk)  Then
										Print "found"
										res.add(New uInteger(i))
										res.add(New uInteger(j))
										res.add(New uInteger(k))
										res.add(New uInteger(l))
										'For i As UInteger=0 To res.count-1
										'	Dim r As UInteger Ptr=res.get(i)
										'	Print *r
										'Next
										'sleep
										Return res
									endif
								EndIf
							Next
						EndIf
					'EndIf
				next
			EndIf
		Next
	Next
	res.add(New UInteger(0))
	res.add(New UInteger(0))
	res.add(New UInteger(0))
	res.add(New UInteger(0))
	Return res
End Function

'Sub render_sector_map(s As sector_t ptr,offset As Double)
'	Dim sys As system_t Ptr
'	Dim sta As star_t
'	Dim pla As planet_t
'	Dim moo As moon_t
'	Dim size As Double
'	Dim size2 As Double
'	Dim y_off As Double=scrH/2
'	offset-=scrW/2
'	'For i As UInteger=0 To s->systems->count-1
'		sys=s->systems->get(0)
'		If sys->nr_stars>0 Then
'			'For j As UInteger=0 To sys->nr_stars-1
'				sta=sys->star[0]
'				size=2+sqr(sys->star[0].radius)/SOLZ'*SOLZ)'/100ar[0].bary_center*100-sys->star[1].orbit*100)+(sys->star[0].bary_center*100+sys->star[0].orbit*100)
'
'				'If sys->nr_stars>1 Then offset-=(sys->st
'				Circle ((((sys->star[0].orbit)/SOLZ)*scrW)-offset,y_off),size,temperature2rgb(sys->star[0].temperature),,,,F
'				Circle ((((0)/SOLZ )*scrW)-offset,y_off),((sys->star[0].orbit)/SOLZ )*scrW,temperature2rgb(sys->star[0].temperature)
'				Dim c1 As UInteger=&hffff00ff
'				'If  (sta.bary_center<1.0) And (i=0) Then
'				'	c1=Temperature2RGB(sta.temperature) Xor &h00ffffff
'				'	Circle (s->position->x-offset,100),4,c1
'				'Else
'				'Circle (((sys->star[0].bary_center/SOLZ )*scrW)-offset,y_off),4,c1
'
'				'EndIf
'				If sys->nr_stars>1 Then 
'				size2=2+sqr(sys->star[1].radius)/SOLZ'*SOLZ)'/100ar[0].bary_center*100-sys->star[1].orbit*100)+(sys->star[0].bary_center*100+sys->star[0].orbit*100)
'				'draw the star
'				Circle ((((sys->star[1].orbit)/SOLZ)*scrW)-offset,y_off),size2,temperature2rgb(sys->star[1].temperature),,,,F
'				'draw the orbit
'				Circle ((((0)/SOLZ )*scrW)-offset,y_off),(abs(sys->star[1].orbit)/SOLZ )*scrW,temperature2rgb(sys->star[1].temperature)
'				Dim c1 As UInteger=&hffff00ff
'				'If  (sta.bary_center<1.0) And (i=0) Then
'				'	c1=Temperature2RGB(sta.temperature) Xor &h00ffffff
'				'	Circle (s->position->x-offset,100),4,c1
'				'Else
'				'Circle (((sys->star[1].bary_center/SOLZ )*scrW)-offset,y_off),4,c1
'
'				EndIf
'
'
'				''sta.render()
'				'If sta.nr_planets>0 Then
'				'	Dim c As UInteger=&hffff7700
'				'	For k As UInteger=0 To sta.nr_planets-1
'				'		pla=sta.planet[k]
'				'		c=Planet_type_colors(pla.planet_type)
'				'		'If pla.orbit_both Then
'				'		'	y_off=+50
'				'		'	If Sgn(sta.orbit)=-1 Then
'				'		'		'Line(s->position->x-log(sta.planet[k].orbit)*scrW/4-offset-8,100+y_off-8)-(s->position->x-log(sta.planet[k].orbit)*scrW/4-offset+8,100+y_off+8),&hff000077,B
'				'		'		Line(s->position->x-offset,100+y_off)-(s->position->x-log(sta.planet[k].orbit)*scrW/4-offset,100+y_off),&hff000077
'				'		'		Line(s->position->x-offset,100)-(s->position->x-offset,100+y_off),&hff000077
'				'		'	ElseIf Sgn(sta.orbit)=0 Then
'				'		'		y_off=0
'				'		'		'Line(sta.bary_center*10+log(sta.planet[k].orbit)*scrW/4-offset-8,100-y_off-8)-(sta.bary_center*10+log(sta.planet[k].orbit)*scrW/4-offset+8,100-y_off+8),&hff007700,B
'				'		'		Line(s->position->x-offset,100-y_off)-(s->position->x+log(sta.planet[k].orbit)*scrW/4-offset,100-y_off),&hff007700
'				'		'	elseIf Sgn(sta.orbit)=1 Then
'				'		'		'Line(s->position->x+log(sta.planet[k].orbit)*scrW/4-offset-8,100+y_off-8)-((s->position->x+(sta.orbit*10))+log(sta.planet[k].orbit)*scrW/4-offset+8,100+y_off+8),&hff770000,B
'				'		'		Line(s->position->x-offset,100+y_off)-(s->position->x+log(sta.planet[k].orbit)*scrW/4-offset,100+y_off),&hff770000
'				'		'		Line(s->position->x-offset,100)-(s->position->x-offset,100+y_off),&hff770000
'				'		'	endif
'				'		'Else
'				'		'	If Sgn(sta.orbit)=-1 Then
'				'		'	Line(sta.bary_center*10-offset,100)-(sta.bary_center*10-log(sta.planet[k].orbit)*scrW/4-offset,100),&hff777777
'				'		'	ElseIf Sgn(sta.orbit)=0 Then
'				'		'	Line(sta.bary_center*10-offset,100)-(sta.bary_center*10+log(sta.planet[k].orbit)*scrW/4-offset,100),&hff777777
'				'		'	elseIf Sgn(sta.orbit)=1 Then
'				'		'	Line(sta.bary_center*10-offset,100)-(sta.bary_center*10+log(sta.planet[k].orbit)*scrW/4-offset,100),&hff777777
'				'		'	endif
'				'		'	y_off=0
'				'		'	'Line(sta.bary_center*10+log(sta.planet[k].orbit)*scrW/4-offset-8,100-y_off-8)-(sta.bary_center*10+log(sta.planet[k].orbit)*scrW/4-offset+8,100-y_off+8),&hff777777,B
'				'		'	Line(sta.bary_center*10-offset,100)-(sta.bary_center*10+log(sta.planet[k].orbit)*scrW/4-offset,100),&hff777777
'				'		'EndIf
'				'		''Line(((sta.bary_center*10+(sta.orbit*10))-log(pla.orbit)*scrW)-offset,100)-(((sta.bary_center*10+(sta.orbit*10))-log(pla.orbit)*scrW)-offset,100+y_off),&hff333377
'
'				'		size=1+log(pla.radius/6380*SOLZ)'/SOLZ
'				'		Circle ( (((sta.orbit/SOLZ))*scrW)-offset,y_off),(pla.orbit*SOLZ),c
'				'		If Sgn(sta.orbit)=-1 Then
'				'			Circle ( (((s->position->x))-(pla.orbit)*scrW/4)-offset,y_off),(size),c,,,,F
'				'		ElseIf Sgn(sta.orbit)=0 Then
'				'			Circle ( (((s->position->x))+(pla.orbit)*scrW/4)-offset,y_off),(size),c,,,,F
'				'		ElseIf Sgn(sta.orbit)=1 Then
'				'			Circle ( (((s->position->x))+(pla.orbit)*scrW/4)-offset,y_off),(size),c,,,,F
'				'		endif
'				'		'pla.render()
'				'		If pla.nr_moons>0 Then
'				'			For l As UInteger=0 To pla.nr_moons-1
'				'			c=Moon_type_colors(pla.planet_type)
'				'				moo=pla.moon[l]
'				'				size2=1+Log(moo.radius/6380*SOLZ)'/SOLZ
'				'				If Sgn(sta.orbit)=-1 then
'				'					Circle ( ((s->position->x)-(pla.orbit)*scrW/4)-offset,(moo.orbit)*scrH/8+y_off),(size2),c,,,,F
'				'				ElseIf Sgn(sta.orbit)=0 then
'				'					Circle ( ((s->position->x)+(pla.orbit)*scrW/4)-offset,(moo.orbit)*scrH/8+y_off),(size2),c,,,,F
'				'				ElseIf Sgn(sta.orbit)=1 then
'				'					Circle ( ((s->position->x)+(pla.orbit)*scrW/4)-offset,(moo.orbit)*scrH/8+y_off),(size2),c,,,,F
'				'					'moo.render()
'				'				endif
'				'			next
'				'		EndIf
'				'	Next
'				'EndIf
'			'Next
'
'		EndIf
'	'Next
'End Sub
