namespace sGUI

declare function AddArrow (win as sGUIWindow ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
declare function AddSmallArrow (win as sGUIWindow ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
declare function ArrowActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawArrow (gad as Gadget ptr)
declare sub DrawSmallArrow (gad as Gadget ptr)

'Steuerungsvariablen:
'Ctrl(0) enthlt einen Richtungsmarker 0=links,1=rechts,2=hoch,3=runter
'Ctrl(1) wird fr die Zeitverzgerung des Triggerns bentigt
function AddArrow (win as sGUIWindow ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    if DirArrow=0 or DirArrow=1 then
      gad->GadWidth=16
      gad->GadHeight=15
    end if
    if DirArrow=2 or DirArrow=3 then
      gad->GadWidth=15
      gad->GadHeight=16
    end if

    gad->Ctrl(0)=DirArrow
    
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)
    
    gad->DoDraw     =@DrawArrow
    gad->DoAction   =@ArrowActions
    gad->DoUpdate   =@DrawArrow

    function=gad
  end if
end function


function AddSmallArrow (win as sGUIWindow ptr,PosX as integer,PosY as integer,DirArrow as integer) as Gadget ptr
  function=0
  if win=0 then
    dim as Gadget ptr gad
    gad=win->GadgetList->AppendNew (GadgetType)
    if gad then
      gad->parent=win
      gad->Selection=0
      gad->Activation=0
      gad->PosX=PosX
      gad->PosY=PosY
      if DirArrow=0 or DirArrow=1 then
        gad->GadWidth=10
        gad->GadHeight=9
      end if
      if DirArrow=2 or DirArrow=3 then
        gad->GadWidth=9
        gad->GadHeight=10
      end if

      gad->Ctrl(0)=DirArrow

      gad->DoDraw     =@DrawSmallArrow
      gad->DoAction   =@ArrowActions

      function=gad
    end if
  end if
end function


function ArrowActions(gad as Gadget ptr,action as integer) as integer
  function=0
  static as single tt

  select case action

      case GADGET_LMBHIT
        SetSelect (gad,1)
        function=1
      
      case GADGET_LMBHOLD
        if gad->Ctrl(1)=2 and timer >= tt+.05 then
          tt=timer
          function=1
        end if

        if gad->Ctrl(1)=1 and timer >= tt+.8 then
          tt=timer
          gad->Ctrl(1)=2
          function=1
        end if

        if gad->Ctrl(1)=0 then
          tt=timer
          gad->Ctrl(1)=1
        end if

      case GADGET_LMBRELEASE,GADGET_LMBRELEASEOFF
        gad->Ctrl(1)=0
        SetSelect (gad,0)
      
      case GADGET_MOUSEHOVER
        gad->ctrl(13)=1
        DrawGadget(gad)

      case GADGET_MOUSENEXT
        gad->ctrl(13)=0
        DrawGadget(gad)

  end select
end function


sub DrawArrow (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,DirArrow,offset
  dim as ulong col
  dim as FB.Image ptr buffer
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
  DirArrow =gad->Ctrl(0) 
  Buffer   =gad->DrawBuffer->img
'OFF 
  ClearBox Buffer,0,0,GadWidth,GadHeight,&HFF00FF
'ON   unselect/select
  if gad->Activation then
    'glowfx
    if gad->ctrl(13) then
      FillA Buffer,0,0,GadWidth,GadHeight,Colors.GadBodyGlow,Colors.GadFrameGlow,gad->Selection
    else
      FillA Buffer,0,0,GadWidth,GadHeight,,,gad->Selection
    end if
    'unselect/select Symbol  
    if gad->Selection then 
      offset=1
      col=Colors.GadText
    else
      offset=0
      col=Colors.GadText
    end if
    if DirArrow=0 then Arrow Buffer,5-offset,3,4,DirArrow,col
    if DirArrow=1 then Arrow Buffer,5+offset,3,4,DirArrow,col
    if DirArrow=2 then Arrow Buffer,3,5-offset,4,DirArrow,col
    if DirArrow=3 then Arrow Buffer,3,5+offset,4,DirArrow,col
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if
end sub


sub DrawSmallArrow (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,DirArrow,offset
  dim as ulong col
  dim as FB.Image ptr buffer
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
  DirArrow =gad->Ctrl(0) 
  Buffer   =gad->DrawBuffer->img  
'OFF
  ClearBox Buffer,0,0,GadWidth,GadHeight,&HFF00FF
  if gad->Activation=0 then
'ON
    'glowfx
    if gad->ctrl(13) then
      FillA Buffer,0,0,GadWidth,GadHeight,Colors.GadBodyGlow,Colors.GadFrameGlow,gad->Selection
    else
      FillA Buffer,0,0,GadWidth,GadHeight,,,gad->Selection
    end if
    'unselect/select Symbol  
    if gad->Selection then 
      offset=1
      col=Colors.GadText
    else
      offset=0
      col=Colors.GadText
    end if
    if DirArrow=0 then Arrow Buffer,3-offset,2,2,DirArrow,col
    if DirArrow=1 then Arrow Buffer,3+offset,2,2,DirArrow,col
    if DirArrow=2 then Arrow Buffer,2,3-offset,2,DirArrow,col
    if DirArrow=3 then Arrow Buffer,2,3+offset,2,DirArrow,col
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if
end sub

end namespace
