namespace sGUI

declare function AddLabel (win as sGUIWindow ptr,PosX as integer,PosY as integer,Text as string,TextColor as integer=TextColor) as Gadget ptr
declare function LabelActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawLabel (gad as Gadget ptr)
declare sub UpdateLabel (gad as Gadget ptr)

declare sub SetLabelColor (gad as Gadget ptr,TextColor as integer)

'Ctrl(0) Farbe des Textes
function AddLabel (win as sGUIWindow ptr,PosX as integer,PosY as integer,Text as string,TextColor as integer=TextColor) as Gadget ptr
  function=0
 
  dim as Gadget ptr gad
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadWidth=GetTextWidth(Text)
    gad->GadHeight=GetFontHeight

    gad->caption=Text

    gad->Ctrl(0)=TextColor

    gad->DoDraw     =@DrawLabel
    gad->DoAction   =@LabelActions
    gad->DoUpdate   =@UpdateLabel

    function=gad
  end if

end function


function LabelActions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action

      case GADGET_LMBHIT

      case GADGET_LMBHOLD

      case GADGET_LMBHOLDOFF

      case GADGET_LMBRELEASE
        function=1
      
      case GADGET_LMBRELEASEOFF

  end select
end function


sub DrawLabel (gad as Gadget ptr)
	dim as integer GadX,GadY
  GetGlobalPosition(gad,GadX,GadY)
  gad->PutBackGround
	if gad->Activation then
    put(GadX,GadY),gad->Background->img,pset
    drawstring ( GadX, GadY,gad->caption,gad->Ctrl(0))
    if gad->Activation=2 then gad->PutBackGround SleepShade
  end if
end sub


sub UpdateLabel (gad as Gadget ptr)
  gad->PutBackGround          
  gad->GadWidth=GetTextWidth(gad->caption)
  gad->SaveBackGround                                 
  DrawGadget(gad)                             
end sub


sub SetLabelColor (gad as Gadget ptr,TextColor as integer)
  gad->Ctrl(0)=TextColor
  UpdateGadget(gad)
end sub

end namespace
