namespace sGUI

declare function AddCheckMarkGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,SwtchSel as integer,Text as string="",textleft as integer=0) as Gadget ptr
declare function AddRadioButton (win as sGUIWindow ptr,PosX as integer,PosY as integer,SwtchSel as integer,Text as string="",Head as Gadget ptr,textleft as integer=0) as Gadget ptr
declare function RadioCheckActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawRadioCheck (gad as Gadget ptr)
declare sub UpdateRadioCheck (gad as Gadget ptr)
declare sub RCRethinkInternal(gad as Gadget ptr)

'Ctrl(0) offset x RadioButton/Checkbox
'Ctrl(1) offset y RadioButton/Checkbox
'Ctrl(2) offset x Text
'Ctrl(3) offset y Text
'Ctrl(4) Schalter Text links
'Ctrl(5) Originalposition x Backup
'Ctrl(6) Originalposition y Backup
'Ctrl(7)  wenn 1 Radiobutton
function AddCheckmarkGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,SwtchSel as integer, Text as string="",textleft as integer=0) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
  	gad->Selection=SwtchSel
    gad->Activation=0
    gad->Ctrl(4)=textleft
    gad->Ctrl(5)=PosX
    gad->Ctrl(6)=PosY
    gad->Ctrl(7)=0
    gad->caption=Text

    RCRethinkInternal(gad)
    
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)

    gad->DoDraw     =@DrawRadioCheck
    gad->DoAction   =@RadioCheckActions
    gad->DoUpdate   =@UpdateRadioCheck
		function=gad
  end if
end function


function AddRadioButton (win as sGUIWindow ptr,PosX as integer,PosY as integer,SwtchSel as integer,Text as string="",Head as Gadget ptr,textleft as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad,groupfirst
  dim as node ptr n
  gad=AddCheckmarkGadget (win,PosX,PosY,SwtchSel,Text,textleft)

  if gad then
    gad->Ctrl(7)=1'Flag CheckMark zu Radiobutton
    if Head=0 then
      gad->anypointer = sGUI.PointerLists->AppendNew (ListObjectType)'eine einfache (Zeiger)Liste fr die Gruppe erzeugen
    else
      gad->anypointer = Head->anypointer'in einem Nichtheader Liste aus Header bernehmen
    end if

    n=cast(ListObject ptr,gad->anypointer)->AppendNew (nodeType)'in der Liste einen node als "Informationstrger" erzeugen
    n->anypointer=cast(any ptr,gad)'den Zeiger dieses Controls in den node schreiben

		function=gad
  end if
end function


function RadioCheckActions(gad as Gadget ptr,action as integer) as integer
  dim as Gadget ptr g
  dim as node ptr n
  dim as ListObject ptr lst=gad->anypointer'Adresse der "GruppenPointerliste"
  function=0
  select case action
      
      case GADGET_LMBRELEASE    'Control regulr losgelassen
          
        if gad->Ctrl(7) then
          
          n=lst->GetFirst
          do
            g=cast(Gadget ptr,n->anypointer)
            if g=gad then
              SetSelect(g,1)
            else
              SetSelect(g,0)
            end if
            n=n->next_node
          loop until n=0
          function=1
        
        else

          if GetSelect(gad) then SetSelect(gad,0) else SetSelect(gad,1)
          function=1
        
        end if

      case GADGET_MOUSEHOVER   'Mouse berm Control
        gad->ctrl(13)=1
        DrawGadget(gad)

      case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
        gad->ctrl(13)=0
        DrawGadget(gad)

  end select
end function


sub DrawRadioCheck (gad as Gadget ptr)
	dim as integer GadX,GadY,RadioCheckPosX,RadioCheckPosY,TextPosX,TextPosY,GadWidth,GadHeight
  dim as FB.Image ptr buffer
  GadWidth		   =gad->GadWidth
	GadHeight		   =gad->GadHeight
  RadioCheckPosX =gad->Ctrl(0)
	RadioCheckPosY =gad->Ctrl(1)
  TextPosX       =gad->Ctrl(2)
	TextPosY       =gad->Ctrl(3)
  Buffer         =gad->DrawBuffer->img  
'OFF
  ClearBox Buffer,0,0,GadWidth,GadHeight,WindowColors.BackGround
'ON
  if gad->Activation then
    if gad->Ctrl(7) then'RadioButton
      'glowfx
      if gad->ctrl(13) then
        FillC Buffer,RadioCheckPosX,RadioCheckPosY,Colors.GadBodyGlow,gad->Selection
      else
        FillC Buffer,RadioCheckPosX,RadioCheckPosY,,gad->Selection
      end if

    else'CheckMark
     'glowfx
      if gad->ctrl(13) then
        FillA Buffer,RadioCheckPosX,RadioCheckPosY,16,16,Colors.GadBodyGlow,Colors.GadFrameGlow,gad->Selection
      else
        FillA Buffer,RadioCheckPosX,RadioCheckPosY,16,16,,,0
      end if
      if gad->Selection then Tick (Buffer,RadioCheckPosX+4,RadioCheckPosY+4,Colors.GadText)
    
    end if
    if gad->caption<>"" then drawstring (Buffer,TextPosX,TextPosY,gad->caption,Colors.GadText)
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if
end sub


sub UpdateRadioCheck (gad as Gadget ptr)
  gad->PutBackGround
  RCRethinkInternal(gad)
  gad->SaveBackGround
  DrawGadget(gad)
end sub


sub RCRethinkInternal(gad as Gadget ptr)
  if gad->caption="" then   'ohne Text
    'X Y Position Gadget
    gad->PosX=gad->Ctrl(5)
    gad->PosY=gad->Ctrl(6)
    'Breite u. Hhe Gadget
    gad->GadWidth=16
    gad->GadHeight=16
    'relative X Y Positionen CheckBox/RadioButton
    gad->Ctrl(0)=0
    gad->Ctrl(1)=0

  else                   'mit Text
    'neue Y Position Gadget
    gad->PosY=gad->Ctrl(6)
    'Breite u. Hhe Gadget
    gad->GadWidth=16 + MinimumClearance + GetTextWidth(gad->caption)
    gad->GadHeight=GetFontHeight
    if gad->GadHeight<16 then gad->GadHeight=16
    'Y Offset CheckBox/RadioButton
    gad->Ctrl(1)=(gad->GadHeight - 16)/2
    'Y offset Text
    gad->Ctrl(3)=(gad->GadHeight-GetFontHeight)/2
    
    'Text links oder rechts?
    if gad->Ctrl(4) then' Text links
      'X Position Gadget(um Textbreite nach links verschoben)
      gad->PosX= gad->Ctrl(5) - MinimumClearance - GetTextWidth(gad->caption)
      'X Offset CheckBox/RadioButton
      gad->Ctrl(0)=MinimumClearance + GetTextWidth(gad->caption)
      'X Offset Text
      gad->Ctrl(2)=0

    else 'Text rechts
      'X Position Gadget
      gad->PosX=gad->Ctrl(5)
      'X Offset CheckBox/RadioButton
      gad->Ctrl(0)=0      
      'X Offset Text
      gad->Ctrl(2)=16 + MinimumClearance
    end if
  end if
end sub

end namespace
