namespace sGUI

declare function AddSimpleGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Text as string) as Gadget ptr
declare function AddToggleGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Selection as integer,Text as string) as Gadget ptr
declare function SimpleGadgetActions(gad as Gadget ptr,action as integer) as integer
declare function ToggleGadgetActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawSimpleToggle (gad as Gadget ptr)

'Ctrl(0) wenn 1 dann Toggle sonst Simple
'ctrl(13) mouse-over-control-flag
function AddSimpleGadget (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Text as string) as Gadget ptr
	function=0  
	dim as Gadget ptr gad
	if win=0 then win=RootWindow
	gad=win->GadgetList->AppendNew (GadgetType)
	if gad then
		gad->parent=win
		gad->Selection=0
		gad->Activation=0
		gad->PosX=PosX
		gad->PosY=PosY
		if GadWidth=0 then GadWidth=GetTextWidth(Text)+2*MinimumClearance
		if GadHeight=0 then GadHeight=GetFontHeight+2*MinimumClearance
		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight
		gad->caption=Text

		gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)

		gad->DoDraw     =@DrawSimpleToggle
		gad->DoAction   =@SimpleGadgetActions
		gad->DoUpdate   =@DrawSimpleToggle

		function=gad
	end if
end function


function AddToggleGadget (win as SGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0,Selection as integer,Text as string) as Gadget ptr
	function=0 
	dim as Gadget ptr gad
	gad=AddSimpleGadget (win,PosX,PosY,GadWidth,GadHeight,Text)
	if gad then
		gad->Selection=Selection
		gad->Ctrl(0)=1  
		gad->DoAction   =@ToggleGadgetActions    
		function=gad
	end if
end function


function SimpleGadgetActions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
      
      case GADGET_LMBHIT        'Control grad frisch gedrckt
        SetSelect (gad,1)
      
      case GADGET_LMBHOLD       'Control wird gehalten, Maus ber dem Control
        SetSelect (gad,1)
      
      case GADGET_LMBHOLDOFF    'Control wird gehalten, Maus neben dem Control
        SetSelect (gad,0)
      
      case GADGET_LMBRELEASE    'Control regulr losgelassen
        SetSelect (gad,0)
        function=1           'Ping!!!! Control meldet sich: bei mir ist was passiert!!!        

      case GADGET_LMBRELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control
        SetSelect (gad,0)
      
      case GADGET_MOUSEHOVER   'Mouse berm Control
        gad->ctrl(13)=1
        DrawGadget(gad)

      case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
        gad->ctrl(13)=0
        DrawGadget(gad)
        
  end select
end function


function ToggleGadgetActions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
      
      case GADGET_LMBHIT        'Control grad frisch gedrckt

      case GADGET_LMBHOLD       'Control wird gehalten, Maus ber dem Control

      case GADGET_LMBHOLDOFF    'Control wird gehalten, Maus neben dem Control

      case GADGET_LMBRELEASE    'Control regulr losgelassen
        if GetSelect(gad) then SetSelect(gad,0) else SetSelect(gad,1)
         function=1
      case GADGET_LMBRELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control
      
      case GADGET_MOUSEHOVER   'Mouse berm Control
        gad->ctrl(13)=1
        DrawGadget(gad)

      case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
        gad->ctrl(13)=0
        DrawGadget(gad)
  end select
end function


sub DrawSimpleToggle (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight,TextPosX,TextPosY
	dim as FB.Image ptr buffer
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
	TextPosX =int((GadWidth-GetTextWidth(gad->caption))/2)
	TextPosY =int((GadHeight-GetFontHeight)/2)
	Buffer   =gad->DrawBuffer->img
	'OFF 
	ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.GadFrameGlow
	'ON   unselect/select
	if gad->Activation then
		'glowfx
		if gad->ctrl(13) then
			FillA Buffer,0,0,GadWidth,GadHeight,Colors.GadBodyGlow,Colors.GadFrameGlow,gad->Selection
		else
			FillA Buffer,0,0,GadWidth,GadHeight,,,gad->Selection
		end if
		'unselect/select Caption
		if gad->Selection then
			drawstring (Buffer, TextPosX, TextPosY, gad->caption,Colors.GadTextSelected)
		else
			drawstring (Buffer, TextPosX, TextPosY, gad->caption,Colors.GadText)
		end if   
		'SLEEP
		if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
	end if
end sub

end namespace
