#include once "Window_CloseButton.bas"
#include once "Window_DragBar.bas"
namespace sGUI


declare function AddWindow (parent as any ptr,PosX as integer,PosY as integer,WinWidth as integer,WinHeight as integer,Text as string="", WinFlags as integer) as sGUIWindow ptr
declare sub DrawWindow (win as sGUIWindow ptr)

function AddWindow (parent as any ptr,PosX as integer,PosY as integer,WinWidth as integer,WinHeight as integer,Text as string="", WinFlags as integer) as sGUIWindow ptr
  function=0
  dim as integer leftover,currentX
  if parent=0 then parent=RootWindow
  dim as sGUIWindow ptr win
  dim as Gadget ptr closebutton,dragbar
  if cast(WinGadHeader ptr,parent)->KindOfType=0 then
    win=cast(sGUIWindow ptr,parent)->WindowList->AppendNew(sGUIWindowType)
  else
    win=GadgetWindowList->AppendNew(sGUIWindowType)
    if win then cast(Gadget ptr,parent)->GadgetWindow=win
  end if
  if win then
    win->Created=timer
    win->parent=parent
    win->Selection=0
    win->Activation=0
    win->PosX=PosX
    win->PosY=PosY
    win->Caption=Text
    win->WinFlags=WinFlags
    '"nutzbare" Gre entsprechend Parameter festlegen
    'das eigentliche Fenster kann, wenn ein Rahmen vorhanden ist, grer sein

    'in Abhngigkeit von den Rahmen-Flags die Eigenschaften festlegen
    select case (win->WinFlags and &B11111111)'Bit 1-8 siehe sGUI.bas WindowFlags
      case WFLAG_WINDOWTYPE0'wenn kein Rahmen vorhanden
        '"inneres" Fenster = "ueres" Fenster
        win->ContentWidth=WinWidth
        win->ContentHeight=WinHeight        
        win->ContentWidth=WinWidth
        win->ContentHeight=WinHeight        
        win->ContentOffsetX=0
        win->ContentOffsetY=0
        
      case WFLAG_WINDOWTYPE1'mit Rahmen
        '"ueres" Fenster um Rahmen grer als "inneres" Fenster
        win->ContentWidth=WinWidth
        win->ContentHeight=WinHeight  
        win->ContentOffsetX=MinimumClearance
        win->ContentOffsetY=MinimumClearance  
        win->WinWidth=win->ContentWidth + 2*MinimumClearance 
        win->WinHeight=win->ContentHeight + 2*MinimumClearance        
      
      case WFLAG_WINDOWTYPE2'mit Rahmen und Kopfzeile
        '"ueres" Fenster um Rahmen grer als "inneres" Fenster
        win->ContentWidth=WinWidth
        win->ContentHeight=WinHeight    
        win->ContentOffsetX=MinimumClearance
        win->ContentOffsetY=GetFontHeight + 2*MinimumClearance   
        win->WinWidth=win->ContentWidth + 2*MinimumClearance 
        win->WinHeight=win->ContentHeight + GetFontHeight + 3*MinimumClearance      
        'nur bei vorhandener Kopfzeile die entsprechenden WindowGadgets, so gewnscht, einfgen
        currentX=-win->ContentOffsetX
        leftover=win->WinWidth
        if (win->WinFlags and WFLAG_CLOSEABLE) then
          closebutton=AddCloseButton(win,currentX,-win->ContentOffsetY)
          GadgetOn(closebutton)
          currentX +=closebutton->GadWidth
          leftover -=closebutton->GadWidth
        end if
        'if (win->WinFlags and WFLAG_MINIMIZABLE) then        
          'jibbet noch nich
        'end if        
        if (win->WinFlags and WFLAG_DRAGABLE) then
          dragbar=AddDragBar(win,currentX,-win->ContentOffsetY,leftover,0)
          GadgetOn(dragbar)        
        end if
        
      case WFLAG_WINDOWTYPE3
        '"ueres" Fenster um Rahmen grer als "inneres" Fenster
        win->ContentWidth=WinWidth
        win->ContentHeight=WinHeight    
        win->ContentOffsetX=1
        win->ContentOffsetY=1   
        win->WinWidth=win->ContentWidth + 2
        win->WinHeight=win->ContentHeight + 2
      
    end select
    'wenn keines dieser Flags gesetzt ist WFLAG_BACKDROP,WFLAG_STACKABLE,WFLAG_ALWAYSONTOP
    'dann setze mindestens das Backdrop Flag
    if (win->WinFlags and (WFLAG_BACKDROP or WFLAG_STACKABLE or WFLAG_ALWAYSONTOP))=0 then win->WinFlags +=WFLAG_STACKABLE
    
    'im Falle eines Backdrop Fensters verschieben wir dieses an den Anfang
    if (win->WinFlags and WFLAG_BACKDROP) then cast(sGUIWindow ptr,parent)->WindowList->MoveToFirst(win)
    
    'WFLAG_ALLWAYSSELECTED
    if (win->WinFlags and WFLAG_ALWAYSSELECTED) then win->Selection=1
       
    win->DrawBuffer->img=imagecreate(win->WinWidth,win->WinHeight,0,32)        
    win->DoDraw =@DrawWindow
    function=win
  end if 
end function


sub DrawWindow (win as sGUIWindow ptr)
  dim as integer TextPosX =int((win->WinWidth-GetTextWidth(win->caption))/2)
  if win->Activation then
    select case (win->WinFlags and &B11111111)'Bit 1-8 siehe sGUI.bas WindowFlags
      case WFLAG_WINDOWTYPE0
        ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight'Reinigungsfarbe voreingestellt
      
      case WFLAG_WINDOWTYPE1
        if win->Selection then 
          ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,Colors.WinFrameSelected
          ClearBox win->DrawBuffer->img,win->ContentOffsetX,win->ContentOffsetY,win->ContentWidth,win->ContentHeight,Colors.WinBackGround         
        else
          ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,Colors.WinFrame
          ClearBox win->DrawBuffer->img,win->ContentOffsetX,win->ContentOffsetY,win->ContentWidth,win->ContentHeight,Colors.WinBackGround                 
        end if
      
      case WFLAG_WINDOWTYPE2
        if win->Selection then
          ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,Colors.WinFrameSelected        
          drawstring win->DrawBuffer->img,TextPosX,MinimumClearance,win->caption,Colors.WinTitleSelected        
        else
          ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,Colors.WinFrame        
          drawstring win->DrawBuffer->img,TextPosX,MinimumClearance,win->caption,Colors.WinTitle      
        end if
        ClearBox win->DrawBuffer->img,win->ContentOffsetX,win->ContentOffsetY,win->ContentWidth,win->ContentHeight,Colors.WinBackGround     
       
      case WFLAG_WINDOWTYPE3
        ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,Colors.Black
        ClearBox win->DrawBuffer->img,win->ContentOffsetX,win->ContentOffsetY,win->ContentWidth,win->ContentHeight,Colors.White    
    
    end select
    
    if win->UserGFXBuffer then 
      if win->UserGFXBuffer->img then put win->DrawBuffer->img,(win->ContentOffsetX,win->ContentOffsetY),win->UserGFXBuffer->img,Alpha'pset
    end if
    
  end if
end sub

end namespace
