namespace sGUI

declare function AddCloseButton (win as sGUIWindow ptr,PosX as integer,PosY as integer) as Gadget ptr
declare function CloseButtonActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawCloseButton (gad as Gadget ptr)

'Ctrl(0) wenn 1 dann Toggle sonst Simple
'ctrl(13) mouse-over-control-flag
function AddCloseButton (win as sGUIWindow ptr,PosX as integer,PosY as integer) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadHeight=GetFontHeight+2*MinimumClearance
    gad->GadWidth=gad->GadHeight
    
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)

    gad->DoDraw     =@DrawCloseButton
    gad->DoAction   =@CloseButtonActions
    gad->DoUpdate   =@DrawCloseButton

    function=gad
  end if
end function


function CloseButtonActions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as integer doit=0
  dim as sGUIWindow ptr parentwin=cast(sGUIWindow ptr,gad->parent)
  select case action
      
      case GADGET_LMBHIT        'Control grad frisch gedrckt
        SetSelect (gad,1)
      
      case GADGET_LMBHOLD       'Control wird gehalten, Maus ber dem Control
        SetSelect (gad,1)
      
      case GADGET_LMBHOLDOFF    'Control wird gehalten, Maus neben dem Control
        SetSelect (gad,0)
      
      case GADGET_LMBRELEASE    'Control regulr losgelassen        
        SetSelect (gad,0)
        doit=1
        function=1           'Ping!!!! Control meldet sich: bei mir ist was passiert!!!        

      case GADGET_LMBRELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control
        SetSelect (gad,0)
      
      case GADGET_MOUSEHOVER   'Mouse berm Control
        gad->ctrl(13)=1
        DrawGadget(gad)

      case GADGET_MOUSENEXT   'Mouse vom Control wegbewegt
        gad->ctrl(13)=0
        DrawGadget(gad)
        
  end select
  
  if doit then
    if (parentwin->WinFlags and WFLAG_DELETEONCLOSE) then DeleteWindow(parentwin) else HideWindow(parentwin)
  end if
end function


sub DrawCloseButton (gad as Gadget ptr)
	dim as integer GadWidth,GadHeight
  dim as FB.Image ptr buffer
  dim as sGUIWindow ptr parentwin=cast(sGUIWindow ptr,gad->parent)
	GadWidth =gad->GadWidth
	GadHeight=gad->GadHeight
  Buffer   =gad->DrawBuffer->img'dereferenzieren
'OFF 
  ClearBox Buffer,0,0,GadWidth,GadHeight
'ON   unselect/select
  if gad->Activation then
    'glowfx
    if gad->ctrl(13) then 
      ClearBox Buffer,0,0,GadWidth,GadHeight,Colors.WarnRed
      circle Buffer,(GadWidth/2,GadHeight/2),3,Colors.WinTitleSelected
    else  
      if parentwin->Selection then        
        circle Buffer,(GadWidth/2,GadHeight/2),3,Colors.WinTitleSelected        
      else       
        circle Buffer,(GadWidth/2,GadHeight/2),3,Colors.WinTitle      
      end if   
    end if   
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,GadWidth,GadHeight
  end if    
end sub

end namespace
