type ColorStorage
  '0  AlphaValue 
  '1  Clean
  '2  Black  
  '3  White
  '4  WarnRed
  '5  WarnYellow
  '6  WarnGreen
  '7  Pen
  '8  BackGround	      
  
  '9  WinFrame    
  '10 WinFrameSelected
  '11 WinTitle
  '12 WinTitleSelected
  '13 WinBackGround  
  
  '14 GadBody			        
  '15 GadFrame
  '16 GadText	    
  '17 GadTextSelected   
  '18 GadBodyGlow	        
  '19 GadFrameGlow   
  '20 GadSleepGrid       
  
  Storage(21) as ulong
  declare property AlphaValue (Value as ubyte)   
  declare property Cleaning as ulong
  declare property Cleaning (RGBValue as ulong)
  declare property Black as ulong
  declare property White as ulong
  declare property WarnRed as ulong
  declare property WarnYellow as ulong  
  declare property WarnGreen as ulong   
  declare property Pen as ulong
  declare property Pen (RGBValue as ulong)  
  declare property BackGround as ulong
  declare property BackGround (RGBValue as ulong)
  declare property WinFrame as ulong
  declare property WinFrame (RGBValue as ulong)
  declare property WinTitle as ulong
  declare property WinTitle (RGBValue as ulong)
  declare property WinFrameSelected as ulong
  declare property WinFrameSelected (RGBValue as ulong)
  declare property WinTitleSelected as ulong
  declare property WinTitleSelected (RGBValue as ulong)
  declare property WinBackGround as ulong
  declare property WinBackGround (RGBValue as ulong)  

  declare property GadFrame as ulong
  declare property GadFrame (RGBValue as ulong)
  declare property GadBody as ulong
  declare property GadBody (RGBValue as ulong)
  declare property GadText as ulong
  declare property GadText (RGBValue as ulong)
  declare property GadTextSelected as ulong
  declare property GadTextSelected (RGBValue as ulong)
  declare property GadFrameGlow as ulong
  declare property GadFrameGlow (RGBValue as ulong)
  declare property GadBodyGlow as ulong
  declare property GadBodyGlow (RGBValue as ulong)
  declare property GadSleepGrid as ulong
  declare property GadSleepGrid (RGBValue as ulong)

  declare constructor
  declare sub AlphaRules
end type

constructor ColorStorage
  AlphaValue=255
  Storage(0)=Storage(0) shl 24
  Storage(2)=&HFFFFFF
  Storage(3)=&H0
  Storage(4)=&HDD0000
  Storage(5)=&HFFDD00 
  Storage(6)=&H00DD00
  AlphaRules
end constructor

sub ColorStorage.AlphaRules
  'Regelwerk, auf welchen RGBWerten der Alphawert angewendet wird
  'hier sind es noch alle, mal sehen, ob sich es ndert
  for i as integer=2 to ubound(Storage)
    Storage(i) = (Storage(i) and &HFFFFFF) or Storage(0)
  next 
end sub

property ColorStorage.AlphaValue (ByteValue as ubyte)'das UBYTE limitiert den Wert: 0 - 255
  Storage(0)=ByteValue
  Storage(0)=Storage(0) shl 24  
  AlphaRules
end property

'in den anderen (Farb-)Properties kann und soll separat entschieden werden, wie
'mit dem Alphawert gearbeitet wird. Im Moment machen alle Properties das gleiche:
'**********************************************
property ColorStorage.Cleaning as ulong
  Cleaning=Storage(1)
end property

property ColorStorage.Cleaning (RGBValue as ulong)
  Storage(1) = RGBValue'  or Storage(0)
  'Storage(1) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.White as ulong
  White=Storage(2)
end property

'**********************************************
property ColorStorage.Black as ulong
  Black=Storage(3)
end property

'**********************************************
property ColorStorage.WarnRed as ulong
  WarnRed=Storage(4)
end property

'**********************************************
property ColorStorage.WarnYellow as ulong
  WarnYellow=Storage(5)
end property

'**********************************************
property ColorStorage.WarnGreen as ulong
  WarnGreen=Storage(6)
end property

'**********************************************
property ColorStorage.Pen as ulong
  Pen=Storage(7)
end property

property ColorStorage.Pen (RGBValue as ulong)
 Storage(7) = (RGBValue and &HFFFFFF) or Storage(0)
 Color Storage(7)
end property

'**********************************************
property ColorStorage.BackGround as ulong
  BackGround=Storage(8)
end property

property ColorStorage.BackGround (RGBValue as ulong)
  Storage(8) = (RGBValue and &HFFFFFF) or Storage(0)
  color ,Storage(8)
end property

'**********************************************
property ColorStorage.WinFrame as ulong
  WinFrame=Storage(9)
end property

property ColorStorage.WinFrame (RGBValue as ulong)
  Storage(9) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.WinFrameSelected as ulong
  WinFrameSelected=Storage(10)
end property

property ColorStorage.WinFrameSelected (RGBValue as ulong)
  Storage(10) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.WinTitle as ulong
  WinTitle=Storage(11)
end property

property ColorStorage.WinTitle (RGBValue as ulong)
  Storage(11) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.WinTitleSelected as ulong
  WinTitleSelected=Storage(12)
end property

property ColorStorage.WinTitleSelected (RGBValue as ulong)
  Storage(12) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.WinBackGround as ulong
  WinBackGround=Storage(13)
end property

property ColorStorage.WinBackGround (RGBValue as ulong)
  Storage(13) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.GadBody as ulong
  GadBody=Storage(14)
end property

property ColorStorage.GadBody (RGBValue as ulong)
  Storage(14) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.GadFrame as ulong
  GadFrame=Storage(15)
end property

property ColorStorage.GadFrame (RGBValue as ulong)
  'Storage(15) = (RGBValue and &HFFFFFF) or Storage(0)
  Storage(15) = RGBValue or Storage(0)
End property

'**********************************************
property ColorStorage.GadText as ulong
  GadText=Storage(16)
end property

property ColorStorage.GadText (RGBValue as ulong)
  Storage(16) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.GadTextSelected as ulong
  GadTextSelected=Storage(17)
end property

property ColorStorage.GadTextSelected (RGBValue as ulong)
  Storage(17) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.GadFrameGlow as ulong
  GadFrameGlow=Storage(18)
end property

property ColorStorage.GadFrameGlow (RGBValue as ulong)
  Storage(18) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.GadBodyGlow as ulong
  GadBodyGlow=Storage(19)
end property

property ColorStorage.GadBodyGlow (RGBValue as ulong)
  Storage(19) = (RGBValue and &HFFFFFF) or Storage(0)
End property

'**********************************************
property ColorStorage.GadSleepGrid as ulong
  GadSleepGrid=Storage(20)
end property

property ColorStorage.GadSleepGrid (RGBValue as ulong)
  Storage(20) = (RGBValue and &HFFFFFF) or Storage(0)
End property
