'******************************************************************************
'******************************************************************************
'GFX***************************************************************************



declare function ShiftRGB (col as uinteger,shift as integer) as uinteger
declare sub ClearBox (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as uinteger=Colors.Cleaning)
declare sub Raster(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as uinteger=Colors.GadSleepGrid)
declare sub FrameB (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer,col as uinteger=Colors.BackGround,switch as integer)

declare sub FrameT (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer, txt as string="")
declare sub FillA (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,fill as uinteger=Colors.GadBody,frame as uinteger=Colors.GadFrame,switch as integer)
declare sub FillC (img as FB.Image ptr,PosX as integer,PosY as integer,col as uinteger=Colors.GadBody,switch as integer)

declare sub Tick (img as FB.Image ptr, PosX as integer,PosY as integer, col as uinteger)
declare sub Dot (img as FB.Image ptr, PosX as integer,PosY as integer, col as uinteger)
declare sub Arrow (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,d as integer,col as uinteger)
'******************************************************************************
'******************************************************************************
'******************************************************************************
'es folgen alle Grafikelemente und Farbroutinen, die in irgend einer Weise in den Gadgets benutzt werden (knnen)
'also eine Art Grafik-Baukasten



'erhht/verringert die RGB Werte einer Farbe um den Wert shift
'eine einfache Additions/Subtraktionsvariante
function ShiftRGB (col as uinteger,shift as integer) as uinteger
  dim as integer red,green,blue
  'RGB Splitting
  'mal wieder Volta
  'siehe http://forum.qbasic.at/viewtopic.php?t=4274&highlight=rgb
  red  =((col shr 16) and &HFF)+shift
	green=((col shr 8) and &HFF )+shift
	blue =(col and &HFF         )+shift
	if red<0 then red=0
  if green<0 then green=0
  if blue<0 then blue=0
	if red>255 then red=255
  if green>255 then green=255
  if blue>255 then blue=255
  function=rgb(red,green,blue)
end function

'von allen Gadgets als Reinigungsdienst benutzt
sub ClearBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as uinteger=Colors.Cleaning)
  line img, (PosX,PosY)-(PosX+BoxWidth-1,PosY+BoxHeight-1),col,BF
end sub

sub Raster(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as uinteger=Colors.GadSleepGrid)
  dim as ushort patternA,PatternB
  patternA=&B1010101010101010
  patternB=&B0101010101010101
  for i as integer=0 to BoxHeight-1
    line img, (PosX,PosY+i)-(PosX+BoxWidth-1,PosY+i),col,,patternA
    swap patternA,patternB
  next i
end sub

'Rahmen(hintergrundbezogen) in zwei Schaltzustnden, ungefllt
'SimpleGadget,ToggleGadget,CheckmarkGadget
sub FrameB (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer,col as uinteger=Colors.BackGround,switch as integer)
	dim as ColorDefinition topleft,bottomright,ptopleft,pmiddle,pbottomright
  topleft.SetRGB(col)
  bottomright.SetRGB(col)
  ptopleft.SetRGB(col)
  pmiddle.SetRGB(col)
  pbottomright.SetRGB(col)

  'Farben fr Hintergrundfase setzen
  if switch then
    topleft.ShiftValue(-50)
    bottomright.ShiftValue(50)
  else
    topleft.ShiftValue(-50)
    bottomright=topleft
	end if

  pset img, (PosX,PosY),ptopleft.GetRGB
  pset img, (PosX+BoxWidth-1,PosY),pmiddle.GetRGB
  pset img, (PosX+BoxWidth-1,PosY+BoxHeight-1),pmiddle.GetRGB
  pset img, (PosX,PosY+BoxHeight-1),pbottomright.GetRGB

  line img, (PosX+1,PosY)-(PosX+BoxWidth-2,PosY),topleft.GetRGB
  line img, (PosX+BoxWidth-1,PosY+1)-(PosX+BoxWidth-1,PosY+BoxHeight-2),bottomright.GetRGB
  line img, (PosX+BoxWidth-2,PosY+BoxHeight-1)-(PosX+1,PosY+BoxHeight-1),bottomright.GetRGB
  line img, (PosX,PosY+BoxHeight-2)-(PosX,PosY+1),topleft.GetRGB
end sub

'Rahmen (hintergrundbezogen) mit Text, gefllt, fr Gliederung der Oberflche
sub FrameT (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer, txt as string="")
  dim as integer foheight,txtwidth
  foheight=GetFontHeight
  txtwidth=GetTextWidth(txt)

  dim as ColorDefinition lite,dark
  lite.SetRGB(Colors.BackGround)
  dark.SetRGB(Colors.BackGround)
  if lite.GetSaturation then 'wenn Sttigung>0 ist es eine Farbe
    lite.ShiftSaturation(-50)
    dark.ShiftSaturation(50)
  else                      'Wenn Sttigung=0 Grauwert
    lite.ShiftValue(-50)
    dark.ShiftValue(50)
  end if

	line img, (PosX+1,PosY+1)-(PosX+BoxWidth-1,PosY+BoxHeight-1),lite.GetRGB,b
  line img, (PosX,PosY)-(PosX+BoxWidth-2,PosY+BoxHeight-2),dark.GetRGB,b
  line img, (PosX+2,PosY+2)-(PosX+BoxWidth-3,PosY+BoxHeight-3),Colors.BackGround,bf 'Lschen des Frameinneren

	if txtwidth then
    line img, (PosX+2*MinimumClearance,PosY-foheight/2)-(PosX+2*MinimumClearance+txtwidth,PosY-foheight/2 + foheight),Colors.BackGround,bf
    DrawString (img, PosX+2*MinimumClearance,PosY-foheight/2,txt)
  end if
end sub

'gefllte farbige Box in zwei Schaltzustnden
'SimpleGadget,ToggleGadget,CheckmarkGadget
Sub FillA (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,fill as uinteger=Colors.GadBody,frame as uinteger=Colors.GadFrame,switch as integer)
	dim as ColorDefinition frm,fll
  frm.SetRGB(frame)
  fll.SetRGB(fill)
  if switch then
		if sgn(SelectBrightnessValue)<0 then
			frm.ShiftValue(SelectBrightnessValue)
			fll.ShiftValue(SelectBrightnessValue)		
		else
			frm.ShiftSaturation(-SelectBrightnessValue)
			fll.ShiftSaturation(-SelectBrightnessValue)		
		end if
	end if
	line img, (PosX,PosY)-(PosX+BoxWidth-1,PosY+BoxHeight-1),frm.GetRGB,b
	line img, (PosX+1,PosY+1)-(PosX+BoxWidth-2,PosY+BoxHeight-2),fll.GetRGB,bf
end sub


'Radiobutton Frame 16x16
Sub FillC (img as FB.Image ptr, PosX as integer,PosY as integer,col as uinteger=Colors.GadBody,switch as integer)
	dim as ColorDefinition frm,fll
  frm.SetRGB(col)
  fll.SetRGB(col)
  if fll.GetSaturation then 'wenn Sttigung>0 ist es eine Farbe, modifiziere Sttigung
    frm.ShiftSaturation(50)
  else                      'Wenn Sttigung=0 Grauwert, modifiziere Schwarzwert
    frm.ShiftValue(-25)
  end if
  if switch then
  	frm.Shiftvalue(-20)
    fll.Shiftvalue(-20)
	end if

  line img, (PosX+5,PosY)-(PosX+10,PosY),frm.GetRGB
    line img, (PosX+10,PosY)-(PosX+13,PosY+2),frm.GetRGB
    line img, (PosX+13,PosY+2)-(PosX+15,PosY+5),frm.GetRGB
  line img, (PosX+15,PosY+5)-(PosX+15,PosY+10),frm.GetRGB
    line img, (PosX+15,PosY+10)-(PosX+13,PosY+13),frm.GetRGB
    line img, (PosX+13,PosY+13)-(PosX+10,PosY+15),frm.GetRGB
  line img, (PosX+10,PosY+15)-(PosX+5,PosY+15),frm.GetRGB
    line img, (PosX+5,PosY+15)-(PosX+2,PosY+13),frm.GetRGB
    line img, (PosX+2,PosY+13)-(PosX,PosY+10),frm.GetRGB
  line img, (PosX,PosY+10)-(PosX,PosY+5),frm.GetRGB  
    line img, (PosX,PosY+5)-(PosX+2,PosY+2),frm.GetRGB
    line img, (PosX+2,PosY+2)-(PosX+5,PosY),frm.GetRGB    
  paint img, (PosX+7,PosY+7),Colors.White,frm.GetRGB
    
    if fll.GetSaturation then 'wenn Sttigung>0 ist es eine Farbe
      fll.ShiftSaturation(50)
    else                      'Wenn Sttigung=0 Grauwert
      fll.ShiftValue(-50)
    end if
  if switch then Dot (img, PosX+4,PosY +4,fll.GetRGB)
end sub

'farbiges Symbol
'"Hkchen" fr CheckMarkGadget 8x9 px
sub Tick (img as FB.Image ptr, PosX as integer,PosY as integer, col as uinteger)
  line img, (PosX+1,PosY+4)-(PosX+4,PosY+7),col
  line img, (PosX,PosY+4)-(PosX+3,PosY+7),col

  line img, (PosX+4,PosY+7)-(PosX+7,PosY),col
  line img, (PosX+3,PosY+7)-(PosX+6,PosY),col
end sub

'farbiges Symbol
'RadiobuttonDot  8x8 px
sub Dot (img as FB.Image ptr, PosX as integer,PosY as integer, col as uinteger)
	dim as ColorDefinition frm,fll
  frm.SetRGB(col)
  fll.SetRGB(col)
  
  if fll.GetSaturation then 'wenn Sttigung>0 ist es eine Farbe
    frm.ShiftSaturation(33)
  else                      'Wenn Sttigung=0 Grauwert
    frm.ShiftValue(-33)
  end if

  line img, (PosX+2,PosY)-(PosX+5,PosY),frm.GetRGB
    pset img, (PosX+6,PosY+1),frm.GetRGB
  line img, (PosX+7,PosY+2)-(PosX+7,PosY+5),frm.GetRGB
    pset img, (PosX+6,PosY+6),frm.GetRGB
  line img, (PosX+5,PosY+7)-(PosX+2,PosY+7),frm.GetRGB
    pset img, (PosX+1,PosY+6),frm.GetRGB
  line img, (PosX,PosY+5)-(PosX,PosY+2),frm.GetRGB
    pset img, (PosX+1,PosY+1),frm.GetRGB
  paint img, (PosX+3,PosY+3),fll.GetRGB,frm.GetRGB
end sub



'farbiges Symbol
'Pfeil
sub Arrow (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,d as integer,col as uinteger)
  for i as integer=0 to 2
    select case d
      case 0'l
        line img, (PosX+size+i,PosY)-(PosX+i,PosY+size),col
        line img,                 -(PosX+size+i,PosY+2*size),col
      case 1'r
        line img, (PosX+i,PosY)-(PosX+size+i,PosY+size),col
        line img,                 -(PosX+i,PosY+2*size),col
      case 2'up
        line img, (PosX,PosY+size+i)-(PosX+size,PosY+i),col
        line img,                 -(PosX+2*size,PosY+size+i),col
      case 3'dwn
        line img, (PosX,PosY+i)-(PosX+size,PosY+size+i),col
        line img,                 -(PosX+2*size,PosY+i),col
    end select
  next
end sub
