declare sub MasterControlProgram(win as sGUIWindow ptr=RootWindow, FirstCall as integer=1)
declare sub MCP_Crawler (win as sGUIWindow ptr=Rootwindow)
declare sub Selection_Crawler (parentwin as sGUIWindow ptr=RootWindow, selectedwin as sGUIWindow ptr)
declare sub AlwaysOnTop_Crawler (win as sGUIWindow ptr=Rootwindow)
declare sub Backdrop_Crawler (win as sGUIWindow ptr=Rootwindow)
declare sub WinMSG_Crawler (win as sGUIWindow ptr)
declare sub GUIBuild_Crawler(win as sGUIWindow ptr)
declare function GetWindowPointer(win as sGUIWindow ptr=RootWindow) as sGUIWindow ptr
declare function GetWarnWindow(win as sGUIWindow ptr=RootWindow) as sGUIWindow ptr 

sub MasterControlProgram(win as sGUIWindow ptr=RootWindow, FirstCall as integer=1)
  dim as Gadget ptr childgad
  dim as sGUIWindow ptr childwin,parentwin,warnwin
  static as sGUIWindow ptr refwin
  
  'Einstieg, nicht rekursiver Teil:
  if Firstcall=1 then
    GetSysEvents
    GADGETMESSAGE=0
    WINDOWMESSAGE=0
    warnwin=GetWarnWindow
    
     select case LMB
      case HIT
        if warnwin then       
          refwin=warnwin
        else
          refwin=GetWindowPointer
          if refwin<>Rootwindow then 
            if (refwin->WinFlags and WFLAG_STACKABLE) then cast(sGUIWindow ptr,refwin->parent)->WindowList->MoveToLast(refwin) 
          end if
          AlwaysOnTop_Crawler
          Backdrop_Crawler
          Selection_Crawler(RootWindow,refwin)          
        end if    
        MasterControlProgram(refwin,0)
      
      case HOLD,RELEASE
        if refwin then MasterControlProgram(refwin,0)
      case RELEASED
        refwin=0
        'geht davon aus, dass keine Maus gedrckt ist, wenn ein WARN Fenster erscheint.
        'falls es zu Problemen kommt, diesen IF...END IF Block oberhalb der LMB SELECT...CASE Abfrage plazieren
        if warnwin then
          cast(sGUIWindow ptr,warnwin->parent)->WindowList->MoveToLast(warnwin)
          Selection_Crawler(RootWindow,warnwin)
        end if        
        'geht rekursiv durch alle Fenster und ruft dort jeweils das MCP auf, als Aufrum- und Putzkolonne.
        'Beispielsweise wird hierber der HoveringOverGadgetCheck in allen Fenstern realisiert, wenn keine Maustaste gedrckt wurde
        'ist also ein genereller Leerlaufrun durch die gesamte GUI
        MCP_Crawler
    end select
  end if
  
  
  'rekursiver Teil:
  if FirstCall=0 then
    'Loop durch die GadgetList dieses Fensters
    'wenn ein Gadget ein Window enthlt erfolgt erneut ein rekursiver Aufruf des MCPs
    'composite Gadgets, also zusammengesetzte, werden mit Sicherheit ein Window mit weiteren Gadgets haben    
    childgad=win->GadgetList->GetFirst
    if childgad then
      do
        if childgad->GadgetWindow then MasterControlProgram(childgad->GadgetWindow,0)'<<<----!!!!
        childgad=cast(Gadget ptr,childgad->next_node)
      loop until childgad=0
    end if  
    'Actionen der Gadgets
    'Memberroutinen des Windows, aufgelster EventHandle
    'enthalten z.T auch Loops durch GadgetList dieses Fensters    
    win->LMBGadgetCheck
    win->WheelGadgetCheck    
    win->KeyboardGadgetCheck
    win->HoveringOverGadgetCheck
    'sollte im untersuchten Fenster ein Ereignis festgestellt worden sein, dieses an die globale Variable "durchschleifen" 
    if win->GADMESSAGE then 
      GADGETMESSAGE=win->GADMESSAGE
      WINDOWMESSAGE=win
    end if
  end if
  
  'Austieg, nicht rekursiver Teil:
  if FirstCall=1 then
    WinMSG_Crawler (WINDOWMESSAGE)
    GUIBuild_Crawler (RootWindow)'komplette GUI ins RootWindow Image zeichnen
    screenlock
      cls
      if RootWindow->UserGFXBuffer then 
        if RootWindow->UserGFXBuffer->img then put (0,0),RootWindow->UserGFXBuffer->img,PSet
      end if
      put (0,0),RootWindow->DrawBuffer->img,Alpha'trans
    screenunlock  
  end if
end sub

 
sub MCP_Crawler (win as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr childwin
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      if childwin->Activation then MCP_Crawler(childwin)
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if
  MasterControlProgram(win,0)
end sub


sub Selection_Crawler (parentwin as sGUIWindow ptr=RootWindow, selectedwin as sGUIWindow ptr)
  dim as _sGUIWindow ptr childwin

  parentwin->Selection=iif(parentwin=selectedwin,1,0) 
  if (parentwin->WinFlags and WFLAG_ALWAYSSELECTED) then parentwin->Selection=1
  if (parentwin->WinFlags and WFLAG_ALWAYSUNSELECTED) then parentwin->Selection=0
  childwin=parentwin->WindowList->GetFirst
  if childwin then
    do
      if childwin->Activation then Selection_Crawler (childwin, selectedwin)  
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if
end sub


sub AlwaysOnTop_Crawler (win as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr childwin
  dim as ListObject ptr WindowPointerList
  dim as node ptr n
  
  childwin=win->WindowList->GetFirst
  if childwin then                                               
        
    'Erzeugen einer Indexlist, die die Pointer aller ALWAYSONTOP Fenster aufnimmt
    
    WindowPointerList=PointerLists->AppendNew (ListObjectType) 
    'Suche nach ALWAYSONTOP
    'bei mehreren ALWAYSONTOP bleibt deren Reihenfolge relativ zueinander erhalten    
    do
      if childwin->Activation=1 then
        if (childwin->WinFlags and WFLAG_ALWAYSONTOP) then 'wenn ein ALWAYSONTOP gefunden wurde, merken wir uns dieses in der WindowPointerList
          n=WindowPointerList->AppendNew (nodeType)
          n->anypointer=cast(any ptr,childwin)
        end if
      end if
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
    
    'wenn ein oder mehrere ALWAYSONTOP gefunden wurde, diese jetzt nach oben verschieben
    n=WindowPointerList->GetFirst
    if n then
      do
        win->WindowList->MoveToLast( cast(sGUIWindow ptr, n->anypointer)  )
        n=cast(node ptr,n->next_node)
      loop until n=0
    end if
    
    'Indexliste lschen
    PointerLists->DeleteNode(WindowPointerList)
    
    'Nach Sortierung rekursiver Aufruf
    childwin=win->WindowList->GetFirst
    do
      if childwin->Activation=1 then AlwaysOnTop_Crawler(childwin)         
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if 
end sub


sub Backdrop_Crawler (win as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr childwin
  dim as ListObject ptr WindowPointerList
  dim as node ptr n
  
  childwin=win->WindowList->GetLast'WindowPointerList rckwrts durchsuchen
  if childwin then                                                      
    'Erzeugen einer Indexlist, die die Pointer aller BACKDROP Fenster aufnimmt    
    WindowPointerList=PointerLists->AppendNew (ListObjectType) 
    'Suche nach BACKDROP
    'bei mehreren BACKDROP bleibt deren Reihenfolge relativ zueinander erhalten    
    
    do
      if childwin->Activation=1 then
        if (childwin->WinFlags and WFLAG_BACKDROP) then 'wenn ein BACKDROP gefunden wurde, merken wir uns dieses in der WindowPointerList
          n=WindowPointerList->AppendNew (nodeType)
          n->anypointer=cast(any ptr,childwin)
        end if
      end if
      childwin=cast(sGUIWindow ptr,childwin->prev_node)
    loop until childwin=0
    
    'wenn ein oder mehrere BACKDROP gefunden wurde, diese jetzt nach oben verschieben
    n=WindowPointerList->GetFirst
    if n then
      do
        win->WindowList->MoveToFirst( cast(sGUIWindow ptr, n->anypointer)  )
        n=cast(node ptr,n->next_node)
      loop until n=0
    end if
    
    'Indexliste lschen
    PointerLists->DeleteNode(WindowPointerList)
    
    'Nach Sortierung rekursiver Aufruf
    childwin=win->WindowList->GetFirst
    do
      if childwin->Activation=1 then Backdrop_Crawler(childwin)         
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if 
end sub


sub WinMSG_Crawler (win as sGUIWindow ptr)
  if win then
    WINDOWMESSAGE=win
    if (win->WinFlags and WFLAG_SENDWMSGASPARENT) then WinMSG_Crawler(cast(sGUIWindow ptr,win->parent))  
  end if
end sub


sub GUIBuild_Crawler(win as sGUIWindow ptr)
  dim as Gadget ptr childgad,parentgad
  dim as sGUIWindow ptr childwin,parentwin

  win->DoDraw(win)
  'Loop durch die GadgetList dieses Fensters 
  childgad=win->GadgetList->GetFirst
  if childgad then
    do
      childgad->DoDraw(childgad)    
      if childgad->GadgetWindow then GUIBuild_Crawler(childgad->GadgetWindow)      
      put win->DrawBuffer->img,(win->ContentOffsetX + childgad->PosX, win->ContentOffsetY + childgad->PosY),childgad->DrawBuffer->img,alpha'trans
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until childgad=0
  end if
  
  'Loop durch die WindowList dieses Fensters
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      if childwin->Activation then GUIBuild_Crawler(childwin)
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if  

  if win->parent then 
    if cast(WinGadHeader ptr,win->parent)->KindOfType=0 then 'wenn parent ein Fenster ist
      parentwin=cast(sGUIWindow ptr,win->parent)
      put parentwin->DrawBuffer->img,(parentwin->ContentOffsetX + win->PosX, parentwin->ContentOffsetY + win->PosY),win->DrawBuffer->img,PSet
    else                                                'wenn parent ein Gadget ist
      parentgad=cast(Gadget ptr,win->parent)
      put parentgad->DrawBuffer->img,(win->PosX,win->PosY),win->DrawBuffer->img,PSet
    end if        
  end if
end sub


function GetWindowPointer(win as sGUIWindow ptr=RootWindow) as sGUIWindow ptr
  dim as _sGUIWindow ptr childwin,hoverwin
  dim as integer WinX,WinY
  GetGlobalPosition(win,WinX,WinY) 
  hoverwin=win
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      if childwin->Activation then'nur bei Activation=1 gibt es eine Antwort        
        if (MOUSEX >= WinX+childwin->PosX) and (MOUSEX < WinX+childwin->PosX+childwin->WinWidth) and _
           (MOUSEY >= WinY+childwin->PosY) and (MOUSEY < WinY+childwin->PosY+childwin->WinHeight) then
           hoverwin=childwin        
        end if
      end if  
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if
  if hoverwin<>win then hoverwin=GetWindowPointer(hoverwin)
  function=hoverwin
end function


function GetWarnWindow(win as sGUIWindow ptr=RootWindow) as sGUIWindow ptr
  dim as _sGUIWindow ptr childwin
  static as sGUIWindow ptr warnwin=0
 
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      if childwin->Activation then GetWarnWindow(childwin)
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if
  
  if (win->WinFlags and WFLAG_WARN) then warnwin=win
  
  function=warnwin
end function
