'******************************************************************************
'******************************************************************************
'******************************************************************************

'Hngt einen Eintrag an die TOListe
function AddTextObject as TextObject ptr
  function=TOList->AppendNew (TextObjectType)
end function

'Lscht den betreffenden Eintrag aus der TOListe
sub DelTextObject(t as TextObject ptr)
  TOList->DeleteNode (t)
end sub

'Hngt einen Einrag an die Imageliste,"leer" ohne ein existierndes reales Image
function AddImageEntry as sGUIImage ptr
  function=ImageList->AppendNew (sGUIImageType)
end function

'Lscht den betreffenden Eintrag aus der Imageliste. Ein "darin befindliches" reales
'Image wird via Destructor gelscht (siehe sGUI_ImageType.bas)
sub DelImageEntry(sguiimg as sGUIImage ptr)
  ImageList->DeleteNode(sguiimg)
end sub


function AddMenu as Menu ptr
  function=MenuList->AppendNew(sGUIMenuType)
end function

sub DelMenu (m as _Menu ptr)

end sub

'**************************************************************************************************
'**************************************************************************************************
'Aktivierung***************************************************************************************

sub ShowWindow    (win as _sGUIWindow ptr)
  win->Activation=1
end sub


sub HideWindow    (win as _sGUIWindow ptr)
  win->Activation=0
end sub


sub DeleteWindow  (win as _sGUIWindow ptr)
  win->Activation=0
  KillWindow (win)
end sub


sub GadgetOn (gad as Gadget ptr)
  ModifyActivation(gad,ACTIVATION_ON)
end sub


sub GadgetSleep (gad as Gadget ptr)
  ModifyActivation(gad,ACTIVATION_SLEEP)
end sub


sub GadgetOff (gad as Gadget ptr)
  ModifyActivation(gad,ACTIVATION_OFF)
end sub

sub RestoreActivation (gad as Gadget ptr)
  dim oa as integer=gad->Activation_Old
  select case oa
    case ACTIVATION_OFF
      GadgetOff (gad)
    case ACTIVATION_OFF
      GadgetOn (gad)
    case ACTIVATION_SLEEP
      GadgetSleep (gad)
  end select
end sub

sub ModifyActivation (gad as _Gadget ptr, mode as integer=ACTIVATION_OFF)
  dim as _Gadget ptr childgad
  'rekursiver Aufruf falls es ein GadgetWindow gibt
  select case mode
    case ACTIVATION_OFF
      gad->Activation_Old=gad->Activation'alten Zustand merken
      gad->Activation=ACTIVATION_OFF  
      gad->DoDraw (gad)  
      'wenn Gadget ein Fenster enthlt
      if gad->GadgetWindow then
        childgad=gad->GadgetWindow->GadgetList->GetFirst
        if childgad then
          do
            ModifyActivation(childgad,ACTIVATION_OFF)
            childgad=cast(Gadget ptr,childgad->next_node)
          loop until childgad=0
        end if
      end if  
  
    case ACTIVATION_ON
      'if gad->Background=0 then gad->SaveBackGround
      gad->Activation_Old=gad->Activation'alten Zustand merken
      gad->Activation=ACTIVATION_ON  
      gad->DoDraw (gad)  
      'wenn Gadget ein Fenster enthlt
      if gad->GadgetWindow then
        childgad=gad->GadgetWindow->GadgetList->GetFirst
        if childgad then
          do
            ModifyActivation(childgad,ACTIVATION_ON)
            childgad=cast(Gadget ptr,childgad->next_node)
          loop until childgad=0
        end if
      end if
      
    case ACTIVATION_SLEEP
      'if gad->Background=0 then gad->SaveBackGround
      gad->Activation_Old=gad->Activation'alten Zustand merken
      gad->Activation=ACTIVATION_SLEEP  
      gad->DoDraw (gad)  
      'wenn Gadget ein Fenster enthlt
      if gad->GadgetWindow then
        childgad=gad->GadgetWindow->GadgetList->GetFirst
        if childgad then
          do
            ModifyActivation(childgad,ACTIVATION_SLEEP)
            childgad=cast(Gadget ptr,childgad->next_node)
          loop until childgad=0
        end if
      end if      
  end select    
end sub


'**************************************************************************************************
'**************************************************************************************************
'Selektion*****************************************************************************************
function GetSelect (gad as Gadget ptr) as integer
  function=gad->Selection
end function


sub SetSelect (gad as Gadget ptr,Selection as integer)
  gad->Selection=selection
  gad->DoDraw (gad)
end sub


'**************************************************************************************************
'**************************************************************************************************
'Draw/Action/Update********************************************************************************
sub DrawGadget(gad as _Gadget ptr)
  gad->DoDraw (gad)
end sub


function GadgetAction(gad as _Gadget ptr, action as integer) as integer
  function=gad->DoAction(gad,action)
end function


sub UpdateGadget(gad as _Gadget ptr)
  'gad->DoUpdate(gad)
  gad->MainUpdate
end sub


sub SetCaption(gad as _Gadget ptr,Text as string)
  gad->caption=Text
  UpdateGadget(gad)
end sub

'**************************************************************************************************
'**************************************************************************************************
'**************************************************************************************************
/'
sub UpdateInternalEventHandle (gad as _Gadget ptr)
	'if gad->subevent then
  '  gad->subevent->parentevent=gad->event
  '  gad->subevent->guiposX=gad->PosX
  '  gad->subevent->guiposY=gad->PosY
  'end if
end sub
'/


'******************************************************************************
'******************************************************************************
'Umlaute***********************************************************************

function UImport(s as string) as string
  function=""
  dim as string tmps
  dim as integer i,tmpasc
  if len(s) then
    tmps=s
    for i=1 to len(s)
      tmpasc=asc(mid(tmps,i,1))
      if tmpasc=228 then tmpasc=132 'ae
      if tmpasc=246 then tmpasc=148 'oe
      if tmpasc=252 then tmpasc=129 'ue

      if tmpasc=196 then tmpasc=142 'AE
      if tmpasc=214 then tmpasc=153 'OE
      if tmpasc=220 then tmpasc=154 'UE

      if tmpasc=223 then tmpasc=225 '"Eszett" zu "Beta"???

      mid(tmps,i,1)=chr(tmpasc)
    next i
    function=tmps
  end if
end function


function UExport(s as string) as string
  function=""
  dim as string tmps
  dim as integer i,tmpasc
  if len(s) then
    tmps=s
    for i=1 to len(tmps)
      tmpasc=asc(mid(tmps,i,1))
      if tmpasc=132 then tmpasc=228 'ae
      if tmpasc=148 then tmpasc=246 'oe
      if tmpasc=129 then tmpasc=252 'ue

      if tmpasc=142 then tmpasc=196 'AE
      if tmpasc=153 then tmpasc=214 'OE
      if tmpasc=154 then tmpasc=220 'UE

      if tmpasc=225 then tmpasc=223 '"Beta" zu "Eszett"???

      mid(tmps,i,1)=chr(tmpasc)
    next i
    function=tmps
  end if
end function


'******************************************************************************
'******************************************************************************
'Stringparser******************************************************************
'Setzt einen gltigen Dateinamen, wie vom FileRequester geliefert, vorraus!!!
'd.h. Dateiname mu sowohl die Pfadinformation als auch einen Dateinamen enthalten.
'Erweiterung optional

type FileNameInfo
  public:
  PathAndFile     as string
  Path            as string
  File            as string
  FileWithoutExt  as string
  Ext             as string

  public:
  declare constructor
  declare sub ParseFileName(filename as string)
end type


constructor FileNameInfo
  PathAndFile   =""
  Path          =""
  File          =""
  FileWithoutExt=""
  Ext           =""
end constructor


sub FileNameInfo.ParseFileName(filename as string)
  PathAndFile   =""
  Path          =""
  File          =""
  FileWithoutExt=""
  Ext           =""
  if filename<>"" then
    dim as string sep
    'define the path separation
    #ifdef __fb_win32__
      sep="\"
    #endif
    'Tux Variante
    #ifdef __FB_LINUX__
      sep="/"
    #endif

    dim as integer length,posext,posfile
    posext=0
    posfile=0
    PathAndFile=filename
    length=len(PathAndFile)
    posfile=instrrev(PathAndFile,sep)
    File=right(PathAndFile,length - posfile)
    Path=left(PathAndFile,posfile)
    posext=instrrev(File,".")
    if posext then
      FileWithoutExt=left(File,posext - 1)
      Ext=right(File,len(File) - posext + 1)
    end if
  end if
end sub


sub GetGlobalPosition(entity as any ptr, byref PosX as integer, byref PosY as integer)
  dim as _WinGadHeader ptr wgheader
  dim as any ptr parent
  wgheader=cast(_WinGadHeader ptr, entity)
  PosX +=wgheader->PosX
  PosY +=wgheader->PosY  
  if wgheader->KindOfType=0 then'bei einem Fenster, ContentOffsets hinzufgen
    PosX +=cast(sGUIWindow ptr, wgheader)->ContentOffsetX
    PosY +=cast(sGUIWindow ptr, wgheader)->ContentOffsetY
  end if
  parent=wgheader->parent  
  if parent then GetGlobalPosition(parent,PosX,PosY)
end sub
