declare sub WindowInitialDraw (win as _sGUIWindow ptr)
declare sub KillWindow (win as _sGUIWindow ptr)
declare sub KillGadget (gad as _Gadget ptr)
declare function EnableUserGFX (win as _sGUIWindow ptr=0) as FB.Image ptr

type WinGadHeader extends node
  parent      as any ptr'Zeiger auf ein Parent, dies kann beides sein: Window oder Gadget
  KindOfType  as integer'Flag 0=Window,1=Gadget. Nur zur Sicherheit, mal sehen ob es gebraucht wird 
  PosX        as integer
  PosY        as integer
  
  Caption     as string     'Text / Bezeichnung
  
  'sGUIImage, dorthinein wird das Gadget/Window gezeichnet
  DrawBuffer    as _sGUIImage ptr
  'zweites Image, falls User in das Window/Gadget zeichnen darf, derzeit nur bei Windows mglich
  UserGFXBuffer as _sGUIImage ptr

  Selection       as integer
  Activation      as integer
  Activation_Old  as integer
end type

'******************************************************************************
'******************************************************************************
'******************************************************************************
'Gadget

type Gadget extends WinGadHeader
  GadWidth    as integer    'Gadgetbreite
  GadHeight   as integer    'Gadgethhe 
   
  Ctrl(15)    as integer    'Steuerungsvariablen, je nach Gadgettyp unterschiedlich oder auch gar nicht genutzt
  
  DoDraw      as sub      (gad as Gadget ptr)                                     'Platzhalter Zeichenroutine
  DoAction    as function (refgad as Gadget ptr, action as integer) as integer    'Platzhalter fr Ereignis-Routine
  DoUpdate    as sub      (gad as Gadget ptr)                                     'Platzhalter Update
  
  GadgetWindow as _sGUIWindow ptr'ein Gadget darf ein Fenster enthalten   
    
  'alle TextObjekte werden in einer globalen Liste verwaltet
  TObject     as _TextObject ptr
  
  declare constructor
  declare destructor
  declare sub MainUpdate
end type


constructor Gadget
  KindOfType=1'its a Gadget
  DrawBuffer=ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!  
end constructor

destructor Gadget
end destructor

sub Gadget.MainUpdate
  'UpdateInternalEventHandle(@this)
  if DoUpdate then DoUpdate(@this)
end sub

'******************************************************************************
'******************************************************************************
'******************************************************************************
'Window
 
type sGUIWindow extends WinGadHeader
  WinFlags        as integer
  WinWidth        as integer
  WinHeight       as integer
  ContentOffsetX  as integer
  ContentOffsetY  as integer
  ContentWidth    as integer
  ContentHeight   as integer
  Created         as double
  
  GADMESSAGE      as _Gadget ptr'Nummer(genauer Pointer) des Gadgets, welches nen "Ping" von sich gibt
  private:
  'Gadget Zeugs
  refgad         as _Gadget ptr 'Referenz Gadget, auf dem der Rest des Clickvorganges basiert
  actgad         as _Gadget ptr
  wheelgad       as _Gadget ptr

  'Maus ber Gadget Handling
  mousehover    as _Gadget ptr'Referenz zu einem Control ber dem die Maus "schwebt"
  mousenext     as _Gadget ptr'Referenz zu einem Control von dem sich die Maus weg bewegt hat

  'letzter abgearbeiteter Tastenstatus der Maus im EventHandle
  lastLMB        as integer
  lastMMB        as integer
  lastRMB        as integer
  keygad         as _Gadget ptr  
  
  public:
  GadgetList as ListObject ptr
  WindowList as ListObject ptr
  
  DoDraw      as sub      (win as sGUIWindow ptr)                                     'Platzhalter Zeichenroutine
  DoAction    as function (refwin as sGUIWindow ptr, action as integer) as integer    'Platzhalter fr Ereignis-Routine
  DoUpdate    as sub      (win as sGUIWindow ptr)                                     'Platzhalter Update
  
  declare constructor ()
  declare destructor ()
  declare sub xSleep (eventmode as integer,XButton as integer=1)
  declare sub LMBGadgetCheck
  declare sub MMBGadgetCheck 
  declare sub RMBGadgetCheck
  declare sub WheelGadgetCheck
  declare sub HoveringOverGadgetCheck
  declare sub KeyboardGadgetCheck
  private:
  declare function GetGadgetPointer as _Gadget ptr
end type

constructor sGUIWindow
  KindOfType  = 0'its a Window
  GadgetList  = GadgetLists->AppendNew(ListObjectType)
  WindowList  = WindowLists->AppendNew(ListObjectType)   
  DrawBuffer  = ImageList->AppendNew(sGUIImageType)'leer, noch ohne Image!  
  DoDraw=@WindowInitialDraw
  DoUpdate=@WindowInitialDraw
end constructor


destructor sGUIWindow
end destructor

'Methoden
Sub sGUIWindow.WheelGadgetCheck
  'Gadgetaktionen fr Mausrad
  if WHEEL<>0 then
    wheelgad=GetGadgetPointer
    if (wheelgad>0) then GadgetAction(wheelgad,GADGET_WHEELMOVE)
  end if
End Sub


sub sGUIWindow.LMBGadgetCheck
  if GadgetList->GetFirst then
    dim as integer result,action
    GADMESSAGE=0

    'Gadgetaktionen fr linken Maustaste
    'if (lastLMB=RELEASE) and (LMB>RELEASE) then refgad=0
    select case LMB
      case HIT 'wenn Maus grad gedrckt wurde
        refgad=0           'Variablen zurcksetzen
        actgad=0
        result=0
        refgad=GetGadgetPointer
        if refgad then action=GADGET_LMBHIT

      case HOLD
        if refgad then
          actgad=GetGadgetPointer
          if actgad=refgad then action=GADGET_LMBHOLD else action=GADGET_LMBHOLDOFF
        end if

      case RELEASE
        if refgad then
          actgad=GetGadgetPointer
          if actgad=refgad then action=GADGET_LMBRELEASE else action=GADGET_LMBRELEASEOFF
        end if

      case RELEASED

    end select
    'lastLMB=LMB

    if refgad then result=GadgetAction(refgad,action)
    if (result>0) then GADMESSAGE=refgad

    'Keyboard ins Control ausschalten
    if (keygad>0) and (refgad>0) and (refgad<>keygad) then
      GadgetAction(keygad,GADGET_KEYBOARDOFF)
      keygad=0
    end if
    'Keyboard ins Control einschalten
    if result=-1 then keygad=refgad

  end if
end sub


sub sGUIWindow.HoveringOverGadgetCheck
  mousehover=GetGadgetPointer
  if mousehover then
    GadgetAction(mousehover,GADGET_MOUSEHOVER)
    if (mousehover<>mousenext) and (mousenext>0) then GadgetAction(mousenext,GADGET_MOUSENEXT)
    mousenext=mousehover
  else
    if mousenext then GadgetAction(mousenext,GADGET_MOUSENEXT)
    mousenext=0
  end if
end sub


sub sGUIWindow.KeyboardGadgetCheck
  dim as integer result
  if (KEY<>"") and (keygad>0) then
    if (keygad->Activation=1) then result=GadgetAction(keygad,GADGET_KEYBOARD)
    if (result<>0) then GADMESSAGE=keygad
    if (result=-1) then
      GadgetAction(keygad,GADGET_KEYBOARDOFF)
      keygad=0
    end if
  end if
end sub



function sGUIWindow.GetGadgetPointer as _Gadget ptr
  dim as _Gadget ptr gad,hover
  dim as uinteger col
  dim as integer guix,guiy,gadx,gady
  function=0  
  GetGlobalPosition(@this,guix,guiy)
  gad=GadgetList->GetFirst
  if gad then
    do
      gadx=guix + gad->posx
      gady=guiy + gad->posy
      hover=0
      if gad->Activation=1 then'nur bei Activation=1 gibt es eine Antwort
        if  (MOUSEX>=gadx) and (MOUSEX<gadx + gad->GadWidth) and (MOUSEY>=gady) and (MOUSEY<gady + gad->GadHeight) then
          'MaskenHandling erst einmal herausgenommen!!!!
          'wenn eine Maske existiert, dann ausschliessen ob die Maus-Position
					'nicht ber einem Pixel mit der Farbe RGB(255,0,255) ist!
					'if (gad->Mask>0) then
          '  col=point(MOUSEX-gadx,MOUSEY-gady,gad->Mask->img)
          '  if col<>&HFFFF00FF then hover=gad
					'else'ohne Maske
						hover=gad
					'end if
      	end if
			end if
      if hover then function=gad
  
      gad=cast(Gadget ptr,gad->next_node)
    loop until (gad=0) or (hover>0)
 
  end if
end function


sub WindowInitialDraw (win as _sGUIWindow ptr)
  ClearBox win->DrawBuffer->img,0,0,win->WinWidth,win->WinHeight,Colors.BackGround
  if win->UserGFXBuffer then 
    if win->UserGFXBuffer->img then put win->DrawBuffer->img,(win->ContentOffsetX,win->ContentOffsetY),win->UserGFXBuffer->img,pset
  end if
end sub


sub KillWindow (win as _sGUIWindow ptr)
  dim as Gadget ptr childgad
  dim as sGUIWindow ptr  childwin
  dim as ListObject ptr owner
  
  'falls dieses Window selbst Childwindows hat
  'KillWindow fr jedes der Fenster in der WindowList rekursiv aufrufen
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      KillWindow(childwin)
      childwin=cast(sGUIWindow ptr,win->WindowList->GetFirst)'bei jedem Durchgang wird immer der erste Eintrag der WindowList wird entfernt
    loop until childwin=0
  end if
  'Die nun zwar leere WindowList selbst muss aber auch aus einer bergeordneten Liste entfernt werden
  'hier wre der owner eigentlich bekannt, eine WindowList eines Fensters wird immer in der globalen Liste "WindowLists" erzeugt(sGUI.bas)
  'WindowLists->DeleteNode(win->WindowList)' wre also der einfachste Weg
  'wir gehen aber ber den owner im geerbten node
  owner=win->WindowList->owner
  owner->DeleteNode(win->WindowList)
  
  'Grafikpuffer des Windows aus entsprechender Liste entfernen
  if win->DrawBuffer then
    owner=win->DrawBuffer->owner
    owner->DeleteNode(win->DrawBuffer)
  end if
  
  'UserGFXpuffer des Windows aus entsprechender Liste entfernen
  if win->UserGFXBuffer then
    owner=win->UserGFXBuffer->owner
    owner->DeleteNode(win->UserGFXBuffer)
  end if  
 
  'zum Schlu Fenster selbst aus entsprechender Liste entfernen
  owner=win->owner
  owner->DeleteNode(win)
end sub


sub KillGadget (gad as _Gadget ptr)
  dim as ListObject ptr owner
  'zuerst alle Objekte lschen die zwar von diesem Gadget benutzt, jedoch in einer entsprechenden Liste verwaltet werden
  
  'hat dieses Gadget ein Fenster?
  if gad->GadgetWindow then KillWindow(gad->GadgetWindow)' eigene Lschroutine, siehe hier drber :)
 
  'Grafikpuffer des Gadgets aus entsprechender Liste entfernen
  if gad->DrawBuffer then
    owner=gad->DrawBuffer->owner
    owner->DeleteNode(gad->DrawBuffer)
  end if
  
  'ist nicht freigegeben, aber dennoch...
  'UserGFXpuffer des Windows aus entsprechender Liste entfernen
  if gad->UserGFXBuffer then
    owner=gad->UserGFXBuffer->owner
    owner->DeleteNode(gad->UserGFXBuffer)
  end if 
  
  'TextObject des Gadgets aus entsprechender Liste entfernen
  if gad->TObject then
    owner=gad->TObject->owner
    owner->DeleteNode(gad->TObject)  
  end if
  
  'weitere Elemente???? hier einfgen
  '.....
  
  'zum Schlu Gadget selbst aus entsprechender Liste entfernen
  owner=gad->owner
  owner->DeleteNode(gad)
end sub

function EnableUserGFX (win as _sGUIWindow ptr=0) as FB.Image ptr
  function=0
  if win=0 then win=RootWindow
  if win->UserGFXBuffer=0 then win->UserGFXBuffer=ImageList->AppendNew(sGUIImageType)
  if (win->UserGFXBuffer<>0) and (win->UserGFXBuffer->img=0) then win->UserGFXBuffer->img=imagecreate(win->ContentWidth,win->ContentHeight,Colors.Cleaning,32) 
  if win->UserGFXBuffer->img then function=win->UserGFXBuffer->img
end function


